window.onload = function () {

//how it all works:

//1. Select box values change
//2. renderCurrentSelections gathers values from select boxes fires renderChartData
//3. renderChartData calls queries from the queries object and passes them to the DB. It also
//    passes a resultBinding callback function which takes the rows argument from the db results
//    This is all based on resultBindings and queries having the same name
//4. resultBinding handlers take the rows object and adapts it for use with canvas.js (that's your work)
//5. The chart is drawn.

//IMPORTANT: Set the Project <SELECT> option to "FEAST Demo Project"

    var gui = require('nw.gui');

    var execArgs = gui.App.argv;

    var fs = require('fs');
    var path = require('path');
    var sqlite3 = require('sqlite3');
    var path = require('path');

    var appRoot = path.dirname(process.execPath);

    var nwDir = path.normalize(appRoot + '/../../sqlite.db');

    var db = new sqlite3.Database(nwDir);
    
//These are for passing parameters from the main app to this one.
//These variable are also set when the form controls are changed.
    var argLen = execArgs.length;
    var query = execArgs[argLen - 3];
    var paramType = execArgs[argLen - 2];
    var paramVal = execArgs[argLen - 1];


//default is to run queries for the site.
    if (paramType === 'techfit') {
        $('#reports-feast').hide();
        $('#reports-techfit').show();
    } else {
        db.serialize(function () {
            db.all('SELECT  fg.id AS focus_group_id, fg.id_gender AS focus_group_gender, fg.venue_name AS focus_group_name, site.id AS site_id, site.name AS site_name, p.id AS project_id, p.title AS project_name FROM project p LEFT OUTER JOIN site ON site.id_project = p.id LEFT OUTER JOIN focus_group fg ON site.id = fg.id_site',
                    function (err, rows) {
                        var ddData = {projects: []};
                        rows.sort(function (a, b) {
                            var retVal = (a.project_name < b.project_name) ? -1 : 1;
                            return retVal;
                        });
                        var pidIndex = [];
                        var sidIndex = [];
                        var fidIndex = [];
                        rows.forEach(function (el) {
                            var pid = el.project_id;
                            var sid = el.site_id;
                            var fid = el.focus_group_id;
                            ddData[pid] = ddData[pid] || {project_name: el.project_name, sites: []};
                            ddData[pid][sid] = ddData[pid][sid] || {site_name: el.site_name, focusGroups: []};
                            if (pidIndex.indexOf(el.project_id) === -1) {
                                pidIndex.push(el.project_id);
                                ddData.projects.push({project_id: pid, project_name: el.project_name});
                            }

                            if (sidIndex.indexOf(el.site_id) === -1) {
                                sidIndex.push(el.site_id);
                                ddData[pid].sites.push({site_id: sid, site_name: el.site_name});
                            }

                            if (fidIndex.indexOf(el.focus_group_id) === -1) {
                                fidIndex.push(el.focus_group_id);
                                ddData[pid][sid].focusGroups.push({focus_group_id: fid, focus_group_name: el.focus_group_name, focus_group_gender: el.focus_group_gender});
                            }
                        });
                        console.log('DROPDOWN DATA');
                        console.log(ddData);
                        chartUi(ddData);
                    }

            );
        });

        /*db.on('profile', function(statement){
         console.log('CHANGE EVENT');// - STATEMENT FOLLOWS:');
         //console.log(statement);
         } );*/

        var queries = {
// Households by Landholding Category [COLUMN CHART]
            'households_by_landholding': {
                displayName: 'Households by Landholding Category',
                sortOrder: 1,
                query: function (param, groupParam, callback) {
                    /*     var statement = "SELECT landholding_category.description AS farm_size, COUNT(*) as number_of_households FROM respondent LEFT OUTER JOIN 		focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN landholding_category ON respondent.id_landholding_category = landholding_category.id WHERE " + param + " GROUP BY landholding_category.description ORDER BY landholding_category.description DESC";  */
                    var statement = "SELECT focus_group.percent_households_large as percent_farms_large, focus_group.percent_households_medium as percent_farms_medium, focus_group.percent_households_small as percent_farms_small, focus_group.threshold_small_farm_ha as small_threshold, focus_group.threshold_large_farm_ha as large_threshold FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project WHERE " + param + "";
                    fireStatement(statement, callback);

                }
            },
// Livestock Holdings - Average Headcount per Household by Animal Type and Farm Size [COLUMN CHART]
            'livestock_holdings_1': {
                displayName: 'Livestock Holdings 1 - Average Headcount per Household by Animal Type and Farm Size',
                sortOrder: 5,
                query: function (param, groupParam, callback) {
                    var statement = "WITH resp_by_category AS (SELECT respondent.id_landholding_category AS cat_landholding, COUNT(*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " GROUP BY respondent.id_landholding_category) SELECT landholding_category.description AS farm_size, animal_type.description AS type_of_animal, (TOTAL(livestock_holding.headcount)/resp_by_category.number_of) AS average_headcount FROM respondent LEFT OUTER JOIN resp_by_category ON resp_by_category.cat_landholding = respondent.id_landholding_category LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN landholding_category ON respondent.id_landholding_category = landholding_category.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type WHERE livestock_holding.headcount IS NOT NULL AND " + param + " GROUP BY animal_type.description, landholding_category.description  ORDER BY average_headcount DESC";

                    fireStatement(statement, callback);
                }
            },
// Livestock Holdings 2 - Average TLUs per Household by Animal Type [COLUMN CHART]
            'livestock_holdings_2': {
                sortOrder: 6,
                displayName: 'Livestock Holdings 2 - Average TLUs per Household by Animal Type',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT animal_type.description as type_of_animal, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND " + param + " GROUP BY animal_type.description  ORDER BY average_tlus DESC";

                    fireStatement(statement, callback);
                }
            },
// Livestock Holdings 3 - Average TLUs per Household by Animal Category [COLUMN CHART]
            'livestock_holdings_3': {
                sortOrder: 7,
                displayName: 'Livestock Holdings 3 - Average TLUs per Household by Animal Category',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT animal_category.description as category_of_animal, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND " + param + " GROUP BY animal_category.description ORDER BY average_tlus DESC";

                    fireStatement(statement, callback);
                }
            },
// Livestock Holdings 4 - Dominant Animal Categories by Average TLUs per Household [COLUMN CHART]
            'livestock_holdings_4': {
                sortOrder: 8,
                displayName: 'Livestock Holdings 4 - Dominant Animal Categories by Average TLUs per Household',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT animal_category.description as category_of_animal, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND " + param + " GROUP BY animal_category.description ORDER BY average_tlus DESC LIMIT 5";

                    fireStatement(statement, callback);
                }
            },
// Crop Cultivation 1- Average Hectares Cultivated per Household by Crop Type [COLUMN CHART]
            'crop_cultivation_1': {
                sortOrder: 11,
                displayName: 'Crop Cultivation 1- Average Hectares Cultivated per Household by Crop Type',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL AND " + param + " GROUP BY crop_type.name ORDER BY average_ha_per_hh DESC";

                    fireStatement(statement, callback);
                }
            },
// Crop Cultivation 2 - Dominant Crop Types by Average Hectares Cultivated per Household [COLUMN CHART]
            'crop_cultivation_2': {
                sortOrder: 12,
                displayName: 'Crop Cultivation 2 - Dominant Crop Types by Average Hectares Cultivated per Household',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL AND " + param + " GROUP BY crop_type.name ORDER BY average_ha_per_hh DESC LIMIT 5";

                    fireStatement(statement, callback);
                }
            },
// Fodder Crop Cultivation 1 - Average Hectares Cultivated per Household by Fodder Crop Type [COLUMN CHART]
            'fodder_cultivation_1': {
                sortOrder: 14,
                displayName: 'Fodder Crop Cultivation 1 - Average Hectares Cultivated per Household by Fodder Crop Type',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT fodder_crop_type.name as type_of_fodder_crop, (TOTAL(fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type LEFT OUTER JOIN unit_area on fodder_crop_cultivation.id_unit_area = unit_area.id WHERE fodder_crop_cultivation.cultivated_land IS NOT NULL AND " + param + " GROUP BY fodder_crop_type.name ORDER BY average_ha_per_hh DESC";

                    fireStatement(statement, callback);
                }
            },
// Fodder Crop Cultivation 2 - Dominant Fodder Crop Types by Average Hectares Cultivated per Household [COLUMN CHART]
            'fodder_crop_2': {
                sortOrder: 15,
                displayName: 'Fodder Crop Cultivation 2 - Dominant Fodder Crop Types by Average Hectares Cultivated per Household',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT fodder_crop_type.name as type_of_fodder_crop, (TOTAL(fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type LEFT OUTER JOIN unit_area on fodder_crop_cultivation.id_unit_area = unit_area.id WHERE fodder_crop_cultivation.cultivated_land IS NOT NULL AND " + param + " GROUP BY fodder_crop_type.name ORDER BY average_ha_per_hh DESC LIMIT 5";

                    fireStatement(statement, callback);
                }
            },
// Purchased Feed 1 - Average Kilograms Purchased per Household by Feed Type [COLUMN CHART]
            'purchased_feed_1': {
                sortOrder: 16,
                displayName: 'Purchased Feed 1 - Average Kilograms Purchased per Household by Feed Type',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT purchased_feed_type.name as type_of_feed, (TOTAL(purchased_feed.quantity_purchased * purchased_feed.purchases_per_year * unit_mass_weight.conversion_kg)/interview_respondents.number_of) as average_kg_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type LEFT OUTER JOIN unit_mass_weight on purchased_feed.id_unit_mass_weight = unit_mass_weight.id LEFT OUTER JOIN interview_respondents WHERE purchased_feed.quantity_purchased IS NOT NULL AND " + param + " GROUP BY purchased_feed_type.name ORDER BY average_kg_per_hh DESC";

                    fireStatement(statement, callback);
                }
            },
// Purchased Feed 2 - Dominant Purchased Feed Types by Average Kilograms Purchased per Household [COLUMN CHART]
            'purchased_feed_2': {
                sortOrder: 17,
                displayName: 'Purchased Feed 2 - Dominant Purchased Feed Types by Average Kilograms Purchased per Household',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT purchased_feed_type.name as type_of_feed, (TOTAL(purchased_feed.quantity_purchased * purchased_feed.purchases_per_year * unit_mass_weight.conversion_kg)/interview_respondents.number_of) as average_kg_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type LEFT OUTER JOIN unit_mass_weight on purchased_feed.id_unit_mass_weight = unit_mass_weight.id LEFT OUTER JOIN interview_respondents WHERE purchased_feed.quantity_purchased IS NOT NULL AND " + param + " GROUP BY purchased_feed_type.name ORDER BY average_kg_per_hh DESC LIMIT 5";

                    fireStatement(statement, callback);
                }
            },
// Animal Diet and Nutrition 1 - Dry Matter Intake by Source [PIE CHART]
            'animal_diet_1': {
                sortOrder: 20,
                displayName: 'Animal Diet and Nutrition 1 - Dry Matter Intake by Source',
                query: function (param, groupParam, callback) {
                    var statement = " WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site   ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id), crop_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0))) as dm_crop_residue,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_metabolisable_energy) as me_crop_residue,   TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_crude_protein * 0.01) as cp_crop_residue  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type            LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = crop_cultivation.id_unit_mass_weight  GROUP BY respondent.id),  fodder_stuff AS   (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0))) as dm_cultivated_fodder,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_metabolisable_energy) as me_cultivated_fodder,   TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_crude_protein * 0.01) as cp_cultivated_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  	   LEFT OUTER JOIN unit_area ON unit_area.id = fodder_crop_cultivation.id_unit_area  GROUP BY respondent.id),  purchased_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL(IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) as dm_purchased_feed,  TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_metabolisable_energy) as me_purchased_feed,   TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_crude_protein * 0.01) as cp_purchased_feed  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id   		 LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = purchased_feed.id_unit_mass_weight  GROUP BY respondent.id)   SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  (TOTAL(crop_stuff.dm_crop_residue) / interview_respondents.number_of) AS dm_crop_residue,  (TOTAL(crop_stuff.me_crop_residue) / interview_respondents.number_of) AS me_crop_residue,  (TOTAL(crop_stuff.cp_crop_residue) / interview_respondents.number_of) AS cp_crop_residue,  (TOTAL(fodder_stuff.dm_cultivated_fodder) / interview_respondents.number_of) AS dm_cultivated_fodder,  (TOTAL(fodder_stuff.me_cultivated_fodder) / interview_respondents.number_of) AS me_cultivated_fodder,  (TOTAL(fodder_stuff.cp_cultivated_fodder) / interview_respondents.number_of) AS cp_cultivated_fodder,  (TOTAL(purchased_stuff.dm_purchased_feed) / interview_respondents.number_of) AS dm_purchased_feed,  (TOTAL(purchased_stuff.me_purchased_feed) / interview_respondents.number_of) AS me_purchased_feed,  (TOTAL(purchased_stuff.cp_purchased_feed) / interview_respondents.number_of) AS cp_purchased_feed, (TOTAL((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of)  as dm_grazing, TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_grazing,  TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_metabolisable_energy) / interview_respondents.number_of) as me_grazing,  TOTAL(((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of) as dm_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_metabolisable_energy) / interview_respondents.number_of) as me_collected_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_stuff ON crop_stuff.respondent_id = respondent.id       LEFT OUTER JOIN fodder_stuff ON fodder_stuff.respondent_id = respondent.id  		 LEFT OUTER JOIN purchased_stuff ON purchased_stuff.respondent_id = respondent.id       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  LEFT OUTER JOIN interview_respondents WHERE " + param + " GROUP BY " + groupParam + "";
                    fireStatement(statement, callback);
                }
            },
            // Animal Diet and Nutrition 2 - Metabolisable Energy Intake by Source [PIE CHART]
            'animal_diet_2': {
                displayName: 'Animal Diet and Nutrition 2 - Metabolisable Energy Intake by Source',
                sortOrder: 21,
                query: function (param, groupParam, callback) {
                    var statement = " WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site   ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id), crop_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0))) as dm_crop_residue,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_metabolisable_energy) as me_crop_residue,   TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_crude_protein * 0.01) as cp_crop_residue  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type            LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = crop_cultivation.id_unit_mass_weight  GROUP BY respondent.id),  fodder_stuff AS   (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0))) as dm_cultivated_fodder,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_metabolisable_energy) as me_cultivated_fodder,   TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_crude_protein * 0.01) as cp_cultivated_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  	   LEFT OUTER JOIN unit_area ON unit_area.id = fodder_crop_cultivation.id_unit_area  GROUP BY respondent.id),  purchased_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL(IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) as dm_purchased_feed,  TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_metabolisable_energy) as me_purchased_feed,   TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_crude_protein * 0.01) as cp_purchased_feed  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id   		 LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = purchased_feed.id_unit_mass_weight  GROUP BY respondent.id)   SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  (TOTAL(crop_stuff.dm_crop_residue) / interview_respondents.number_of) AS dm_crop_residue,  (TOTAL(crop_stuff.me_crop_residue) / interview_respondents.number_of) AS me_crop_residue,  (TOTAL(crop_stuff.cp_crop_residue) / interview_respondents.number_of) AS cp_crop_residue,  (TOTAL(fodder_stuff.dm_cultivated_fodder) / interview_respondents.number_of) AS dm_cultivated_fodder,  (TOTAL(fodder_stuff.me_cultivated_fodder) / interview_respondents.number_of) AS me_cultivated_fodder,  (TOTAL(fodder_stuff.cp_cultivated_fodder) / interview_respondents.number_of) AS cp_cultivated_fodder,  (TOTAL(purchased_stuff.dm_purchased_feed) / interview_respondents.number_of) AS dm_purchased_feed,  (TOTAL(purchased_stuff.me_purchased_feed) / interview_respondents.number_of) AS me_purchased_feed,  (TOTAL(purchased_stuff.cp_purchased_feed) / interview_respondents.number_of) AS cp_purchased_feed, (TOTAL((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of)  as dm_grazing, TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_grazing,  TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_metabolisable_energy) / interview_respondents.number_of) as me_grazing,  TOTAL(((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of) as dm_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_metabolisable_energy) / interview_respondents.number_of) as me_collected_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_stuff ON crop_stuff.respondent_id = respondent.id       LEFT OUTER JOIN fodder_stuff ON fodder_stuff.respondent_id = respondent.id  		 LEFT OUTER JOIN purchased_stuff ON purchased_stuff.respondent_id = respondent.id       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  LEFT OUTER JOIN interview_respondents WHERE " + param + " GROUP BY " + groupParam + "";

                    fireStatement(statement, callback);
                }
            },
            // Animal Diet and Nutrition 3 - Crude Protein Intake by Source [PIE CHART]
            'animal_diet_3': {
                sortOrder: 22,
                displayName: 'Animal Diet and Nutrition 3 - Crude Protein Intake by Source',
                query: function (param, groupParam, callback) {
                    var statement = " WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site   ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id), crop_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0))) as dm_crop_residue,  TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_metabolisable_energy) as me_crop_residue,   TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_crude_protein * 0.01) as cp_crop_residue  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type            LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = crop_cultivation.id_unit_mass_weight  GROUP BY respondent.id),  fodder_stuff AS   (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0))) as dm_cultivated_fodder,  TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_metabolisable_energy) as me_cultivated_fodder,   TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_crude_protein * 0.01) as cp_cultivated_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id        LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  	   LEFT OUTER JOIN unit_area ON unit_area.id = fodder_crop_cultivation.id_unit_area  GROUP BY respondent.id),  purchased_stuff AS (SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  TOTAL(IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) as dm_purchased_feed,  TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_metabolisable_energy) as me_purchased_feed,   TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_crude_protein * 0.01) as cp_purchased_feed  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id   		 LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project       LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = purchased_feed.id_unit_mass_weight  GROUP BY respondent.id)   SELECT  project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,  (TOTAL(crop_stuff.dm_crop_residue) / interview_respondents.number_of) AS dm_crop_residue,  (TOTAL(crop_stuff.me_crop_residue) / interview_respondents.number_of) AS me_crop_residue,  (TOTAL(crop_stuff.cp_crop_residue) / interview_respondents.number_of) AS cp_crop_residue,  (TOTAL(fodder_stuff.dm_cultivated_fodder) / interview_respondents.number_of) AS dm_cultivated_fodder,  (TOTAL(fodder_stuff.me_cultivated_fodder) / interview_respondents.number_of) AS me_cultivated_fodder,  (TOTAL(fodder_stuff.cp_cultivated_fodder) / interview_respondents.number_of) AS cp_cultivated_fodder,  (TOTAL(purchased_stuff.dm_purchased_feed) / interview_respondents.number_of) AS dm_purchased_feed,  (TOTAL(purchased_stuff.me_purchased_feed) / interview_respondents.number_of) AS me_purchased_feed,  (TOTAL(purchased_stuff.cp_purchased_feed) / interview_respondents.number_of) AS cp_purchased_feed, (TOTAL((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of)  as dm_grazing, TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_grazing,  TOTAL((((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_metabolisable_energy) / interview_respondents.number_of) as me_grazing,  TOTAL(((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) / interview_respondents.number_of) as dm_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_crude_protein_percentage * 0.01) / interview_respondents.number_of) as cp_collected_fodder,  TOTAL((((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_metabolisable_energy) / interview_respondents.number_of) as me_collected_fodder  FROM respondent       LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group       LEFT OUTER JOIN crop_stuff ON crop_stuff.respondent_id = respondent.id       LEFT OUTER JOIN fodder_stuff ON fodder_stuff.respondent_id = respondent.id  		 LEFT OUTER JOIN purchased_stuff ON purchased_stuff.respondent_id = respondent.id       LEFT OUTER JOIN site ON focus_group.id_site = site.id   		 LEFT OUTER JOIN project ON project.id = site.id_project  LEFT OUTER JOIN interview_respondents WHERE " + param + " GROUP BY " + groupParam + "";

                    fireStatement(statement, callback);
                }
            },
            // Income Sources [PIE CHART]
            'income_sources': {
                sortOrder: 23,
                displayName: 'Major Sources of Income',
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT income_activity_category.description as income_category, TOTAL(COALESCE((income_activity.percent_of_hh_income * .01), 0)/interview_respondents.number_of) as average_percent FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category LEFT OUTER JOIN interview_respondents WHERE income_activity_type.description IS NOT NULL AND " + param + " GROUP BY income_activity_category.description";

                    fireStatement(statement, callback);
                }
            },        
// Monthly Rainfall and Feed Availability [STACKED COLUMN CHART WITH RAINFALL SERIES REPRESENTED AS A LINE - RAIN ON AN AXIS FROM 0 TO 5, OTHER SERIES ON AN AXIS FROM 0 TO 10]
            'monthly_rainfall': {
                displayName: 'Monthly Rainfall and Feed Availability',
                sortOrder: 27,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + "), " +
                            "feed_source_values AS (SELECT month.ordering as month_order, month.name as name_of_month, month.ordering as order_of_month, feed_source.description as resource_type, ((IFNULL(feed_source_availability.percentage, 0) * scale_zero_ten.number * 0.1)/interview_respondents.number_of) as numerical_value FROM respondent INNER JOIN feed_source_availability ON respondent.id = feed_source_availability.id_respondent INNER JOIN month ON month.id = feed_source_availability.id_month INNER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_respondent = respondent.id INNER JOIN scale_zero_ten ON respondent_monthly_statistics.id_scale_zero_ten = scale_zero_ten.id LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN focus_group_monthly_statistics ON focus_group_monthly_statistics.id_month = month.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN feed_source ON feed_source_availability.id_feed_source = feed_source.id LEFT OUTER JOIN interview_respondents WHERE respondent_monthly_statistics.id_month = feed_source_availability.id_month AND " + param + " GROUP BY respondent.id, month.id, feed_source.description ORDER BY month.ordering, feed_source.description) " +
                            "SELECT month.name AS name_of_month, month.ordering AS order_of_month, 'Rainfall' as resource_type, AVG(scale_zero_five.number) AS numerical_value FROM month LEFT OUTER JOIN focus_group_monthly_statistics ON focus_group_monthly_statistics.id_month = month.id LEFT OUTER JOIN focus_group ON focus_group.id = focus_group_monthly_statistics.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN scale_zero_five ON focus_group_monthly_statistics.id_scale_zero_five = scale_zero_five.id WHERE scale_zero_five.number IS NOT NULL AND " + param + " GROUP BY month.name " +
                            "UNION ALL " +
                            "SELECT feed_source_values.name_of_month AS name_of_month, feed_source_values.month_order AS order_of_month, feed_source_values.resource_type AS resource_type, TOTAL(feed_source_values.numerical_value) " +
                            "FROM feed_source_values GROUP BY feed_source_values.name_of_month, feed_source_values.resource_type " +
                            "ORDER BY month.ordering"

                    console.log(statement);

                    fireStatement(statement, callback);
                }
            },
// Daily Milk Yield versus Average Price Received  [LINE GRAPH - TWO DIFFERENT AXES FOR YIELD AND PRICE]
            'monthly_milk_yield': {
                sortOrder: 28,
                displayName: 'Daily Milk Yield versus Average Price Received',
                query: function (param, groupParam, callback) {
                    var statement = "SELECT month.name as month_name, month.ordering, AVG(respondent_monthly_statistics.milk_average_yield) as average_yield, AVG(respondent_monthly_statistics.milk_average_price_litre * currency.current_usd_exchange_rate) as average_price_litre_usd FROM month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent_monthly_statistics.milk_average_yield IS NOT NULL AND " + param + " GROUP BY focus_group.id, month.ordering ORDER BY month.ordering";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Monthly Market Prices for Livestock [LINE GRAPH - TWO DIFFERENT AXES FOR HEADCOUNT AND PRICE]
            'monthly_market_prices': {
                displayName: 'Monthly Market Prices',
                sortOrder: 29,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT month.name as month_name, month.ordering, (AVG(respondent_monthly_statistics.market_price_cattle) * currency.current_usd_exchange_rate) as price_head_cattle_usd, (AVG(respondent_monthly_statistics.market_price_sheep) * currency.current_usd_exchange_rate) as price_head_sheep_usd, (AVG(respondent_monthly_statistics.market_price_goat) * currency.current_usd_exchange_rate) as price_head_goat_usd FROM month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE (respondent_monthly_statistics.market_price_cattle IS NOT NULL OR respondent_monthly_statistics.market_price_goat IS NOT NULL OR respondent_monthly_statistics.market_price_sheep IS NOT NULL) AND " + param + " GROUP BY focus_group.id, month.ordering ORDER BY month.ordering";

                    fireStatement(statement, callback);
                }
            },
            // Gender Pay Equality [COLUMN CHART]
            'gender_pay_equality': {
                displayName: 'Gender Pay Equality',
                sortOrder: 31,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT (AVG(labour_activity.daily_rate_female) * currency.current_usd_exchange_rate) as avg_pay_female, (AVG(labour_activity.daily_rate_male) * currency.current_usd_exchange_rate) as avg_pay_male FROM focus_group LEFT OUTER JOIN labour_activity ON focus_group.id = labour_activity.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE labour_activity.daily_rate_female IS NOT NULL AND labour_activity.daily_rate_male IS NOT NULL AND " + param + " GROUP BY focus_group.id";

                    fireStatement(statement, callback);
                }
            },
            // Coop membership by gender [COLUMN CHART]
            'coop_by_gender': {
                displayName: 'Coop/Farmer Organization Memberships by Gender',
                sortOrder: 4,
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT TOTAL(coop_membership.membership_count_male) AS total_male, TOTAL(coop_membership.membership_count_female) AS total_female FROM coop_membership LEFT JOIN respondent ON respondent.id = coop_membership.id_respondent  LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project " +
                        "WHERE focus_group.id_gender IS NOT NULL AND " + param + " GROUP BY " + groupParam;

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },                   
            // Farm Size by gender [COLUMN CHART]
            'farm_size_by_gender': {
                displayName: 'Farm Size by Gender of Household Head',
                sortOrder: 2,
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT respondent.id_landholding_category, respondent.id_gender, respondent.id_gender1, AVG(respondent.land_under_control * unit_area.conversion_ha) AS avg_land FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN unit_area on respondent.id_unit_area = unit_area.id " +
                        "WHERE focus_group.id_gender IS NOT NULL AND " + param + " GROUP BY respondent.id_gender1, respondent.id_landholding_category, " + groupParam;

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },                   
            // Land ownership by gender [COLUMN CHART] ("WITH" and TOTAL works better with potential null data than AVG
            'land_ownership_by_gender': {
                displayName: 'Land Ownership by Gender',
                sortOrder: 3,
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id_gender IS NOT NULL AND " + param + " ORDER BY respondent.id) " +
                            "SELECT (TOTAL(respondent.land_ownership_joint * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_joint, (TOTAL(respondent.land_ownership_male * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_male, (TOTAL(respondent.land_ownership_female * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_female FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN unit_area on respondent.id_unit_area = unit_area.id  LEFT OUTER JOIN interview_respondents WHERE focus_group.id_gender IS NOT NULL AND " + param + " GROUP BY " + groupParam;
//                    "SELECT AVG(respondent.land_ownership_joint * unit_area.conversion_ha) AS avg_joint, AVG(respondent.land_ownership_male * unit_area.conversion_ha) AS avg_male, AVG(respondent.land_ownership_female * unit_area.conversion_ha) AS avg_female FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN unit_area on respondent.id_unit_area = unit_area.id  LEFT OUTER JOIN interview_respondents WHERE focus_group.id_gender IS NOT NULL AND " + param + " GROUP BY " + groupParam;

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Livestock Holdings 5 - Dominant Animal Categories by Average TLUs per Household by Gender of HH Head [COLUMN CHART]
            'livestock_holdings_5': {
                displayName: 'Livestock Holdings 5 - Dominant Livestock Categories in TLUs by Gender of Household Head (Up to 5)',
                gendered: true,
                sortOrder: 9,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id)," +
                        " top_categories AS (SELECT animal_category.id as category_id, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND " + param + " GROUP BY animal_category.description ORDER BY average_tlus DESC LIMIT 5) " +
                        " SELECT respondent.id_gender1, animal_category.description as category_of_animal, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND animal_category.id IN (SELECT category_id FROM top_categories) AND " + param + " GROUP BY animal_category.description, respondent.id_gender1 ORDER BY average_tlus DESC" ;

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Crop Cultivation 3 - Dominant Crop Types by Average Hectares Cultivated per Household by Gender of HH Head [COLUMN CHART]
            'crop_cultivation_3': {
                sortOrder: 13,
                displayName: 'Crop Cultivation 3 - Dominant Crop Types in Average Hectares Cultivated by Gender of Household Head (Up to 5)',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id)," +
                            "top_categories AS (SELECT crop_type.id as category_id, crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL AND " + param + " GROUP BY crop_type.name ORDER BY average_ha_per_hh DESC LIMIT 5) " +
                            "SELECT respondent.id_gender1, crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL AND crop_type.id IN (SELECT category_id FROM top_categories) AND " + param + " GROUP BY crop_type.name, respondent.id_gender1 ORDER BY average_ha_per_hh DESC";

                    fireStatement(statement, callback);
                }
            },  
// Roles of men, women, and children in feed production, harvesting, and feeding            
            'feed_labor_division': {
                sortOrder: 19,
                displayName: 'Gender Division of Labour in Feed Production, Harvesting and Feeding',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT COUNT(*) AS labor_total, feed_labor_type.description AS labor_type, respondent.id, feed_labor_division.id_labor_division_group " +
                                    "FROM feed_labor_division " +
                                    "LEFT OUTER JOIN respondent ON feed_labor_division.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " +
                                    "LEFT OUTER JOIN feed_labor_type ON feed_labor_type.id = feed_labor_division.id_feed_labor_type " +
                                    "WHERE  focus_group.id_gender IS NOT NULL AND feed_labor_division.id_labor_division_group IS NOT NULL AND " + param + " " +
                                    "GROUP BY feed_labor_division.id_feed_labor_type, feed_labor_division.id_labor_division_group";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Gender Roles In Decision Making: Crop and Feed
            'gender_decision_feed': {
                sortOrder: 18,
                displayName: 'Gendered Decision Making on Crop and Feeding',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group " +
                                    "FROM decision_making_by_household " +
                                    "LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " +
                                    "LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision " +
                                    "WHERE focus_group.id_gender IS NOT NULL AND decision.id_decision_type IN (2,3,4) AND decision_making_by_household.id_gender_group IS NOT NULL AND " + param + " " +
                                    "GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Gender Roles In Decision Making: Livestock Husbandry
            'gender_decision_livestock': {
                sortOrder: 10,
                displayName: 'Gendered Decision Making on Livestock',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group " +
                                    "FROM decision_making_by_household " +
                                    "LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " +
                                    "LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision " +
                                    "WHERE  focus_group.id_gender IS NOT NULL AND decision.id_decision_type IN (1) AND decision_making_by_household.id_gender_group IS NOT NULL AND " + param + " " +
                                    "GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Gender Roles In Decision Making: Sales
            'gender_decision_sales': {
                sortOrder: 30,
                displayName: 'Gendered Decision Making on Sales of Livestock and Milk',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group " +
                                    "FROM decision_making_by_household " +
                                    "LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " +
                                    "LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision " +
                                    "WHERE focus_group.id_gender IS NOT NULL AND decision.id_decision_type IN (5) AND decision_making_by_household.id_gender_group IS NOT NULL AND " + param + " " +
                                    "GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },
// Women's Income Sources [PIE CHART]
            'womens_income_sources': {
                sortOrder: 24,
                displayName: 'Major Sources of Income for Women',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE " + param + " ORDER BY respondent.id) SELECT income_activity_category.description as income_category, TOTAL(COALESCE((womens_income_activity.pct_womens_income * .01), 0)/interview_respondents.number_of) as average_percent FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN womens_income_activity ON womens_income_activity.id_respondent = respondent.id LEFT OUTER JOIN income_activity_type ON income_activity_type.id = womens_income_activity.id_income_activity_type LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category LEFT OUTER JOIN interview_respondents WHERE income_activity_type.description IS NOT NULL AND " + param + " GROUP BY income_activity_category.description";

                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },   
            'gender_decision_income': {
                sortOrder: 25,
                displayName: 'Gendered Decision Making on Major Sources of Household Income',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "SELECT income_activity_type.id, income_activity_type.description as income_category, income_activity.id_gender_group, count(income_activity.id_gender_group) as gender_total " + 
                            "FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  " +
                            "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                            "LEFT OUTER JOIN project ON project.id = site.id_project " +
                            "LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id " +
                            "LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type " +
                            "WHERE income_activity_type.description IS NOT NULL AND focus_group.id_gender IS NOT NULL AND " + param + " " +
                            "GROUP BY income_activity.id_income_activity_type, income_activity.id_gender_group";
                    
                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },   
            'gender_income_sources': {
                sortOrder: 26,
                displayName: 'Relative Contribution of Major Sources of Income to Household and Women\'s Income',
                gendered: true,
                query: function (param, groupParam, callback) {
                    var statement = "WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent " +
                                    "LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id_gender IS NOT NULL AND " + param + " ORDER BY respondent.id) " +
                                    "SELECT income_category, TOTAL(average_percent_hh) AS avg_percent_hh, TOTAL(average_percent_women) as avg_percent_women FROM (SELECT income_activity_type.description as income_category, " +
                                    "0 as average_percent_hh, " +
                                    "TOTAL(COALESCE((womens_income_activity.pct_womens_income * .01), 0)/interview_respondents.number_of) as average_percent_women " +
                                    "FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " + 
                                    "LEFT OUTER JOIN womens_income_activity ON womens_income_activity.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN income_activity_type ON income_activity_type.id = womens_income_activity.id_income_activity_type " +
                                    "LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category " +
                                    "LEFT OUTER JOIN interview_respondents " +
                                    "WHERE income_activity_type.description IS NOT NULL AND " + param + "  " +
                                    "GROUP BY income_activity_type.description " +
                                    "UNION ALL " +
                                    "SELECT income_activity_type.description as income_category, " +
                                    "TOTAL(COALESCE((income_activity.percent_of_hh_income* .01), 0)/interview_respondents.number_of) as average_percent_hh, " +
                                    "0 as average_percent_women " +
                                    "FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  " +
                                    "LEFT OUTER JOIN site ON site.id = focus_group.id_site " +
                                    "LEFT OUTER JOIN project ON project.id = site.id_project " +
                                    "LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id " +
                                    "LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type " +
                                    "LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category " +
                                    "LEFT OUTER JOIN interview_respondents " +
                                    "WHERE focus_group.id_gender IS NOT NULL AND income_activity_type.description IS NOT NULL AND " + param + " " +
                                    "GROUP BY income_activity_type.description) GROUP BY income_category ";
                    
                    console.log(statement);
                    fireStatement(statement, callback);
                }
            },   
            
            
     

// Key Statistics [NOT FINISHED - WILL SEND LATER]
            /*   'key_statistics':{
             displayName:'Key Statistics',
             
             query:function(param, groupParam, callback){
             var statement = "WITH offtake_cattle AS (SELECT ((livestock_sale.number_sold * 1.0 * livestock_sale.approximate_weight)/250)) AS tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN livestock_sale ON livestock_sale.id_respondent = respondent.id LEFT OUTER JOIN livestock_sale_category ON livestock_sale.id_livestock_sale_category = livestock_sale_category.id LEFT OUTER JOIN animal_species ON livestock_sale_category.id_animal_species = animal_species.id WHERE livestock_sale.number_sold IS NOT NULL AND animal_species.description = 'Cattle' AND [[[ATTRIBUTES]]]) GROUP BY animal_species.description, gender.description), " +
             
             "offtake_shoat AS (SELECT ((livestock_sale.number_sold * livestock_sale.approximate_weight)/250)) AS tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN livestock_sale ON livestock_sale.id_respondent = respondent.id LEFT OUTER JOIN livestock_sale_category ON livestock_sale.id_livestock_sale_category = livestock_sale_category.id LEFT OUTER JOIN animal_species ON livestock_sale_category.id_animal_species = animal_species.id WHERE livestock_sale.number_sold IS NOT NULL AND animal_species.description = 'Sheep' OR 'Goat' AND [[[ATTRIBUTES]]]) GROUP BY animal_species.description, gender.description), " +
             "income_milk AS (SELECT TOTAL(month.days * (respondent_monthly_statistics.milk_average_yield - respondent_monthly_statistics.milk_retained_for_household) * respondent_monthly_statistics.milk_average_price_litre) as sales_local_currency LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent_monthly_statistics.milk_average_yield IS NOT NULL AND " + param + " GROUP BY " + groupParam + ")" +
             "cattle_data AS (SELECT (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250)) AS tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species WHERE livestock_holding.headcount IS NOT NULL AND animal_species.description = 'Cattle' AND " + param + " GROUP BY animal_category.description)" +
             "shoat_data AS (SELECT (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250)) AS tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species WHERE livestock_holding.headcount IS NOT NULL AND animal_species.description = ('Sheep' OR 'Goat') AND " + param + " GROUP BY animal_category.description)" +
             "SELECT ((offtake_cattle.tlus/(offtake_cattle.tlus + cattle_data.tlus))*100) as percent_cattle_offtake FROM cattle_data LEFT OUTER JOIN offtake_cattle" 
             
             SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, month.name as month_name, month.ordering, month.days, AVG(respondent_monthly_statistics.milk_average_yield) as average_yield, AVG(respondent_monthly_statistics.milk_retained_for_household) as average_retained, AVG(respondent_monthly_statistics.milk_average_price_litre * currency.current_usd_exchange_rate) as price_litre_milk_usd, TOTAL(month.days * (respondent_monthly_statistics.milk_average_yield - respondent_monthly_statistics.milk_retained_for_household) * respondent_monthly_statistics.milk_average_price_litre * currency.current_usd_exchange_rate) as sales FROM month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent_monthly_statistics.milk_average_yield IS NOT NULL '+report_export_filter_short+'GROUP BY focus_group.id, month.ordering', Results);
             
             
             SELECT  as  FROM respondent  LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN gender ON gender.id = livestock_sale_category.id_gender LEFT OUTER JOIN animal_species ON livestock_sale_category.id_animal_species = animal_species.id WHERE livestock_sale.number_sold IS NOT NULL '+report_export_filter_short+'GROUP BY animal_species.description, gender.description'
             
             /*query_name:{
             displayName:'Query',
             
             query:function(param, groupParam, callback){
             var statement = "' + buildFilter(param) +' <more sql here>';
             param = buildFilter(param);
             if(groupParam){ groupParam = buildGroupFilter(groupParam); }
             fireStatement(statement, callback);
             }
             } */

        };

        $('#reports-feast').show();
        $('#reports-techfit').hide();
        if (paramType === 'byFocusGroup') {
            $('#btn_by_group').addClass('active');
        } else {
            $('#btn_by_site').addClass('active');
        }
    }

//These are the handlers for the query results.
//Rows is from the DB
    var resultBindings = {
        gender_income_sources: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var incomeTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var decisionType = rows[i].income_category;
                if ($.inArray(decisionType, incomeTypeList) < 0) {
                    incomeTypeList.push(decisionType);
                }
            }
            
            var resultData = [];
            for (var j = 0; j < incomeTypeList.length; j++) {
                resultData.push({
                    type: "stackedBar100",
                    legendText: incomeTypeList[j],
                    showInLegend: true,
                    dataPoints: [
                        { 
                            label: "% of Household Income",
                            y: 0
                        },
                        { 
                            label: "% of Women's Income",
                            y: 0
                        }
                    ]
                });
            }
            
            if (resultData.length == 0) {
                resultData.push({
                    type: "stackedBar100",
                    legendText: "No Data",
                    showInLegend: true,
                    dataPoints: []
                });
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < resultData.length; x++) {
                    if (rows[i].income_category == resultData[x].legendText) {
                        var dataArray = resultData[x].dataPoints;

                        dataArray[0].y = rows[i].avg_percent_hh;
                        dataArray[0].toolTipContent = rows[i].income_category + ": " + rows[i].avg_percent_hh;
                        
                        dataArray[1].y = rows[i].avg_percent_women;
                        dataArray[1].toolTipContent = rows[i].income_category + ": " + rows[i].avg_percent_women;
                    }
                }
            }            
            
            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Relative Contribution of Major Sources of Income to Household and Women\'s Income',
                },
                animationEnabled: true,
                axisY: {
                    title: "Contribution in %",
                    titleFontSize: 16
                },
                data: resultData
            };


            renderChart('gender_income_sources', dataObj);
        },                      
        gender_decision_income: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var decisionTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var decisionType = rows[i].income_category;
                if ($.inArray(decisionType, decisionTypeList) < 0) {
                    decisionTypeList.push(decisionType);
                }
            }
            
            var resultData = [];
            for (var j = 0; j < decisionTypeList.length; j++) {
                resultData.push({
                    type: "stackedColumn",
                    legendText: decisionTypeList[j],
                    showInLegend: true,
                    dataPoints: [
                        { 
                            label: "Men Decide Alone",
                            y: 0
                        },
                        { 
                            label: "Women Decide Alone",
                            y: 0
                        },
                        { 
                            label: "Joint Decision Making",
                            y: 0
                        }
                    ]
                });
            }
            
            if (resultData.length == 0) {
                resultData.push({
                    type: "stackedColumn",
                    legendText: "No Data",
                    showInLegend: true,
                    dataPoints: []
                });
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < resultData.length; x++) {
                    if (rows[i].income_category == resultData[x].legendText) {
                        var dataArray = resultData[x].dataPoints;

                        dataArray[rows[i].id_gender_group - 1].y = rows[i].gender_total;
                        dataArray[rows[i].id_gender_group - 1].toolTipContent = rows[i].income_category + ": " + rows[i].gender_total;
                    }
                }
            }            
            
            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Gendered Decision Making on Major Sources of Household Income',
                },
                animationEnabled: true,
                axisY: {
                    title: "Count",
                    titleFontSize: 16
                },
                data: resultData
            };


            renderChart('gender_decision_income', dataObj);
        },                                
// Gender Roles In Decision Making: Sales        
        gender_decision_sales: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var decisionTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var decisionType = rows[i].decision_type;
                if ($.inArray(decisionType, decisionTypeList) < 0) {
                    decisionTypeList.push(decisionType);
                }
            }
            
            var dataPointsMale = [];
            var dataPointsFemale = [];
            var dataPointsJoint = [];
            var dataPointsNA = [];
            for (var j = 0; j < decisionTypeList.length; j++) {
                dataPointsMale.push({label: decisionTypeList[j], y: 0});
                dataPointsFemale.push({label: decisionTypeList[j], y: 0});
                dataPointsJoint.push({label: decisionTypeList[j], y: 0});
                dataPointsNA.push({label: decisionTypeList[j], y: 0});
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < decisionTypeList.length; x++) {
                    if (rows[i].decision_type == decisionTypeList[x]) {
                        var dataArray = dataPointsJoint;
                        switch(rows[i].id_gender_group) {
                            case 2:
                                dataArray = dataPointsMale;
                                break;
                            case 3:
                                dataArray = dataPointsFemale;
                                break;
                            case 1:
                                dataArray = dataPointsJoint;
                                break;
                            case 4:
                                dataArray = dataPointsNA;
                                break;
                        }

                        dataArray[x] = {
                            label: rows[i].decision_type,
                            y: rows[i].decision_total
                        };
                    }
                }
            }            

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Gendered Decision Making on Sales of Livestock and Milk',
                },
                animationEnabled: true,
                axisY: {
                    title: "Count",
                    titleFontSize: 16
                },
                data: [{
                    type: "stackedColumn",
                    legendText: "Men Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsMale
                },{
                    type: "stackedColumn",
                    legendText: "Women Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsFemale
                },{
                    type: "stackedColumn",
                    legendText: "Joint Decision Making",
                    showInLegend: true,
                    dataPoints: dataPointsJoint
                }]
            };


            renderChart('gender_decision_sales', dataObj);
        },                        
// Gender Roles In Decision Making: Livestock Husbandry        
        gender_decision_livestock: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var decisionTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var decisionType = rows[i].decision_type;
                if ($.inArray(decisionType, decisionTypeList) < 0) {
                    decisionTypeList.push(decisionType);
                }
            }
            
            var dataPointsMale = [];
            var dataPointsFemale = [];
            var dataPointsJoint = [];
            var dataPointsNA = [];
            for (var j = 0; j < decisionTypeList.length; j++) {
                dataPointsMale.push({label: decisionTypeList[j], y: 0});
                dataPointsFemale.push({label: decisionTypeList[j], y: 0});
                dataPointsJoint.push({label: decisionTypeList[j], y: 0});
                dataPointsNA.push({label: decisionTypeList[j], y: 0});
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < decisionTypeList.length; x++) {
                    if (rows[i].decision_type == decisionTypeList[x]) {
                        var dataArray = dataPointsJoint;
                        switch(rows[i].id_gender_group) {
                            case 2:
                                dataArray = dataPointsMale;
                                break;
                            case 3:
                                dataArray = dataPointsFemale;
                                break;
                            case 1:
                                dataArray = dataPointsJoint;
                                break;
                            case 4:
                                dataArray = dataPointsNA;
                                break;
                        }

                        dataArray[x] = {
                            label: rows[i].decision_type,
                            y: rows[i].decision_total
                        };
                    }
                }
            }            

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Gendered Decision Making on Livestock',
                },
                animationEnabled: true,
                axisY: {
                    title: "Count",
                    titleFontSize: 16
                },
                data: [{
                    type: "stackedColumn",
                    legendText: "Men Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsMale
                },{
                    type: "stackedColumn",
                    legendText: "Women Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsFemale
                },{
                    type: "stackedColumn",
                    legendText: "Joint Decision Making",
                    showInLegend: true,
                    dataPoints: dataPointsJoint
                }]
            };


            renderChart('gender_decision_livestock', dataObj);
        },                
// Gender Roles In Decision Making: Crop and Feed
        gender_decision_feed: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var decisionTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var decisionType = rows[i].decision_type;
                if ($.inArray(decisionType, decisionTypeList) < 0) {
                    decisionTypeList.push(decisionType);
                }
            }
            
            var dataPointsMale = [];
            var dataPointsFemale = [];
            var dataPointsJoint = [];
            var dataPointsNA = [];
            for (var j = 0; j < decisionTypeList.length; j++) {
                dataPointsMale.push({label: decisionTypeList[j], y: 0});
                dataPointsFemale.push({label: decisionTypeList[j], y: 0});
                dataPointsJoint.push({label: decisionTypeList[j], y: 0});
                dataPointsNA.push({label: decisionTypeList[j], y: 0});
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < decisionTypeList.length; x++) {
                    if (rows[i].decision_type == decisionTypeList[x]) {
                        var dataArray = dataPointsJoint;
                        switch(rows[i].id_gender_group) {
                            case 2:
                                dataArray = dataPointsMale;
                                break;
                            case 3:
                                dataArray = dataPointsFemale;
                                break;
                            case 1:
                                dataArray = dataPointsJoint;
                                break;
                            case 4:
                                dataArray = dataPointsNA;
                                break;
                        }

                        dataArray[x] = {
                            label: rows[i].decision_type,
                            y: rows[i].decision_total
                        };
                    }
                }
            }            

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Gendered Decision Making on Crops and Feeding',
                },
                animationEnabled: true,
                axisY: {
                    title: "Count",
                    titleFontSize: 16
                },
                data: [{
                    type: "stackedColumn",
                    legendText: "Men Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsMale
                },{
                    type: "stackedColumn",
                    legendText: "Women Decide Alone",
                    showInLegend: true,
                    dataPoints: dataPointsFemale
                },{
                    type: "stackedColumn",
                    legendText: "Joint Decision Making",
                    showInLegend: true,
                    dataPoints: dataPointsJoint
                }]
            };


            renderChart('gender_decision_feed', dataObj);

        },        
// Feed Labor Division - Roles of men, women, and children in feed production, harvesting, and feeding
        feed_labor_division: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var laborTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var laborType = rows[i].labor_type;
                if ($.inArray(laborType, laborTypeList) < 0) {
                    laborTypeList.push(laborType);
                }
            }
            
            var dataPointsMale = [];
            var dataPointsFemale = [];
            var dataPointsChildren = [];
            var dataPointsNA = [];
            for (var j = 0; j < laborTypeList.length; j++) {
                dataPointsMale.push({label: laborTypeList[j], y: 0});
                dataPointsFemale.push({label: laborTypeList[j], y: 0});
                dataPointsChildren.push({label: laborTypeList[j], y: 0});
                dataPointsNA.push({label: laborTypeList[j], y: 0});
            }
            
            for (var i = 0; i < rows.length; i++) {
                for (var x = 0; x < laborTypeList.length; x++) {
                    if (rows[i].labor_type == laborTypeList[x]) {
                        var dataArray = dataPointsChildren;
                        switch(rows[i].id_labor_division_group) {
                            case 1:
                                dataArray = dataPointsMale;
                                break;
                            case 2:
                                dataArray = dataPointsFemale;
                                break;
                            case 3:
                                dataArray = dataPointsChildren;
                                break;
                            case 4:
                                dataArray = dataPointsNA;
                                break;
                        }

                        dataArray[x] = {
                            label: rows[i].labor_type,
                            y: rows[i].labor_total
                        };
                    }
                }
            }            

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: 'Gender Division of Labour in Feed Production, Harvesting and Feeding',
                },
                animationEnabled: true,
                axisY: {
                    title: "Count",
                    titleFontSize: 16
                },
                data: [{
                    type: "stackedColumn",
                    legendText: "Men",
                    showInLegend: true,
                    dataPoints: dataPointsMale
                },{
                    type: "stackedColumn",
                    legendText: "Women",
                    showInLegend: true,
                    dataPoints: dataPointsFemale
                },{
                    type: "stackedColumn",
                    legendText: "Children & Youth",
                    showInLegend: true,
                    dataPoints: dataPointsChildren
                }]
            };


            renderChart('feed_labor_division', dataObj);

        },
        coop_by_gender: function (err, rows) {

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            if (rows.length > 0) {
                dataPointsArray.push({
                    label: "Male household members",
                    y: rows[0].total_male
                });

                dataPointsArray.push({
                    label: "Female household members",
                    y: rows[0].total_female
                });
            }

            /** Create data object */
            var dataObj = {
                theme: "theme2", //theme1
                colorType: 'single',
                animationEnabled: true,
                title: {
                    text: 'Coop/Farmer Organization Memberships by Gender',
                },
                axisY: {
                    title: "Number of Memberships"
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                color: "#80FF80",
                                dataPoints: dataPointsArray
                            }]
            };

            renderChart('households_by_landholding', dataObj);

        },        
        farm_size_by_gender: function (err, rows) {

            /** CREATE DATA POINTS */
            var dataPointsArrayMale = [{label: "Small Farm", y: 0},{label: "Medium Farm", y: 0},{label: "Large Farm", y: 0}];
            var dataPointsArrayFemale = [{label: "Small Farm", y: 0},{label: "Medium Farm", y: 0},{label: "Large Farm", y: 0}];

            for (var i = 0; i < rows.length; i++) {
                var dataArray = rows[i].id_gender1 === 1 ? dataPointsArrayFemale : dataPointsArrayMale;
                switch(rows[i].id_landholding_category) {
                    case 1:
                    case 2:
                        dataArray[0].y += rows[i].avg_land;
                        break;
                    case 3:
                        dataArray[1].y += rows[i].avg_land;
                        break;
                    case 4:
                        dataArray[2].y += rows[i].avg_land;
                        break;
                }
            }

            /** Create data object */
            var dataObj = {
                theme: "theme2", //theme1
                colorType: 'alternating',
                animationEnabled: true,
                title: {
                    text: "Farm Size by Gender of Household Head"
                },
                axisY: {
                    title: "Area (Hectares)"
                },
                animationEnabled: true,
                data: [{
                    type: "column",
                    name: "Male-headed Households",
                    legendText: "Male-headed Households",
                    showInLegend: true,
                    color: "#CC3300",
                    dataPoints: dataPointsArrayMale
                }, {
                    type: "column",
                    name: "Female-headed Households",
                    legendText: "Female-headed Households",
                    showInLegend: true,
                    color: "#47B56C",
                    dataPoints: dataPointsArrayFemale
                }]
            }

            renderChart('farm_size_by_gender', dataObj);

        },
        households_by_landholding: function (err, rows) {

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            // for (var i = 0; i < rows.length; i++) {
            //     dataPointsArray.push({
            //             label: rows[i].farm_size,
            //             y:rows[i].number_of_households
            //     });
            // };
            // 
            
            

            dataPointsArray.push({
                label: "Small Farms",
                y: rows[0].percent_farms_small
            });

            dataPointsArray.push({
                label: "Medium Farms",
                y: rows[0].percent_farms_medium
            });
            
            dataPointsArray.push({
                label: "Large Farms",
                y: rows[0].percent_farms_large
            });

            /** Create data object */
            var dataObj = {
                theme: "theme2", //theme1
                colorType: 'single',
                animationEnabled: true,
                title: {
                    text: "Households by Landholding Category"
                },
                axisY: {
                    title: "Percentage"
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                color: "#80FF80",
                                legendText: "Landholding Category",
                                dataPoints: dataPointsArray
                            }]
            };

            renderChart('households_by_landholding', dataObj);

        },
        // Livestock Holdings - Average Headcount per Household by Animal Type and Farm Size [COLUMN CHART]
        livestock_holdings_1: function (err, rows) {

            var holdingsData = [
                {
                    type: "column",
                    name: "Large Farm",
                    legendText: "Large Farm",
                    showInLegend: true,
                    color: "#CC3300",
                    dataPoints: []
                }, {
                    type: "column",
                    name: "Medium Farm",
                    legendText: "Medium Farm",
                    showInLegend: true,
                    color: "#FFCC00",
                    dataPoints: []
                }, {
                    type: "column",
                    name: "Small Farm",
                    legendText: "Small Farm",
                    showInLegend: true,
                    color: "#47B56C",
                    dataPoints: []
                }
            ];

            /** CREATE DATA ARRAY HERE */
            var animalTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                // Each holdingsData[i].datapoints = type of animal
                // get list of all animal types, then for each type, get list of holding counts for large, medium, small    
                var animalType = rows[i].type_of_animal;
                animalTypeList.push(animalType);
            }

            var animalArray = {};

            for (var i = 0; i < rows.length; i++) {
                var animalType = rows[i].type_of_animal;
                if (animalArray[animalType] == null) {
                    animalArray[animalType] = [0, 0, 0];
                }
                switch (rows[i].farm_size) {
                    case "Large Farm":
                        animalArray[animalType][0] = rows[i].average_headcount;
                        break;
                    case "Medium Farm":
                        animalArray[animalType][1] = rows[i].average_headcount;
                        break;
                    case "Small Farm":
                        animalArray[animalType][2] = rows[i].average_headcount;
                        break;
                    default:
                        break;
                }
            }
            for (var typeLabel in animalArray) {
                var thisAnimalType = animalArray[typeLabel];
                holdingsData[0].dataPoints.push({label: typeLabel, y: thisAnimalType[0]});
                holdingsData[1].dataPoints.push({label: typeLabel, y: thisAnimalType[1]});
                holdingsData[2].dataPoints.push({label: typeLabel, y: thisAnimalType[2]});
            }


            var dataObj = {
                theme: "theme2",
                animationEnabled: true,
                title: {
                    text: "Average Livestock Holdings per Household by Farm Size (Headcount)",
                    fontSize: 30
                },
                colorType: 'alternating',
                toolTip: {
                    shared: true
                },
                axisY: {
                    title: "Headcount"
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelAutoFit: false,
                    labelAngle: -45,
                    labelWrap: false,
                },
                legend: {
                    verticalAlign: "top",
                    horizontalAlign: "center"
                },
                data: holdingsData,
                legend: {
                    cursor: "pointer",
                    itemclick: function (e) {
                        if (typeof (e.dataSeries.visible) === "undefined" || e.dataSeries.visible) {
                            e.dataSeries.visible = false;
                        } else {
                            e.dataSeries.visible = true;
                        }
                        chart.render();
                    }
                }
            }

            renderChart('livestock_holdings_1', dataObj);
        },
        // Livestock Holdings 2 - Average TLUs per Household by Animal Type [COLUMN CHART]
        livestock_holdings_2: function (err, rows) {
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_animal,
                    y: rows[i].average_tlus
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                theme: "theme2", //theme1
                colorType: 'single',
                title: {
                    text: "Average Household Livestock Holdings by Type in Tropical Livestock Units (TLUs)"
                },
                axisY: {
                    title: "TLUs"
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: false,
                    labelAngle: -45
                },
                animationEnabled: true,
                data: [{
                        // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                        type: "column",
                        width: 50,
                        legendText: "Landholding Category",
                        dataPoints: dataPointsArray
                    }]
            }

            renderChart('livestock_holdings_2', dataObj);

        },
        // Livestock Holdings 3 - Average TLUs per Household by Animal Category [COLUMN CHART]
        livestock_holdings_3: function (err, rows) {

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].category_of_animal,
                    y: rows[i].average_tlus
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                theme: "theme2", //theme1
                animationEnabled: true,
                colorType: 'single',
                title: {
                    text: "Average Household Livestock Holdings by Category in Tropical Livestock Units (TLUs)"
                },
                axisY: {
                    title: "TLUs"
                },
                axisX: {
                    labelWrap: true
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('livestock_holdings_3', dataObj);

        },
        // Livestock Holdings 4 - Dominant Animal Categories by Average TLUs per Household [COLUMN CHART]
        livestock_holdings_4: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].category_of_animal,
                    y: rows[i].average_tlus
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Livestock Categories by TLUs (Up to 5)"
                },
                axisY: {
                    title: "TLUs"
                },
                axisX: {
                    labelWrap: true,
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('livestock_holdings_4', dataObj);
        },
        // Livestock Holdings 5 - Gendered Dominant Animal Categories by Average TLUs per Household [COLUMN CHART]
        livestock_holdings_5: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            
            var animalTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var animalType = rows[i].category_of_animal;
                if ($.inArray(animalType, animalTypeList) < 0) {
                    animalTypeList.push(animalType);
                }
            }            
            
            var dataPointsArrayMale = [];
            var dataPointsArrayFemale = [];
            for (var j = 0; j < animalTypeList.length; j++) {
                dataPointsArrayMale.push({label: animalTypeList[j], y: 0});
                dataPointsArrayFemale.push({label: animalTypeList[j], y: 0});
            }

            for (var i = 0; i < rows.length; i++) 
                for (var x = 0; x < animalTypeList.length; x++) {{
                    if (rows[i].category_of_animal == animalTypeList[x]) {
                        var dataPointsArray = rows[i].id_gender1 === 1 ? dataPointsArrayFemale : dataPointsArrayMale;
                        dataPointsArray[x] = {
                            label: rows[i].category_of_animal,
                            y: rows[i].average_tlus
                        };
                        break;
                    }
                }
            }

            /** Create data object */
            var dataObj = {
                colorType: 'alternating',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Livestock Categories in TLUs by Gender of Household Head (Up to 5)"
                },
                axisY: {
                    title: "Size of Holding(TLUs)"
                },
                axisX: {
                    labelWrap: true,
                },
                animationEnabled: true,
                data: [{
                    type: "column",
                    name: "Male-headed Households",
                    legendText: "Male-headed Households",
                    showInLegend: true,
                    color: "#CC3300",
                    dataPoints: dataPointsArrayMale
                }, {
                    type: "column",
                    name: "Female-headed Households",
                    legendText: "Female-headed Households",
                    showInLegend: true,
                    color: "#47B56C",
                    dataPoints: dataPointsArrayFemale
                }]
            }

            renderChart('livestock_holdings_5', dataObj);
        },        
        // Crop Cultivation 1- Average Hectares Cultivated per Household by Crop Type [COLUMN CHART]
        crop_cultivation_1: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_crop,
                    y: rows[i].average_ha_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Average Hectares Cultivated per Household by Crop Type"
                },
                axisY: {
                    title: "Hectares Under Cultivation",
                    titleFontSize: 12
                },
                axisX: {
                    labelWrap: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('crop_cultivation_1', dataObj);
        },
        // Crop Cultivation 2 - Dominant Crop Types by Average Hectares Cultivated per Household [COLUMN CHART]
        crop_cultivation_2: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_crop,
                    y: rows[i].average_ha_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Crop Types by Average Hectares Cultivated (Up to 5)"
                },
                axisY: {
                    title: "Hectares Under Cultivation",
                    titleFontSize: 12
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('crop_cultivation_2', dataObj);
        },
        // Crop Cultivation 3 - Dominant Crop Types by Average Hectares Cultivated per Household by Gender [COLUMN CHART]
        crop_cultivation_3: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            
            var cropTypeList = [];
            for (var i = 0; i < rows.length; i++) {
                var cropType = rows[i].type_of_crop;
                if ($.inArray(cropType, cropTypeList) < 0) {
                    cropTypeList.push(cropType);
                }
            }            
            
            var dataPointsArrayMale = [];
            var dataPointsArrayFemale = [];
            for (var j = 0; j < cropTypeList.length; j++) {
                dataPointsArrayMale.push({label: cropTypeList[j], y: 0});
                dataPointsArrayFemale.push({label: cropTypeList[j], y: 0});
            }

            for (var i = 0; i < rows.length; i++) 
                for (var x = 0; x < cropTypeList.length; x++) {{
                    if (rows[i].type_of_crop == cropTypeList[x]) {
                        var dataPointsArray = rows[i].id_gender1 === 1 ? dataPointsArrayFemale : dataPointsArrayMale;
                        dataPointsArray[x] = {
                            label: rows[i].type_of_crop,
                            y: rows[i].average_ha_per_hh
                        };
                        break;
                    }
                }
            }            
            /** Create data object */
            var dataObj = {
                colorType: 'alternating',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Crop Types in Average Hectares Cultivated by Gender of Household Head (Up to 5)"
                },
                axisY: {
                    title: "Area (Hectares)",
                    titleFontSize: 12
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                data: [{
                    type: "column",
                    name: "Male-headed Households",
                    legendText: "Male-headed Households",
                    showInLegend: true,
                    color: "#CC3300",
                    dataPoints: dataPointsArrayMale
                }, {
                    type: "column",
                    name: "Female-headed Households",
                    legendText: "Female-headed Households",
                    showInLegend: true,
                    color: "#47B56C",
                    dataPoints: dataPointsArrayFemale
                }]
            }

            renderChart('crop_cultivation_3', dataObj);
        },        
        // Fodder Crop Cultivation 1 - Average Hectares Cultivated per Household by Fodder Crop Type [COLUMN CHART]
        fodder_cultivation_1: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_fodder_crop,
                    y: rows[i].average_ha_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Average Hectares Cultivated per Household by Fodder Crop Type"
                },
                axisY: {
                    title: "Hectares Under Cultivation",
                    titleFontSize: 10
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('fodder_cultivation_1', dataObj);
        },
        // Fodder Crop Cultivation 2 - Dominant Fodder Crop Types by Average Hectares Cultivated per Household [COLUMN CHART]
        fodder_crop_2: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_fodder_crop,
                    y: rows[i].average_ha_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Fodder Crops by Average Hectares Cultivated (Up to 5)"
                },
                axisY: {
                    title: "Hectares Under Cultivation",
                    titleFontSize: 10
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('fodder_crop_2', dataObj);
        },
        // Purchased Feed 1 - Average Kilograms Purchased per Household by Feed Type [COLUMN CHART]
        purchased_feed_1: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_feed,
                    y: rows[i].average_kg_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Average kg of Feed Purchased per Household by Feed Type"
                },
                axisY: {
                    title: "Kg Purchased Per Year",
                    titleFontSize: 10,
                    minimum: 0
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelFontSize: 10,
                    //labelMaxWidth: 150,  
                    labelAutoFit: true//,
                            //labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('purchased_feed_1', dataObj);
        },
        // Purchased Feed 2 - Dominant Purchased Feed Types by Average Kilograms Purchased per Household [COLUMN CHART]
        purchased_feed_2: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].type_of_feed,
                    y: rows[i].average_kg_per_hh
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'single',
                theme: "theme2", //theme1
                animationEnabled: true,
                title: {
                    text: "Dominant Purchased Feed Types by kg Purchased (Up to 5)"
                },
                axisY: {
                    title: "Kg Purchased Per Year",
                    titleFontSize: 10
                },
                axisX: {
                    labelFontStyle: "italic",
                    labelFontSize: 12,
                    labelMaxWidth: 150,
                    labelAutoFit: true,
                    labelAngle: -45
                },
                animationEnabled: true,
                        data: [{
                                // Change type to "bar", "splineArea", "area", "spline", "pie",etc.
                                type: "column",
                                dataPoints: dataPointsArray
                            }]
            }

            renderChart('purchased_feed_2', dataObj);
        },
        // Animal Diet and Nutrition 1 - Dry Matter Intake by Source [PIE CHART]
        animal_diet_1: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var res = rows[0];

            // Create data array like this
            var dataPointsArray = [
                {y: res.dm_collected_fodder, label: "Collected fodder", color: '#78AFE6'},
                {y: res.dm_crop_residue, label: "Crop residue", color: '#FF9900'},
                {y: res.dm_cultivated_fodder, label: "Cultivated fodder", color: '#47B56C'},
                {y: res.dm_grazing, label: "Grazing", color: '#99FF66'},
                {y: res.dm_purchased_feed, label: "Purchased feed", color: '#CC3300'}
            ];

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Dry Matter Intake by Source"
                },
                animationEnabled: true,
                legend: {
                    verticalAlign: "center",
                    horizontalAlign: "left",
                    fontSize: 20,
                    fontFamily: "tahoma"
                },
                theme: "theme2",
                data: [
                    {
                        type: "pie",
                        indexLabelFontFamily: "verdana",
                        indexLabelFontSize: 12,
                        indexLabel: "{label} #percent %",
                        startAngle: -20,
                        toolTipContent: "{y} - #percent %",
                        dataPoints: dataPointsArray
                    }
                ]
            };

            renderChart('animal_diet_1', dataObj);
        },
        // Animal Diet and Nutrition 2 - Metabolisable Energy Intake by Source [PIE CHART]
        animal_diet_2: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            res = rows[0];

            // Create data array like this
            var dataPointsArray = [
                {y: res.me_collected_fodder, label: "Collected fodder", color: '#78AFE6'},
                {y: res.me_crop_residue, label: "Crop residue", color: '#FF9900'},
                {y: res.me_cultivated_fodder, label: "Cultivated fodder", color: '#47B56C'},
                {y: res.me_grazing, label: "Grazing", color: '#99FF66'},
                {y: res.me_purchased_feed, label: "Purchased feed", color: '#CC3300'}
            ];

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Metabolisable Energy Intake by Source"
                },
                animationEnabled: true,
                legend: {
                    verticalAlign: "center",
                    horizontalAlign: "left",
                    fontSize: 20,
                    fontFamily: "tahoma"
                },
                theme: "theme2",
                data: [
                    {
                        type: "pie",
                        indexLabelFontFamily: "verdana",
                        indexLabelFontSize: 12,
                        indexLabel: "{label} #percent %",
                        startAngle: -20,
                        toolTipContent: "{y} - #percent %",
                        dataPoints: dataPointsArray
                    }
                ]
            };

            renderChart('animal_diet_2', dataObj);
        },
        // Animal Diet and Nutrition 3 - Crude Protein Intake by Source [PIE CHART]
        animal_diet_3: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            res = rows[0];

            // Create data array like this
            var dataPointsArray = [
                {y: res.cp_collected_fodder, label: "Collected fodder", color: '#78AFE6'},
                {y: res.cp_crop_residue, label: "Crop residue", color: '#FF9900'},
                {y: res.cp_cultivated_fodder, label: "Cultivated fodder", color: '#47B56C'},
                {y: res.cp_grazing, label: "Grazing", color: '#99FF66'},
                {y: res.cp_purchased_feed, label: "Purchased feed", color: '#CC3300'}
            ];

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Crude Protein Intake by Source"
                },
                animationEnabled: true,
                legend: {
                    verticalAlign: "center",
                    horizontalAlign: "left",
                    fontSize: 20,
                    fontFamily: "tahoma"
                },
                theme: "theme2",
                data: [
                    {
                        type: "pie",
                        indexLabelFontFamily: "verdana",
                        indexLabelFontSize: 12,
                        indexLabel: "{label} #percent %",
                        startAngle: -20,
                        toolTipContent: "{y} - #percent %",
                        dataPoints: dataPointsArray
                    }
                ]
            };

            renderChart('animal_diet_3', dataObj);
        },
        // Income Sources [PIE CHART]
        income_sources: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].income_category,
                    y: rows[i].average_percent
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Major Sources of Income by Activity Category"
                },
                animationEnabled: true,
                legend: {
                    verticalAlign: "center",
                    horizontalAlign: "left",
                    fontSize: 20,
                    fontFamily: "tahoma"
                },
                theme: "theme2",
                data: [
                    {
                        type: "pie",
                        indexLabelFontFamily: "verdana",
                        indexLabelFontSize: 12,
                        indexLabel: "{label} #percent %",
                        startAngle: -20,
                        toolTipContent: "{label} {y}%",
                        dataPoints: dataPointsArray
                    }
                ]
            };

            renderChart('income_sources', dataObj);
        },
        // Income Sources [PIE CHART]
        womens_income_sources: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            /** CREATE DATA POINTS */
            var dataPointsArray = [];

            for (var i = 0; i < rows.length; i++) {
                dataPointsArray.push({
                    label: rows[i].income_category,
                    y: rows[i].average_percent
                });
            }
            ;

            /** Create data object */
            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Major Sources of Income for Women by Activity Category"
                },
                animationEnabled: true,
                legend: {
                    verticalAlign: "center",
                    horizontalAlign: "left",
                    fontSize: 20,
                    fontFamily: "tahoma"
                },
                theme: "theme2",
                data: [
                    {
                        type: "pie",
                        indexLabelFontFamily: "verdana",
                        indexLabelFontSize: 12,
                        indexLabel: "{label} #percent %",
                        startAngle: -20,
                        toolTipContent: "{label} {y}%",
                        dataPoints: dataPointsArray
                    }
                ]
            };

            renderChart('womens_income_sources', dataObj);
        },        
        // Monthly Rainfall
        monthly_rainfall: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            var tempData = {};
            var dataArr = [];

            rows.forEach(function (el) {
                var type = el.resource_type;
                tempData[type] = tempData[type] || {
                    type: (type !== "Rainfall") ? "stackedColumn" : "line",
                    lineThickness: "3",
                    axisYType: (type !== "Rainfall") ? "primary" : "secondary",
                    showInLegend: true,
                    name: el.resource_type,
                    dataPoints: []
                };

                tempData[type].dataPoints[el.order_of_month - 1] = {
                    y: el.numerical_value,
                    x: new Date(2015, el.order_of_month - 1)
                };


            });

            for (var x in tempData) {
                if (x !== 'Rainfall') {
                    dataArr.push(tempData[x]);
                }
            }
            dataArr.push(tempData['Rainfall']);//assuming that puts rainfall 'on top'

            var dataObj = {
                colorType: 'alternating',
                title: {
                    text: "Rainfall and Feed Availability",
                },
                animationEnabled: true,
                toolTip: {
                    shared: true,
                    content: function (e) {
                        var str = '';
                        var total = 0;
                        var str3;
                        var str2;
                        for (var i = 0; i < e.entries.length; i++) {

                            if (e.entries[i].dataSeries.name !== 'Rainfall') {
                                var str1 = "<span style= 'color:" + e.entries[i].dataSeries.color + "'> " + e.entries[i].dataSeries.name + "</span>: <strong>" + unfloatRound(e.entries[i].dataPoint.y, 2) + "</strong><br/>";
                                total = e.entries[i].dataPoint.y + total;
                                str = str.concat(str1);
                            }

                        }
                        str2 = "<span style = 'color:DodgerBlue; '><strong>" + (e.entries[0].dataPoint.x).getFullYear() + "</strong></span><br/>";

                        total = unfloatRound(total, 2);
                        str3 = "<span style = 'color:Tomato '>Total:</span><strong> " + total + "</strong><br/>";

                        return (str2.concat(str)).concat(str3);
                    }
                },
                axisY: {
                    title: "Availability of feed (0-10)",
                    titleFontSize: 16
                },
                axisY2: {
                    title: "Rainfall (0-5)",
                    maximum: 5,
                    titleFontSize: 16,
                    gridThickness: 0
                },
                axisX: {
                    interval: 1,
                    intervalType: "month",
                    valueFormatString: "MMMM",
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                data: dataArr
            };


            renderChart('monthly_rainfall', dataObj);

        },
        // Monthly Milk Yield versus Average Price Received  [LINE GRAPH - TWO DIFFERENT AXES FOR YIELD AND PRICE]
        monthly_milk_yield: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            var yieldData = [];
            var priceData = [];

            rows.forEach(function (el) {

                var month = el.ordering - 1;
                var date = new Date(2015, month);

                priceData[month] = {x: date, y: el.average_price_litre_usd};
                yieldData[month] = {x: date, y: el.average_yield};

            });

            var dataObj = {
                colorType: 'line',
                title: {
                    text: "Average Daily Milk Yield (L) vs. Avg. Price Received per Litre"
                },
                animationEnabled: true,
                axisX: {
                    intervalType: "month",
                    valueFormatString: "MMMM",
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: true,
                    labelAngle: -45
                },
                axisY: {
                    title: "Yield (L)",
                },
                axisY2: {
                    title: "Price (USD)",
                },
                data: [
                    {
                        type: "line",
                        color: "#78AFE6",
                        lineThickness: "3",
                        showInLegend: true,
                        axisYType: "primary",
                        name: "Average yield",
                        dataPoints: yieldData
                    }, {
                        type: "line",
                        color: "#FF9900",
                        lineThickness: "3",
                        showInLegend: true,
                        axisYType: "secondary",
                        name: "Average price per litre",
                        dataPoints: priceData
                    }
                ]
            };

            renderChart('monthly_milk_yield', dataObj);

        },
        // Monthly Market Prices for Livestock [LINE GRAPH - TWO DIFFERENT AXES FOR HEADCOUNT AND PRICE]
        monthly_market_prices: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);

            //month_name: "January"ordering: 1price_head_cattle_usd: 12672.000000000002price_head_goat_usd: 495.00000000000006price_head_sheep_usd: 792.0000000000001

            var cattleData = [];
            var goatData = [];
            var sheepData = [];
            
            rows.forEach(function (el) {

                var month = el.ordering - 1;
                var date = new Date(2015, month);
                
                cattleData[month] = {x: date, y: el.price_head_cattle_usd};
                goatData[month] = {x: date, y: el.price_head_goat_usd};
                sheepData[month] = {x: date, y: el.price_head_sheep_usd};
            });

            var dataObj = {
                colorType: 'line',
                title: {
                    text: "Average Household Income by Activity Category"
                },
                animationEnabled: true,
                legend: {
                    //verticalAlign: "center",
                    //horizontalAlign: "left",
                    //fontSize: 20,
                    fontFamily: "tahoma"
                },
                axisX: {
                    interval: 1,
                    intervalType: "month",
                    valueFormatString: "MMMM",
                    labelFontStyle: "italic",
                    labelMaxWidth: 100,
                    labelWrap: false,
                    labelAngle: -55
                },
                axisY: {title: 'Price (cows) USD'},
                axisY2: {
                    title: "Price (goats, sheep) USD",
                },
                theme: "theme2",
                data: [
                    {
                        type: "line",
                        color: "#FF9900",
                        showInLegend: true,
                        lineThickness: "3",
                        name: "Price per head of Cow (USD)",
                        dataPoints: cattleData
                    },
                    {
                        type: "line",
                        showInLegend: true,
                        lineThickness: "3",
                        name: "Price per head of Goat (USD)",
                        axisYType: "secondary",
                        dataPoints: goatData
                    },
                    {
                        type: "line",
                        showInLegend: true,
                        name: "Price per head of Sheep (USD)",
                        axisYType: "secondary",
                        dataPoints: sheepData
                    }
                ]
            };

            renderChart('monthly_market_prices', dataObj);

        },
        // Gender Pay Equality [COLUMN CHART]
        gender_pay_equality: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            var row = rows[0];
			
			if (rows.length < 1) {
				row = {};
				row.avg_pay_male = 0;
				row.avg_pay_female = 0;
			}

            var dataObj = {
                colorType: 'single',
                title: {
                    text: "Average Income By Gender"
                },
                animationEnabled: true,
                axisY: {
                    title: "Average Daily Labour Rate (usd)",
                },
                data: [
                    {
                        type: "column",
                        dataPoints: [
                            {label: 'Men', y: row.avg_pay_male},
                            {label: 'Women', y: row.avg_pay_female}
                        ]
                    }
                ]
            };

            renderChart('gender_pay_equality', dataObj);

        },
        // Land Ownership by Gender
        land_ownership_by_gender: function (err, rows) {
            console.log("=========> ROWS");
            console.log(rows);
            //format rows into dataObj here

            var row = rows[0];
			
			if (rows.length < 1) {
				row = {};
				row.avg_joint = 0;
				row.avg_male = 0;
                                row.avg_female = 0;
			}

            var dataObj = {
                colorType: 'single',
                title: {
                    text: "Land Ownership by Gender"
                },
                animationEnabled: true,
                axisY: {
                    title: "Area(Hectares)",
                },
                data: [
                    {
                        type: "column",
                        dataPoints: [
                            {label: 'Individually owned by the man', y: row.avg_male},
                            {label: 'Individually owned by the woman', y: row.avg_female},
                            {label: 'Jointly owned land', y: row.avg_joint}
                        ]
                    }
                ]
            };

            renderChart('land_ownership_by_gender', dataObj);

        }        
        /*
         query_label:function(err, rows){
         
         //format rows into dataObj here
         
         renderChart(dataObj);
         
         }
         */
    };

//renderChartData for any args that were passed when the nwk app was started
    if (paramType !== 'techfit') {
        renderChartData(query, paramType, paramVal);

//This is the function that passes resultBinding callbacks to the queries
        function renderChartData(query, paramType, paramVal) {
            if (query && queries[query]) {
                if (queries[query] && resultBindings[query]) {

                    paramObj = buildFilter(paramType, paramVal);

                    queries[query].query(paramObj.param, paramObj.groupParam, resultBindings[query]);

                } else {
                    $('#chartContainer').empty();
                }
            }
        }
        /*
         
         axisX: {
         labelFontStyle: "italic",
         labelMaxWidth: 100,  
         labelWrap: true,
         labelAngle: -45
         },
         */


        window.columnColorSelect = (function () {
            var arr = [
                '#4573a7',
                '#d09392',
                '#89a54e',
                '#71588f',
                '#4298af',
                '#db843d',
                '#93a9d0',
                '#aa4644',
                '#bacd96',
                '#a99bbe'
            ];
            return (function columnColorSelect() {
                var retColor = arr.shift();
                arr.push(retColor);
                return retColor;
            });
        })();

        var colorMap = {};

        for (var x in resultBindings) {
            colorMap[x] = columnColorSelect();
        }
        console.log('COLORMAP:');
        console.log(colorMap);
//This calls canvas.js from the resultBindings
        function renderChart(chartId, dataObj) {

            var cols = dataObj.data[0].dataPoints.length;
            var labelFontSize = (cols > 5) ? 10 : 12;
            var colors = [
                '#89a54e',
                '#4573a7',
                '#d09392',
                '#71588f',
                '#4298af',
                '#db843d',
                '#93a9d0',
                '#aa4644',
                '#bacd96',
                '#a99bbe'
            ];
            if (dataObj.data) {
                var singleColor = false;
                if ((dataObj.colorType !== 'alternating') && (dataObj.colorType !== 'line')) {
                    singleColor = true;
                    singleColorVal = colorMap[chartId];
                }

                if (dataObj.data.length > 1) {
                    dataObj.data.forEach(function (el, i) {
                        var count = i;
                        var len = dataObj.data.length;
                        if (!singleColor) {
                            if (count > (len - 1)) {
                                count = count % (len - 1);
                                console.log('COUNT: ' + count);
                            }
                            el.color = colors[count];
                        } else {
                            el.color = singleColorVal;
                        }
                    });
                } else if (dataObj.data.length > 0) {
                    dataObj.data[0].dataPoints.forEach(function (el, i) {
                        var count = i;
                        var len = dataObj.data[0].dataPoints.length;
                        if (!singleColor) {
                            if (count > (len - 1)) {
                                count = count % (len - 1);
                                console.log('COUNT: ' + count);
                            }
                            el.color = colors[count];
                        } else {
                            el.color = singleColorVal;
                        }
                    });
                }
            }


            dataObj.animationDuration = 800;
            dataObj.backgroundColor = null;
            dataObj.title = dataObj.title || {};
            dataObj.title.fontFamily = 'tahoma';
            dataObj.title.fontSize = 20;

            dataObj.axisX = dataObj.axisX || {};
            dataObj.axisX.labelFontFamily = 'tahoma';
            dataObj.axisX.labelFontSize = labelFontSize;


            var dataLen = dataObj.data[0].dataPoints.length;

            if (dataLen) {
                dataObj.axisX.labelMaxWidth = $('#chartContainer').width() / dataObj.data[0].dataPoints.length;
            }

            dataObj.axisY = dataObj.axisY || {};
            if (dataObj.axisY2 === undefined) {
                dataObj.axisY.minimum = 0;
            }


            dataObj.axisY.titleFontFamily = 'tahoma';
            dataObj.axisY.titleFontSize = 20;

            dataObj.axisY.titleFontWeight = 400;
            if (dataObj.axisY2) {
                dataObj.axisY2.titleFontFamily = 'tahoma';
                dataObj.axisY2.titleFontSize = 20;
                dataObj.axisY2.titleFontWeight = 400;
            }

            dataObj.data.forEach(function (el) {
                el.indexLabelFontFamily = 'tahoma';
                el.indexLabelFontSize = 12;
            });

            var chart = new CanvasJS.Chart("chartContainer", dataObj);
            chart.render();
        }

//This is kind of stupid. I was assuming we would handle more than one parameter but it's not really necessary now.
        function buildFilter(paramType, paramVal) {
            var retVal;
            if (paramType === 'byFocusGroup') {
                retVal = {
                    param: 'focus_group.id = ' + paramVal,
                    groupParam: 'focus_group.id'
                };
            } else if (paramType === 'bySite') {
                retVal = {
                    param: 'focus_group.id_site = ' + paramVal,
                    groupParam: 'focus_group.id_site'
                };
            } else
                retVal = false;
            return retVal;
        }

//This fires the sqlLite adapter and returns rows to the callback.
        function fireStatement(statement, callback) {
            console.log(callback);
            if (typeof callback === 'string') {
                var label = callback;
                callback = function (err, rows) {
                    console.log('\nTESTING queries.' + label + ':');
                    console.log(rows || ('ERROR WITH STATEMENT:\n' + statement));
                };
            }

            db.serialize(function () {
                db.all(statement, callback);
            });

        }

//testing - this is what's giving you all those logs when the app first runs.
        for (var x in queries) {
            queries[x].query(buildFilter('bySite', 2).param, buildFilter('bySite', 2).groupParam, x);
        }

//Setting up all of the HTML events to trigger everthing above this.
        function chartUi(ddData) {

            $('#chartContainer').on('newChartData', function () {
                renderCurrentSelections();
            });


            var $chartSelection = $('#chart_selection');
            var $projectSelection = $('#project_selection');
            var $siteSelection = $('#site_selection');
            var $groupSelection = $('#group_selection');
            var $allSelects = $('#chart_selection, #project_selection, #site_selection, #group_selection');
            var $btnRefresh = $('#btn_refresh');
            var $btnByBroup = $('#btn_by_group');
            var $btnBySite = $('#btn_by_site');
            var $btnSaveImg = $('#btn_save_img');
            var $fileChooser = $('#file_chooser');

            var sid, pid, fid;

            $btnRefresh.click(function () {
                $('#chartContainer').trigger('newChartData');
            });

            $btnSaveImg.click(function () {
                $fileChooser.click();
            });

            function buildChartList(gendered) {
                var optionArr = [];
                
                var sortedQueries = [];
                for (var x in queries) {
                    sortedQueries.push(queries[x]);
                }
                
                sortedQueries.sort(function(a,b){ return a.sortOrder - b.sortOrder; });
                
                for (var x in sortedQueries) { 
                    for (var y in queries) {
                        if (queries[y].sortOrder == sortedQueries[x].sortOrder && (sortedQueries[x].gendered == null || sortedQueries[x].gendered === gendered)) {
                            optionArr.push(['<option value="', y, '">', sortedQueries[x].displayName, '</option>'].join(''));
                        }
                    }
                }
                
                $chartSelection.html(optionArr.join(''));
            }


            function buildOptions(idLabel, nameLabel, data) {
                var arr = [];
                data.forEach(function (el) {
                    arr.push(['<option value="', el[idLabel], '">', el[nameLabel], '</option>'].join(''));
                });
                return arr.join('');
            }

            $projectSelection.html(buildOptions('project_id', 'project_name', ddData.projects));


            $projectSelection.change(function (e) {

                if (e.target.value !== pid) {
                    pid = e.target.value;
                    var data = ddData[pid].sites;
                    $siteSelection.html(buildOptions('site_id', 'site_name', data));
                    $siteSelection.change();
                } else {
                    renderCurrentSelections();
                }
            });

            $siteSelection.change(function (e) {
                if (e.target.value !== sid) {
                    sid = e.target.value;
                    var data = ddData[pid][sid].focusGroups;
                    $groupSelection.html(buildOptions('focus_group_id', 'focus_group_name', data));
                    $groupSelection.change();
                } else {
                    renderCurrentSelections();
                }
            });

            $groupSelection.change(function (e) {

                //testing - this is what's giving you all those logs when the app first runs.
                for (var x in queries) {
                    queries[x].query(buildFilter('bySite', 2).param, buildFilter('bySite', 2).groupParam, x);
                }

                for (var i = 0; i < ddData[pid][sid].focusGroups.length; i++) {
                  var selectedFocusGroup = ddData[pid][sid].focusGroups[i];
                  if (selectedFocusGroup.focus_group_id == e.target.value) {
                      buildChartList(selectedFocusGroup.focus_group_gender != null);
                      break;
                  }
                }
                if (e.target.value !== fid) {
                    fid = e.target.value;
                    renderCurrentSelections();
                }
            });

            $projectSelection.change();

            $siteSelection.change();
            
            var firstChart = $chartSelection[0].value;

            $('#btn_by_group, #btn_by_site').click(function (e) {
                if (!$(this).hasClass('active')) {
                    var targetId = e.target.id;
                    $('button.active').removeClass('active');
                    $('#' + targetId).addClass('active');
                    renderCurrentSelections();
                }
            });

            $chartSelection.change(function (e) {
                $('#file_chooser')[0].nwsaveas = e.target.value + '.png';
                renderCurrentSelections();
            });


            $chartSelection.change();


            function renderCurrentSelections() {
                var $activeBtn = $('#btn_by_group.active, #btn_by_site.active');
                var activeId = $activeBtn[0].id;

                var query = $chartSelection[0].value;
                console.log(query);
                var paramType = (activeId === 'btn_by_group') ? 'byFocusGroup' : 'bySite';
                var paramVal = (paramType === 'byFocusGroup') ? fid : sid;

                renderChartData(query, paramType, paramVal);
            }

            $('#file_chooser').change(function (e) {
                var imgData = $('canvas.canvasjs-chart-canvas')[0].toDataURL().split(',')[1];
                imgData = new Buffer(imgData, 'base64');
                console.log(path.normalize(e.target.value));
                fs.writeFileSync(e.target.value, imgData);
            });


        }//end chartUi
    } else {
        techfitModel = new koTechfitModel(paramVal);
        techfitModel.init();
        ko.applyBindings(techfitModel);
    }

// Set up a knockout model for the techfit data
    function koTechfitModel(assessmentID) {
        var self = this;
        self.assessment = ko.observable({});
        self.assessmentScores = {};
        self.interventions = ko.observableArray();
        self.selectedIntervention = ko.observable();

        self.heatmapGradient = tinygradient([
            'rgb(248,105,107)',
            'rgb(255,235,132)',
            'rgb(99,190,123)'
        ]);

        self.gradientColors = self.heatmapGradient.hsv(21);

        self.showRankings = function () {
            self.selectedIntervention(null);
        };

        self.showIntervention = function (intervention) {
            self.selectedIntervention(intervention);
        };

        self.intvListType = ko.observable();
        self.intvScoreType = ko.observable();

        self.currentScoreType = "normal";
        self.lastSort = "none";
        self.sortDir = "asc";
        self.currentSort = ko.observable("none");

        self.sortRankings = function (rankedInterventions) {
            var sortField = null;
            switch (self.currentSort()) {
                case "core":
                    sortField = self.currentScoreType === "raw" ? "mitigationPotential" : "normalMitigationPotential";
                    break;
                case "commodity":
                    sortField = self.currentScoreType === "raw" ? "commodityRelevance" : "normalCommodityRelevance";
                    break;
                case "system":
                    sortField = self.currentScoreType === "raw" ? "systemRelevance" : "normalSystemRelevance";
                    break;
                case "attribute":
                    sortField = self.currentScoreType === "raw" ? "attributeMatch" : "normalAttributeMatch";
                    break;
                case "impact":
                    sortField = self.currentScoreType === "raw" ? "impact" : "normalImpact";
                    break;
            }
            if (sortField != null) {
                var sortAsc = true;
                if (self.lastSort === self.currentSort()) {
                    if (self.sortDir === "asc") { // Switch directions
                        sortAsc = false;
                        self.sortDir = "desc";
                    } else {
                        self.sortDir = "asc";
                    }
                } else {
                    self.sortDir = "asc";
                }
                if (sortAsc) {
                    rankedInterventions.sort(function (a, b) {
                        return a.techfitCalcs[sortField] === b.techfitCalcs[sortField] ? 0 : (a.techfitCalcs[sortField] < b.techfitCalcs[sortField] ? -1 : 1);
                    });
                } else {
                    rankedInterventions.sort(function (a, b) {
                        return b.techfitCalcs[sortField] === a.techfitCalcs[sortField] ? 0 : (b.techfitCalcs[sortField] < a.techfitCalcs[sortField] ? -1 : 1);
                    });
                }
            }
            return rankedInterventions;
        };

        self.normalRankings = function () {
            self.currentScoreType = "normal";
            self.interventions.sort(function (a, b) {
                return a.techfitCalcs.normalRank === b.techfitCalcs.normalRank ? 0 : (a.techfitCalcs.normalRank < b.techfitCalcs.normalRank ? -1 : 1);
            });
            return self.interventions();
        };

        self.rawRankings = function () {
            self.currentScoreType = "raw";
            self.interventions.sort(function (a, b) {
                return a.techfitCalcs.rawRank === b.techfitCalcs.rawRank ? 0 : (a.techfitCalcs.rawRank < b.techfitCalcs.rawRank ? -1 : 1);
            });
            return self.interventions();
        };

        self.displayRankings = ko.computed(function () {
            var plainList = self.currentSort() == "none";
            if (self.intvScoreType() == "Normalized Scores") {
                if (self.intvListType() == "Top Interventions") {
                    var topRankings = [];
                    var rawList = self.normalRankings();
                    for (var i = 0; i < rawList.length; i++) {
                        if (rawList[i].techfitCalcs.normalRank <= 5 && rawList[i].techfitCalcs.landElig && rawList[i].techfitCalcs.waterElig) {
                            topRankings.push(rawList[i]);
                        }
                    }
                    return self.sortRankings(topRankings);
                } else {
                    return self.sortRankings(self.normalRankings());
                }
            } else {
                if (self.intvListType() == "Top Interventions") {
                    var topRankings = [];
                    var rawList = self.rawRankings();
                    for (var i = 0; i < rawList.length; i++) {
                        if (rawList[i].techfitCalcs.rawRank <= 5) {
                            topRankings.push(rawList[i]);
                        }
                    }
                    return self.sortRankings(topRankings);
                } else {
                    return self.sortRankings(self.rawRankings());
                    }
                }
        });

        self.init = function () {
            db.serialize(function () {
                db.all('SELECT * FROM techfit_assessment WHERE id = ' + assessmentID, function (err, rows) {
                    if (!err) {
                        self.assessment(rows[0]);
                        console.log(rows);
                        db.all('SELECT * FROM core_context_attribute_score WHERE id_techfit_assessment = ' + assessmentID, function (err, rows) {
                            if (!err) {
                                var result = {};
                                for (var i = 0; i < rows.length; i++) {
                                    result[rows[i].id_core_context_attribute] = rows[i];
                                    result[rows[i].id_core_context_attribute].score = rows[i].id_techfit_scale - 1;
                                }
                                self.assessmentScores = result;
                                console.log(rows);

                                db.all('SELECT * FROM techfit_intervention WHERE id > 1', function (err, rows) {
                                    if (!err) {
                                        console.log(rows);
                                        self.calculateRankings(rows);
                                        self.filterNormalScores(rows);
                                        self.rankInterventions(rows);
                                    } else {
                                        console.log(err);
                                    }
                                });
                            } else {
                                console.log(err);
                            }
                        });
                    } else {
                        console.log(err);
                    }
                });

            });
        };

        self.calculateRankings = function (rows) {
            /** assessmentScore (core_context_attribute_score) attribute IDs are:
             1	Availability of feed in dry or cool season (0 = serious problem)
             2	Availability of feed in growing season (0 = serious problem)
             3	Quality of feed (4 = best)
             4	Quantity of feed (4 = best)
             5	Availability of water in growing season (4 = best)
             6	Availability of labour (4 = best)
             7	Availability of cash / credit (4 = best)
             8	Availability of land for fodder cultivation (4 = best)
             9	Availability of input delivery (4 = best)
             10	Availability of knowledge / skill (4 = best)
             */

            /** Agriculture system types
             1	Pastoral (extensive grazing systems)
             2	Agro-pastoral / extensive mixed systems
             3	Intensive mixed crop-livestock system (incl. trees)
             4	Landless livestock producers (intensive)
             */

            /** Core commodities
             1	Cattle/buffalo breeding (cow-calf)
             2	Cattle/buffalo fattening
             3	Dairy cattle / buffalo
             4	Sheep/goat breeding
             5	Sheep/goat fattening
             6	Pig breeding (sow-piglets)
             7	Pig fattening
             */
            for (var i = 0; i < rows.length; i++) {
                var thisIntv = rows[i];

                var techfitCalcs = {};
                // Calculate eligibility
                techfitCalcs.landElig = !(self.assessmentScores[8].score < 2 && thisIntv.technology_land < 4);
                techfitCalcs.waterElig = !(self.assessmentScores[5].score < 2 && thisIntv.technology_water < 4);
                techfitCalcs.systemEligPastoral = self.assessment().id_agriculture_system_type === 1 && thisIntv.system_pastoral > 0;
                techfitCalcs.systemEligAgro = self.assessment().id_agriculture_system_type === 2 && thisIntv.system_agro_pastoral > 0;
                techfitCalcs.systemEligIntensive = self.assessment().id_agriculture_system_type === 3 && thisIntv.system_intensive_mixed > 0;
                techfitCalcs.systemEligLandless = self.assessment().id_agriculture_system_type === 4 && thisIntv.system_landless > 0;
                techfitCalcs.systemElig = (techfitCalcs.systemEligPastoral || techfitCalcs.systemEligAgro || techfitCalcs.systemEligIntensive || techfitCalcs.systemEligLandless);

                techfitCalcs.comEligCowBreed = self.assessment().id_core_commodity === 1 && thisIntv.commodity_cattle_buffalo_breeding > 0;
                techfitCalcs.comEligCowFat = self.assessment().id_core_commodity === 2 && thisIntv.commodity_cattle_buffalo_fattening > 0;
                techfitCalcs.comEligCowDairy = self.assessment().id_core_commodity === 3 && thisIntv.commodity_cattle_buffalo_dairy > 0;
                techfitCalcs.comEligGoatBreed = self.assessment().id_core_commodity === 4 && thisIntv.commodity_sheep_goat_breeding > 0;
                techfitCalcs.comEligGoatFat = self.assessment().id_core_commodity === 5 && thisIntv.commodity_sheep_goat_fattening > 0;
                techfitCalcs.comEligPigBreed = self.assessment().id_core_commodity === 6 && thisIntv.commodity_pig_breeding > 0;
                techfitCalcs.comEligPigFat = self.assessment().id_core_commodity === 7 && thisIntv.commodity_pig_fattening > 0;
                techfitCalcs.comElig = (techfitCalcs.comEligCowBreed || techfitCalcs.comEligCowFat || techfitCalcs.comEligCowDairy || techfitCalcs.comEligGoatBreed || techfitCalcs.comEligGoatFat || techfitCalcs.comEligPigBreed || techfitCalcs.comEligPigFat);

                // Calculate potential to mitigate
                techfitCalcs.mitigDry = self.assessmentScores[1].score * thisIntv.mitigate_season_feed_scarcity_dry_cool;
                techfitCalcs.mitigGrowing = self.assessmentScores[2].score * thisIntv.mitigate_season_feed_scarcity_growing;
                techfitCalcs.mitigQuantity = self.assessmentScores[4].score * thisIntv.mitigate_quantity_constraint;
                techfitCalcs.mitigQuality = self.assessmentScores[3].score * thisIntv.mitigate_quality_constraint;
                techfitCalcs.mitigationPotential = (techfitCalcs.mitigDry + techfitCalcs.mitigGrowing + techfitCalcs.mitigQuantity + techfitCalcs.mitigQuality) * self.assessment().weight_core_feed_issue;

                // Commodity relevance
                techfitCalcs.comRelvCowBreed = self.assessment().id_core_commodity === 1 ? thisIntv.commodity_cattle_buffalo_breeding : 0;
                techfitCalcs.comRelvCowFat = self.assessment().id_core_commodity === 2 ? thisIntv.commodity_cattle_buffalo_fattening : 0;
                techfitCalcs.comRelvCowDairy = self.assessment().id_core_commodity === 3 ? thisIntv.commodity_cattle_buffalo_dairy : 0;
                techfitCalcs.comRelvGoatBreed = self.assessment().id_core_commodity === 4 ? thisIntv.commodity_sheep_goat_breeding : 0;
                techfitCalcs.comRelvGoatFat = self.assessment().id_core_commodity === 5 ? thisIntv.commodity_sheep_goat_fattening : 0;
                techfitCalcs.comRelvPigBreed = self.assessment().id_core_commodity === 6 ? thisIntv.commodity_pig_breeding : 0;
                techfitCalcs.comRelvPigFat = self.assessment().id_core_commodity === 7 ? thisIntv.commodity_pig_fattening : 0;
                techfitCalcs.commodityRelevance = (techfitCalcs.comRelvCowBreed + techfitCalcs.comRelvCowFat + techfitCalcs.comRelvCowDairy + techfitCalcs.comRelvGoatBreed + techfitCalcs.comRelvGoatFat + techfitCalcs.comRelvPigBreed + techfitCalcs.comRelvPigFat) * self.assessment().weight_commodity;

                //  Farming relevance
                techfitCalcs.systemRelvPastoral = self.assessment().id_agriculture_system_type === 1 ? thisIntv.system_pastoral : 0;
                techfitCalcs.systemRelvAgro = self.assessment().id_agriculture_system_type === 2 ? thisIntv.system_agro_pastoral : 0;
                techfitCalcs.systemRelvIntensive = self.assessment().id_agriculture_system_type === 3 ? thisIntv.system_intensive_mixed : 0;
                techfitCalcs.systemRelvLandless = self.assessment().id_agriculture_system_type === 4 ? thisIntv.system_landless : 0;
                techfitCalcs.systemRelevance = (techfitCalcs.systemRelvPastoral + techfitCalcs.systemRelvAgro + techfitCalcs.systemRelvIntensive + techfitCalcs.systemRelvLandless) * self.assessment().weight_fs;

                // Attribute Match
                techfitCalcs.attrMatchLand = self.assessmentScores[8].score * thisIntv.technology_land;
                techfitCalcs.attrMatchWater = self.assessmentScores[5].score * thisIntv.technology_water;
                techfitCalcs.attrMatchLabour = self.assessmentScores[6].score * thisIntv.technology_labour;
                techfitCalcs.attrMatchCapital = self.assessmentScores[7].score * thisIntv.technology_cash_credit;
                techfitCalcs.attrMatchInput = self.assessmentScores[9].score * thisIntv.technology_input_delivery;
                techfitCalcs.attrMatchKnowledge = self.assessmentScores[10].score * thisIntv.technology_knowledge_skill;
                techfitCalcs.attributeMatch = (techfitCalcs.attrMatchLand + techfitCalcs.attrMatchWater + techfitCalcs.attrMatchLabour + techfitCalcs.attrMatchCapital + techfitCalcs.attrMatchInput + techfitCalcs.attrMatchKnowledge) * self.assessment().weight_context_attribute;

                techfitCalcs.impact = thisIntv.impact * self.assessment().weight_impact;

                techfitCalcs.rawScore = (techfitCalcs.mitigationPotential + techfitCalcs.commodityRelevance + techfitCalcs.systemRelevance + techfitCalcs.attributeMatch + techfitCalcs.impact);
                thisIntv.techfitCalcs = techfitCalcs;
            }
        };

        self.filterNormalScores = function (rows) {
            var maxMitigationPotential = 0;
            var maxCommodityRelevance = 0;
            var maxSystemRelevance = 0;
            var maxAttributeMatch = 0;
            var maxImpact = 0;
            // Get maximum values for each score
            for (var i = 0; i < rows.length; i++) {
                var thisIntv = rows[i];
                if (thisIntv.techfitCalcs.mitigationPotential > maxMitigationPotential) {
                    maxMitigationPotential = thisIntv.techfitCalcs.mitigationPotential;
                }
                if (thisIntv.techfitCalcs.commodityRelevance > maxCommodityRelevance) {
                    maxCommodityRelevance = thisIntv.techfitCalcs.commodityRelevance;
                }
                if (thisIntv.techfitCalcs.systemRelevance > maxSystemRelevance) {
                    maxSystemRelevance = thisIntv.techfitCalcs.systemRelevance;
                }
                if (thisIntv.techfitCalcs.attributeMatch > maxAttributeMatch) {
                    maxAttributeMatch = thisIntv.techfitCalcs.attributeMatch;
                }
                if (thisIntv.techfitCalcs.impact > maxImpact) {
                    maxImpact = thisIntv.techfitCalcs.impact;
                }
            }

            // Calculate normalized scores
            for (var i = 0; i < rows.length; i++) {
                var thisIntv = rows[i];
                thisIntv.techfitCalcs.normalMitigationPotential = thisIntv.techfitCalcs.mitigationPotential * (20 / maxMitigationPotential);
                thisIntv.techfitCalcs.normalCommodityRelevance = thisIntv.techfitCalcs.commodityRelevance * (20 / maxCommodityRelevance);
                thisIntv.techfitCalcs.normalSystemRelevance = thisIntv.techfitCalcs.systemRelevance * (20 / maxSystemRelevance);
                thisIntv.techfitCalcs.normalAttributeMatch = thisIntv.techfitCalcs.attributeMatch * (20 / maxAttributeMatch);
                thisIntv.techfitCalcs.normalImpact = thisIntv.techfitCalcs.impact * (20 / maxImpact);
                thisIntv.techfitCalcs.normalScore = (thisIntv.techfitCalcs.normalMitigationPotential + thisIntv.techfitCalcs.normalCommodityRelevance + thisIntv.techfitCalcs.normalSystemRelevance + thisIntv.techfitCalcs.normalAttributeMatch + thisIntv.techfitCalcs.normalImpact);
            }
        };

        self.rankInterventions = function (rows) {
            var validRows = [];
            for (var r = 0; r < rows.length; r++) {
                if (rows[r].techfitCalcs.landElig && rows[r].techfitCalcs.waterElig) {
                    validRows.push(rows[r]);
                }
            }
            
            var sortedRaw = validRows.slice().sort(function (a, b) {
                return b.techfitCalcs.rawScore - a.techfitCalcs.rawScore;
            });
            var ranksRaw = validRows.slice().map(function (v) {
                return sortedRaw.indexOf(v) + 1;
            });
            var sortedNormal = validRows.slice().sort(function (a, b) {
                return b.techfitCalcs.normalScore - a.techfitCalcs.normalScore;
            });
            var ranksNormal = validRows.slice().map(function (v) {
                return sortedNormal.indexOf(v) + 1;
            });

            var results = [];
            for (var i = 0; i < validRows.length; i++) {
                var thisIntv = validRows[i];
                thisIntv.techfitCalcs.rawRank = ranksRaw[i];
                thisIntv.techfitCalcs.normalRank = ranksNormal[i];
                results.push(thisIntv);
            }
            self.interventions(results);

            for (var i = 0; i < self.normalRankings().length; i++) {
                if (i > 0) {
                    if (self.normalRankings()[i].techfitCalcs.normalScore === self.normalRankings()[i - 1].techfitCalcs.normalScore) {
                        self.normalRankings()[i].techfitCalcs.normalRank = self.normalRankings()[i - 1].techfitCalcs.normalRank;
                    }
                }
            }

            for (var i = 0; i < self.rawRankings().length; i++) {
                if (i > 0) {
                    if (self.rawRankings()[i].techfitCalcs.rawScore === self.rawRankings()[i - 1].techfitCalcs.rawScore) {
                        self.rawRankings()[i].techfitCalcs.rawRank = self.rawRankings()[i - 1].techfitCalcs.rawRank;
                    }
                }
            }
        };

        self.getCoreNarrative = ko.computed(function () {
            if (self.selectedIntervention() == null) {
                return {};
            }
            var narrative = {};
            narrative.rationales = [];
            var baseScale = ["Little or no", "Low", "Moderate", "High", "Very high"];
            var severityScale = ["N/A", "a minor", "a moderate", "a major", "a major"]; // 3-4 both major
            var potentialScale = ["little or no", "a low", "a moderate", "a high", "a very high"];

            var potentialScore = self.selectedIntervention().techfitCalcs.normalMitigationPotential;

            narrative.description = "Overall, the scores suggest that this intervention has " + potentialScale[Math.floor((potentialScore / 20) * 4)] + " potential to mitigate the area's core constraints."

            var dryBase = self.selectedIntervention().mitigate_season_feed_scarcity_dry_cool;
            var growingBase = self.selectedIntervention().mitigate_season_feed_scarcity_growing;
            var qualityBase = self.selectedIntervention().mitigate_quantity_constraint;
            var quantityBase = self.selectedIntervention().mitigate_quality_constraint;

            var drySeverity = self.assessmentScores[1].score;
            var growingSeverity = self.assessmentScores[2].score;
            var qualitySeverity = self.assessmentScores[3].score;
            var quantitySeverity = self.assessmentScores[4].score;

            if (drySeverity > 0) {
                narrative.rationales.push(baseScale[dryBase] + " potential to mitigate the area's dry season feed scarcity issues, which the survey rated as " + severityScale[drySeverity] + " constraint");
            }
            if (growingSeverity > 0) {
                narrative.rationales.push(baseScale[growingBase] + " potential to mitigate the area's growing season feed scarcity issues, which the survey rated as " + severityScale[growingSeverity] + " constraint");
            }
            if (qualitySeverity > 0) {
                narrative.rationales.push(baseScale[qualityBase] + " potential to mitigate the area's feed quality issues, which the survey rated as " + severityScale[qualitySeverity] + " constraint");
            }
            if (quantitySeverity > 0) {
                narrative.rationales.push(baseScale[quantityBase] + " potential to mitigate the area's feed quantity issues, which the survey rated as " + severityScale[quantitySeverity] + " constraint");
            }

            narrative.weight = self.assessment().weight_core_feed_issue;

            return narrative;
        });

        self.getCommodityNarrative = ko.computed(function () {
            if (self.selectedIntervention() == null) {
                return {};
            }
            var narrative = {};

            var baseScale = ["generally unsuitable", "barely suitable", "somewhat suitable", "highly suitable", "very highly suitable"];
            var typeLabel = "";
            var suitability = 0;

            switch (self.assessment().id_core_commodity) {
                case 1:
                    suitability = self.selectedIntervention().commodity_cattle_buffalo_breeding;
                    typeLabel = "cattle / buffalo breeding (cow-calf)";
                    break;
                case 2:
                    suitability = self.selectedIntervention().commodity_cattle_buffalo_fattening;
                    typeLabel = "cattle / buffalo fattening";
                    break;
                case 3:
                    suitability = self.selectedIntervention().commodity_cattle_buffalo_dairy;
                    typeLabel = "dairy cattle / buffalo";
                    break;
                case 4:
                    suitability = self.selectedIntervention().commodity_sheep_goat_breeding;
                    typeLabel = "sheep / goat breeding";
                    break;
                case 5:
                    suitability = self.selectedIntervention().commodity_sheep_goat_fattening;
                    typeLabel = "sheep / goat fattening";
                    break;
                case 6:
                    suitability = self.selectedIntervention().commodity_pig_breeding;
                    typeLabel = "pig breeding (sow-piglets)";
                    break;
                case 7:
                    suitability = self.selectedIntervention().commodity_pig_fattening;
                    typeLabel = "pig fattening";
                    break;
            }

            narrative.description = "This intervention is considered " + baseScale[suitability] + " for communities reliant on " + typeLabel + ".";
            narrative.weight = self.assessment().weight_commodity;
            return narrative;

        });

        self.getSystemNarrative = ko.computed(function () {
            if (self.selectedIntervention() == null) {
                return {};
            }
            var narrative = {};

            var baseScale = ["generally unsuitable", "barely suitable", "somewhat suitable", "highly suitable", "very highly suitable"];
            var typeLabel = "";
            var suitability = 0;

            switch (self.assessment().id_agriculture_system_type) {
                case 1:
                    suitability = self.selectedIntervention().system_pastoral;
                    typeLabel = "pastoral (extensive grazing systems)";
                    break;
                case 2:
                    suitability = self.selectedIntervention().system_agro_pastoral;
                    typeLabel = "agro-pastoral / extensive mixed systems";
                    break;
                case 3:
                    suitability = self.selectedIntervention().system_intensive_mixed;
                    typeLabel = "intensive mixed crop-livestock system (including trees)";
                    break;
                case 4:
                    suitability = self.selectedIntervention().system_landless;
                    typeLabel = "landless livestock producers (intensive)";
                    break;
            }

            narrative.description = "This intervention is considered " + baseScale[suitability] + " for communities where the farming system is largely " + typeLabel + ".";
            narrative.weight = self.assessment().weight_fs;
            return narrative;

        });

        self.getAttributeNarrative = ko.computed(function () {
            if (self.selectedIntervention() == null) {
                return {};
            }
            var narrative = {descriptions: []};

            var intvAttrScale = ["N/A", "very high", "high", "medium", "no or low"];
            var scoreAttrScale = ["no", "low", "medium", "high", "very high"];
            var baseScale = ["Too resource-intensive", "Possible (but not ideal)", "Generally reasonable", "Highly reasonable", "Very highly reasonable"];

            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchLand / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[8].score] + " land availability.");
            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchWater / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[5].score] + " water availability.");
            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchLabour / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[6].score] + " labour availability.");
            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchCapital / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[7].score] + " cash / credit availability.");
            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchInput / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[9].score] + " input delivery availability.");
            narrative.descriptions.push(baseScale[Math.floor((self.selectedIntervention().techfitCalcs.attrMatchKnowledge / 16) * 4)] + " for communities with " + scoreAttrScale[self.assessmentScores[10].score] + " knowledge / skill availability.");
            narrative.weight = self.assessment().weight_context_attribute;
            return narrative;

        });

        self.getImpactNarrative = ko.computed(function () {
            if (self.selectedIntervention() == null) {
                return {};
            }
            var narrative = {};

            var baseScale = ["no", "a low", "a moderate", "a high", "a very high"];

            narrative.description = "Where suitable, this intervention is expected to have " + baseScale[self.selectedIntervention().impact] + " impact.";
            narrative.weight = self.assessment().weight_impact;
            return narrative;
        });

        self.clearSort = function () {
            self.lastSort = self.currentSort();
            self.currentSort("none");
            self.currentSort.notifySubscribers();
        };

        self.sortCore = function () {
            self.lastSort = self.currentSort();
            self.currentSort("core");
            self.currentSort.notifySubscribers();
        };

        self.sortCommodity = function () {
            self.lastSort = self.currentSort();
            self.currentSort("commodity");
            self.currentSort.notifySubscribers();
        };

        self.sortSystem = function () {
            self.lastSort = self.currentSort();
            self.currentSort("system");
            self.currentSort.notifySubscribers();
        };

        self.sortAttribute = function () {
            self.lastSort = self.currentSort();
            self.currentSort("attribute");
            self.currentSort.notifySubscribers();
        };

        self.sortImpact = function () {
            self.lastSort = self.currentSort();
            self.currentSort("impact");
            self.currentSort.notifySubscribers();
        };

        self.openDetails = function (intervention) {
            gui.Shell.openExternal(intervention.detail_link);
        };

        self.showExplanations = function () {
            $('#modal-explanation').modal('show');
        };

    }
};//end onload

function unfloatRound(value, decimalPoint) {
    var dpAdjust = Math.pow(10, decimalPoint);
    return Number((Math.round(value * dpAdjust) + 'e2') / dpAdjust + 'e-2');
}
