﻿// FEAST Data Utility
// Designed by the International Livestock Research Institute (www.ilri.org)
// Developed by Emil Heidkamp, Dmitriy Galihin, Craig Simmons and Erik Reppen (www.sonatatechnologysolutions.com)

// *** DECLARE GLOBAL VARIABLES ***

const
    field_delimiter = '|';

var
    focus_group_edit_prev_action: string;
    PrevAction: string;
    idRecord: integer;
    id_respondent_record: integer;
    id_focus_group_record: integer;
    id_site_record: integer;
    id_techfit_assessment_record: integer;
    currency_label: extended;
    grid_record_count: integer;
    techfit_assessment_new_record: integer;
    respondent_new_record: integer;
    focus_group_new_record: integer;
    new_custom_livestock_species_id: integer;
    techfit_grid_select: boolean;
    add_category_from_species_flag: integer;
    report_export_filter: string;
    report_export_filter_short: string;
    report_export_gender_filter: string;
    report_export_gender_filter_short: string;
    report_export_id: integer;
    report_export_level: string;
    report_export_label: string;
    count_blanks: integer;
    registration_volume_serial: string;
    registration_concatenated_id: string;
    registration_exact_time_stamp: string;
    registration_concat_check: string;
    stamp_incremental: integer;
    import_directory: string;
    global_action: string;
    report_path: string;
    create_gendered_fg: boolean;
    create_fg_f: boolean;

// Registration

    register_first_name: string;
    register_last_name: string;
    register_org: string;
    register_version: extended;
    registration_existing_volume_serial: string;
    registration_existing_random_id: string;
    registration_random_id: integer;
    registration_application_path: string;
    registration_existing_application_path: string;
    registration_application_drive_and_path: string;
    display_serial: string;
    registration_first_name: string;

// For Validations

    ignore_validation: integer;
    button_fail: integer;

// Animal Type weights

    animal_type_weight_min: extended;
    animal_type_weight_max: extended;

// *** FORM FUNCTIONS ***

procedure respondent_edit_grid_market_prices_OnChange (Sender: TObject);
var
    i: integer;
begin
try
    for i := 0 to respondent_edit.grid_market_prices.RowCount-1 do respondent_edit.grid_market_prices.Cell[1,i].Empty := False; // for the second column
    for i := 0 to respondent_edit.grid_market_prices.RowCount-1 do respondent_edit.grid_market_prices.Cell[2,i].Empty := False; // for the third column
    for i := 0 to respondent_edit.grid_market_prices.RowCount-1 do respondent_edit.grid_market_prices.Cell[3,i].Empty := False; // for the fourth column
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure edit_coop_membership_OnShow (Sender: TObject; Action: string);
begin
try

// Stamp the record

    edit_coop_membership.stamp_updated_at.Checked := TRUE;
    edit_coop_membership.stamp_updated_at.DateTime := Now;
    edit_coop_membership.stamp_updated_by.Text := registration_concatenated_id;
    if edit_coop_membership.stamp_created_by.Text = '' then
        begin
        edit_coop_membership.stamp_created_by.Text := registration_concatenated_id;
        edit_coop_membership.stamp_created_at.Checked := TRUE;
        edit_coop_membership.stamp_created_at.DateTime:= Now;
    end;
    if edit_coop_membership.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        edit_coop_membership.stamp_unique_identifier.Text := 'cm_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_coop_edit_delete_OnClick (Sender: TObject; var Cancel: boolean);
begin
try
    if (ignore_validation = 0) then
    begin
    if (respondent_edit.grid_coop_membership.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure edit_income_source_women_OnShow (Sender: TObject; Action: string);
begin
try

// Stamp the record

    edit_income_source_women.stamp_updated_at.Checked := TRUE;
    edit_income_source_women.stamp_updated_at.DateTime := Now;
    edit_income_source_women.stamp_updated_by.Text := registration_concatenated_id;
    if edit_income_source_women.stamp_created_by.Text = '' then
        begin
        edit_income_source_women.stamp_created_by.Text := registration_concatenated_id;
        edit_income_source_women.stamp_created_at.Checked := TRUE;
        edit_income_source_women.stamp_created_at.DateTime:= Now;
    end;
    if edit_income_source_women.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        edit_income_source_women.stamp_unique_identifier.Text := 'wicsr_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_button_edit_gender_labour_OnClick (Sender: TObject; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_gender_labor.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure feed_labor_edit_OnShow (Sender: TObject; Action: string);
begin
try
    feed_labor_edit.stamp_updated_at.Checked := TRUE;
    feed_labor_edit.stamp_updated_at.DateTime := Now;
    feed_labor_edit.stamp_updated_by.Text := registration_concatenated_id;
    if feed_labor_edit.stamp_created_by.Text = '' then
    begin
        feed_labor_edit.stamp_created_by.Text := registration_concatenated_id;
        feed_labor_edit.stamp_created_at.Checked := TRUE;
        feed_labor_edit.stamp_created_at.DateTime:= Now;
    end;
        if feed_labor_edit.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        feed_labor_edit.stamp_unique_identifier.Text := 'fld_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

    idRecord := feed_labor_edit.button_submit.dbGeneralTableId;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure feed_labor_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    feed_labor_edit.button_submit.dbDoCloseForm := False;
    feed_labor_edit.button_submit.Click;
    feed_labor_populate_grid();
    feed_labor_edit.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_gender_labor.SelectedRow := respondent_edit.grid_gender_labor.SelectedRow -1;
    if respondent_edit.grid_gender_labor.SelectedRow < 0 then respondent_edit.grid_gender_labor.SelectedRow := 0;
    respondent_edit.button_edit_gender_labour.Click;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure feed_labor_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    grid_record_count := SQLExecute('SELECT COUNT(*) FROM feed_labor_type');
    feed_labor_edit.button_submit.dbDoCloseForm := False;
    feed_labor_edit.button_submit.Click;
    feed_labor_populate_grid();
    feed_labor_edit.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_gender_labor.SelectedRow := respondent_edit.grid_gender_labor.SelectedRow +1;
    if respondent_edit.grid_gender_labor.SelectedRow > grid_record_count then respondent_edit.grid_gender_labor.SelectedRow := grid_record_count;
    respondent_edit.button_edit_gender_labour.Click;
 except
    ShowMessage(ExceptionMessage);
end;
end;

procedure gender_decision_edit_OnShow (Sender: TObject; Action: string);
begin
try
    // Stamp the record
    gender_decision_edit.stamp_updated_at.Checked := TRUE;
    gender_decision_edit.stamp_updated_at.DateTime := Now;
    gender_decision_edit.stamp_updated_by.Text := registration_concatenated_id;
    if gender_decision_edit.stamp_created_by.Text = '' then
    begin
        gender_decision_edit.stamp_created_by.Text := registration_concatenated_id;
        gender_decision_edit.stamp_created_at.Checked := TRUE;
        gender_decision_edit.stamp_created_at.DateTime:= Now;
    end;                                      

    idRecord := gender_decision_edit.button_submit.dbGeneralTableId;
    gender_decision_edit.textbox_decision_type.Text := SQLExecute( 'SELECT decision_type.description FROM decision_making_by_household LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision LEFT OUTER JOIN decision_type ON decision_type.id = decision.id_decision_type WHERE decision_making_by_household.id = '+IntToStr(idRecord) );
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_combo_hh_gender_OnChange (Sender: TObject);
begin
try
    idRecord := respondent_edit.combo_hh_gender.dbItemID;
    respondent_edit.textbox_hh_gender.Text := SQLExecute( 'SELECT gender.description FROM gender WHERE gender.id = '+IntToStr(idRecord) );
    if respondent_edit.textbox_hh_gender.Text = 'female' then
    begin
      respondent_edit.checkbox_hh_female_managed.Checked := true;
      end else
      begin
      respondent_edit.checkbox_hh_female_managed.Checked := false;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure focus_group_edit_fg_convert_ng_OnClick (Sender: TObject; var Cancel: boolean);
var
    dialog_response: Integer;
begin
try
    dialog_response := MessageDlg('Are you sure you want to convert this gendered focus group to non-gendered? This cannot be reversed!', mtConfirmation, mbYes+mbNo, 0);
    if dialog_response = mrYes then
    begin
    focus_group_edit.fg_convert_ng.Visible := false;
    id_focus_group_record := focus_group_edit.button_submit.dbGeneralTableId;
    SQLExecute('UPDATE focus_group SET id_gender = null WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.GroupBox1.Left := 104;
    focus_group_edit.GroupBox1.Width := 469;
    focus_group_edit.GroupBox7.Visible := false;
    focus_group_edit.label_participants_female.Top := 152;
    focus_group_edit.textbox_participants_female.Top := 152;
    focus_group_edit.label_participants_male.Top := 184;
    focus_group_edit.textbox_participants_male.Top := 184;
    focus_group_edit.label_participants_female.Visible := true;
    focus_group_edit.textbox_participants_female.Visible := true;
    focus_group_edit.label_participants_male.Visible := true;
    focus_group_edit.textbox_participants_male.Visible := true;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure choose_focus_group_type_new_fg_OnClick (Sender: TObject; var Cancel: boolean);
begin
try
   create_gendered_fg := false;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure choose_focus_group_type_new_fg_f_OnClick (Sender: TObject; var Cancel: boolean);
begin
try
   create_gendered_fg := true;
   create_fg_f := true;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure choose_focus_group_type_new_fg_m_OnClick (Sender: TObject; var Cancel: boolean);
begin
try
   create_gendered_fg := true;
   create_fg_f := false;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure view_intervention_ranking (Sender: string; var Cancel: boolean);
begin
try
    id_techfit_assessment_record := techfit_assessment_edit.button_submit.dbGeneralTableId;
    techfit_assessment_edit.button_submit.dbDoCloseForm := False;
    techfit_assessment_edit.button_submit.dbDontResetID := True;
    techfit_assessment_edit.button_submit.Click;
    techfit_assessment_edit.button_submit.dbDoCloseForm := True;
    OpenFile('techfit '+IntToStr(id_techfit_assessment_record), report_path+'System\Viewer\nw.exe');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure techfit_assessment_default_weight (Sender: string; var Cancel: boolean);
begin
try
    techfit_assessment_edit.weight_commodity.Value := SQLExecute('SELECT commodity FROM techfit_defaults WHERE id = 1');
    techfit_assessment_edit.weight_core_feed.Value := SQLExecute('SELECT core_feed_issue FROM techfit_defaults WHERE id = 1');
    techfit_assessment_edit.weight_fs.Value := SQLExecute('SELECT fs FROM techfit_defaults WHERE id = 1');
    techfit_assessment_edit.weight_context.Value := SQLExecute('SELECT context_attribute FROM techfit_defaults WHERE id = 1');
    techfit_assessment_edit.weight_impact.Value := SQLExecute('SELECT impact FROM techfit_defaults WHERE id = 1');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure launch_report_browser (Sender: string; Action: string);
begin
try
    OpenFile('landholding_stats byFocusGroup 1', report_path+'System\Viewer\nw.exe');
except
    ShowMessage(ExceptionMessage);
end;
end;

// populate currency field by country

procedure auto_pop_currency (Sender: string; Action: string);
var
    country_lookup_currency: integer;
begin
try
    idRecord := project_edit_site.combo_country.dbItemID;
    country_lookup_currency := SQLExecute('SELECT currency.id FROM country LEFT OUTER JOIN currency ON currency.id = country.id_currency WHERE country.id = '+IntToStr(idRecord) );
    project_edit_site.combo_currency.dbItemId := country_lookup_currency;
except
    ShowMessage(ExceptionMessage);
end;
end;

// edit_data filter by project

procedure enter_data_filter_program (Sender: string; Action: string);
begin
try
    idRecord:=enter_data.combo_project.dbItemId;
    enter_data.grid_focus_group.dbSQL:='SELECT focus_group.meeting_date_time, focus_group.community, focus_group.venue_name, focus_group.id FROM project LEFT OUTER JOIN site ON site.id_project = project.id INNER JOIN focus_group ON focus_group.id_site = site.id WHERE project.id = '+IntToStr(idRecord);
    enter_data.grid_focus_group.dbListFieldsNames :='Date/Time, Community, Venue, id';
    enter_data.grid_focus_group.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

// edit_data filter by project

procedure techfit_filter_program (Sender: string; Action: string);
begin
try
    idRecord:=techfit_assessments.combo_project.dbItemId;
    techfit_assessments.grid_techfit_assessments.dbSQL:='SELECT techfit_assessment.title, techfit_assessment.id FROM project LEFT OUTER JOIN site ON site.id_project = project.id INNER JOIN techfit_assessment ON techfit_assessment.id_site = site.id WHERE project.id = '+IntToStr(idRecord);
    techfit_assessments.grid_techfit_assessments.dbListFieldsNames :='Title, ID';
    techfit_assessments.grid_techfit_assessments.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Populate and stamp the techfit_assessment record      WAXY

procedure techfit_assessment_onshow (Sender: string; Action: string);
var
   i, c: integer;
   techfit_rowcount: integer;
   ta_site_caption: string;
   ta_fg_test: integer;
begin
try
techfit_assessment_edit.tabs_techfit_assessment_data.ActivePageIndex := 0;

// Stamp the record

    techfit_assessment_edit.stamp_updated_at.Checked := TRUE;
    techfit_assessment_edit.stamp_updated_at.DateTime := Now;
    techfit_assessment_edit.stamp_updated_by.Text := registration_concatenated_id;
    if techfit_assessment_edit.stamp_created_by.Text = '' then
        begin
        techfit_assessment_edit.stamp_created_by.Text := registration_concatenated_id;
        techfit_assessment_edit.stamp_created_at.Checked := TRUE;
        techfit_assessment_edit.stamp_created_at.DateTime:= Now;
    end;
    if techfit_assessment_edit.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        techfit_assessment_edit.stamp_unique_identifier.Text := 'tfas_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

PrevAction := Action;

    if Action='NewRecord' then
    begin
        techfit_assessment_new_record := 1;
        techfit_assessment_edit.button_submit.Tag := 1;
        techfit_assessment_edit.combo_site_id.dbItemID := techfit_assessments.combo_site.dbItemID;
        techfit_assessment_edit.button_submit.dbDoCloseForm := False;
        techfit_assessment_edit.button_submit.dbDontResetID := True;
        techfit_assessment_edit.button_submit.Click;

 // Get the record number

    id_techfit_assessment_record := techfit_assessment_edit.button_submit.dbGeneralTableId;

 // generate the core context records

        SQLExecute('INSERT INTO core_context_attribute_score (id_core_context_attribute) SELECT (id) FROM core_context_attribute');
        stamp_incremental := SQLExecute('SELECT COUNT (*) FROM core_context_attribute');
        for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE core_context_attribute_score SET id_techfit_assessment = ('+IntToStr(id_techfit_assessment_record)+'), created_by = "'+registration_concatenated_id+'", created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_at="'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by="'+registration_concatenated_id+'", unique_identifier="ccas_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id_techfit_assessment IS NULL AND id_core_context_attribute = '+IntToStr(i));
        end;

// Copy over the default weighting

        SQLExecute('UPDATE techfit_assessment SET weight_core_feed_issue = (SELECT core_feed_issue FROM techfit_defaults WHERE id = 1), weight_commodity = (SELECT commodity FROM techfit_defaults WHERE id = 1), weight_fs = (SELECT fs FROM techfit_defaults WHERE id = 1), weight_context_attribute = (SELECT context_attribute FROM techfit_defaults WHERE id = 1), weight_impact = (SELECT impact FROM techfit_defaults WHERE id = 1) WHERE id = '+IntToStr(id_techfit_assessment_record) );

 // Close and re-open

        techfit_assessment_edit.button_submit.Click;
        techfit_assessments.hidden_button_search_techfit.Click;
        techfit_rowcount := (techfit_assessments.grid_techfit_assessments.RowCount) - 1;
        techfit_assessments.grid_techfit_assessments.SelectedRow := techfit_rowcount;
        techfit_assessments.button_edit_techfit.Click;
        techfit_assessment_edit.button_submit.dbDoCloseForm := True;
        techfit_assessment_edit.button_submit.Tag := 0;
        ignore_validation := 0;

    end;

id_techfit_assessment_record := techfit_assessment_edit.button_submit.dbGeneralTableId;

// Populate the labels

    ta_site_caption := SQLExecute('SELECT site.name FROM site WHERE site.id = '+IntToStr(techfit_assessment_edit.combo_site_id.dbItemID) );
    techfit_assessment_edit.label_site_name.Caption := ta_site_caption;
    techfit_assessment_edit.alt_title.Visible := False;
    techfit_assessment_edit.title.Visible := True;
    ta_fg_test := SQLExecute('SELECT COUNT (*) FROM techfit_assessment WHERE id_focus_group IS NULL AND id = '+IntToStr(id_techfit_assessment_record)+' LIMIT 1' );
    techfit_assessment_edit.alt_title.Caption := SQLExecute('SELECT title FROM techfit_assessment WHERE id = '+IntToStr(id_techfit_assessment_record) );

    if ta_fg_test = 0 then
    begin
    techfit_assessment_edit.alt_title.Visible := True;
    techfit_assessment_edit.title.Visible := False;
    end;


except
    ShowMessage(ExceptionMessage);
end;
end;


procedure  grid_core_context_techfit_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (techfit_assessment_edit.grid_core_context.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    techfit_grid_select := TRUE;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure techfit_assessments_assign_titles (Sender: string; Action: string);
begin
try
SQLExecute('UPDATE techfit_assessment SET title = (SELECT meeting_date_time FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) || '' '' || (SELECT community FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) || '' '' || (SELECT venue_name FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) WHERE techfit_assessment.title IS NULL');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_techfit_assessment_edit_submit (Sender: string; var Cancel: boolean);
var
    id_core_commodity_selected: integer;
    id_agriculture_system_selected: integer;
    buttonSelected : Integer;
    techfit_assessment_title : string;
    validate_skip : Integer;
    dialog_response: Integer;
    count_blanks: Integer;
    stamp_update: string;

begin
try

// Ignore during auto-save process when creating a new record

    if techfit_assessment_edit.button_submit.Tag=1 then exit;


    if (techfit_assessment_edit.title.Text='')then
    begin
        ShowMessage('Enter a title for the assessment.');
        Cancel := True;
    end;
   count_blanks := SQLExecute('SELECT COUNT (*) FROM core_context_attribute_score LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id = core_context_attribute_score.id_techfit_assessment LEFT OUTER JOIN focus_group ON focus_group.id = techfit_assessment.id_focus_group WHERE core_context_attribute_score.id_techfit_scale IS NULL AND techfit_assessment.id = '+IntToStr(id_techfit_assessment_record) );
   if count_blanks > 0 then
   begin
       ShowMessage('Please enter all of the core context attributes / feed attribute scores (Feed / Context Issues Tab)');
       Cancel := True;
   end;
   if (techfit_assessment_edit.combo_core_commodity.dbItemID = -1) OR (techfit_assessment_edit.combo_agricultural_system.dbItemID = -1) then
   begin
       ShowMessage('Please select a description for the agricultural system and core commodity (Feed / Context Issues Tab)');
       Cancel := True;
   end;

if Cancel <> True then
begin
techfit_assessment_new_record := 0;
end;

except
    ShowMessage(ExceptionMessage);
end;
end;




// techfit_assessments filter by project

procedure techfit_assessments_filter_program (Sender: string; Action: string);
begin
try
    idRecord:=techfit_assessments.combo_project.dbItemId;
    techfit_assessments.grid_techfit_assessments.dbSQL:='SELECT techfit_assessment.title FROM project LEFT OUTER JOIN site ON site.id_project = project.id INNER JOIN techfit_assessment ON techfit_assessment.id_site = site.id LEFT OUTER JOIN focus_group ON techfit_assessment.id_focus_group = focus_group.id WHERE project.id = '+IntToStr(idRecord);
    techfit_assessments.grid_techfit_assessments.dbListFieldsNames :='Title';
    techfit_assessments.grid_techfit_assessments.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

//the labels on the focus group form on changes to relevant fields

 procedure focus_group_label_OnChange (Sender: string; Action: string);
 begin
 try
 focus_group_edit.label_focus_group_title.Caption := DateToStr(focus_group_edit.date_meeting.Date)+' '+focus_group_edit.textbox_community.Text+' '+focus_group_edit.textbox_venue.Text;
 except
    ShowMessage(ExceptionMessage);
 end;
 end;

// Change landholding min/max for "Average" farm on updating min/max values for "Small" and "Large" farms.

   procedure household_land_holding_OnChange (Sender: string; Action: string);
begin
try
    focus_group_edit.textbox_medium_threshold_large.Text := focus_group_edit.textbox_threshold_large.Text;
    focus_group_edit.textbox_medium_threshold_small.Text := focus_group_edit.textbox_threshold_small.Text;
except
    ShowMessage(ExceptionMessage);
end;
end;

   procedure percent_land_holding_OnChange (Sender: string; Action: string);
begin
try
    focus_group_edit.textbox_sum_landholding_pct.Value := focus_group_edit.textbox_hh_landless.Value +  focus_group_edit.textbox_hh_small.Value + focus_group_edit.textbox_hh_medium.Value + focus_group_edit.textbox_hh_large.Value;
    if focus_group_edit.textbox_sum_landholding_pct.Value = 100 then
    begin
    focus_group_edit.textbox_sum_landholding_pct.Color := $00EEFFDD;
    end else
    begin
    focus_group_edit.textbox_sum_landholding_pct.Color := $00EBE2FE;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure percent_land_hh_gender_OnChange(Sender: string; Action: string);
begin
try
    focus_group_edit.percent_hh_landless_m.Value := 100 - focus_group_edit.percent_hh_landless_f.Value;
    focus_group_edit.percent_hh_small_m.Value := 100 - focus_group_edit.percent_hh_small_f.Value;
    focus_group_edit.percent_hh_med_m.Value := 100 - focus_group_edit.percent_hh_med_f.Value;
    focus_group_edit.percent_hh_large_m.Value := 100 - focus_group_edit.percent_hh_large_f.Value;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Update percentage totals on respondent_edit_availability_data

procedure percent_feed_availability_OnChange (Sender: string; Action: string);
var
    name_month: string;
begin
try
    name_month := respondent_edit_availability_data.textbox_month.Text;
    respondent_edit_availability_data.textbox_diet_composition_total.Value := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM month LEFT OUTER JOIN feed_source_availability ON feed_source_availability.id_month = month.id WHERE month.name = "'+name_month+'" AND feed_source_availability.id_respondent = '+IntToStr(id_respondent_record) );
    respondent_edit_availability_data.grid_feed_availability.dbSQL:='SELECT feed_source_availability.id, feed_source.list_order, feed_source.description, feed_source_availability.percentage FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source_availability.id_feed_source = feed_source.id LEFT OUTER JOIN month ON feed_source_availability.id_month = month.id WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = "'+name_month+'" ORDER BY feed_source.list_order DESC';
    respondent_edit_availability_data.grid_feed_availability.dbGeneralTable := 'feed_source_availability';
    respondent_edit_availability_data.grid_feed_availability.dbListFieldsNames :='delete_col, Order, Source, Rating';
    respondent_edit_availability_data.grid_feed_availability.dbSQLExecute;

    respondent_edit_availability_data.grid_feed_availability.Columns[0].Visible := False;

    if respondent_edit_availability_data.textbox_diet_composition_total.Value = 10 then
    begin
    respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EEFFDD;
    end else
    if respondent_edit_availability_data.textbox_diet_composition_total.Value > 0 then
    begin
    respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EBE2FE;
    end else
    begin
    respondent_edit_availability_data.textbox_diet_composition_total.Color := $00F2F2F2;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure percent_feed_availability_grid_OnChange (Sender: string; Action: String);
var
    name_month: string;
begin
try
   name_month := respondent_edit_availability_data.textbox_month.Text;
   respondent_edit_availability_data.textbox_diet_composition_total.Value := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM month INNER JOIN feed_source_availability ON feed_source_availability.id_month = month.id WHERE month.name = "'+name_month+'" AND feed_source_availability.id_respondent = '+IntToStr(id_respondent_record) );
   respondent_edit_availability_data.grid_feed_availability.Columns[0].Visible := False;

   if respondent_edit_availability_data.textbox_diet_composition_total.Value = 10 then
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EEFFDD;
        end else
        begin
           if respondent_edit_availability_data.textbox_diet_composition_total.Value > 0 then
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EBE2FE;
        end else
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00F2F2F2;
        end;
        end;

except
    ShowMessage(ExceptionMessage);
end;
end;


// Make sure the registration info record is selected

procedure edit_registration_OnClick (Sender: string; Action: string);
begin
try
home_menu.hidden_grid_registration.SelectedRow := 0;
except
    ShowMessage(ExceptionMessage);
end;
end;


// Update percentage totals on respondent_edit_crop

procedure percent_crop_residue_OnChange (Sender: string; Action: string);
begin
try
   respondent_edit_crop.textbox_total.Value := respondent_edit_crop.textbox_percent_other.Value + respondent_edit_crop.textbox_percent_burned.Value + respondent_edit_crop.textbox_percent_fed.Value + respondent_edit_crop.textbox_percent_sold.Value + respondent_edit_crop.textbox_percent_mulched.Value;
    if respondent_edit_crop.textbox_total.Value = 100 then
    begin
    respondent_edit_crop.textbox_total.Color := $00EEFFDD;
    end else
    if respondent_edit_crop.textbox_total.Value > 0 then
    begin
    respondent_edit_crop.textbox_total.Color := $00EBE2FE;
    end else
    begin
    respondent_edit_crop.textbox_total.Color := $00F2F2F2;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Change head of household information

procedure head_household_read_write_toggle (Sender: string; Action: string);
begin
try
      if respondent_edit.checkbox_respondent_hh.Checked then
      begin
          respondent_edit.textbox_hh_name.ReadOnly := True;
          respondent_edit.textbox_hh_name.Text := respondent_edit.textbox_respondent_name.Text;
          respondent_edit.combo_hh_gender.Visible := False;
          respondent_edit.combo_hh_gender.dbItemID := respondent_edit.combo_respondent_gender.dbItemID;
          respondent_edit.textbox_hh_gender.Visible := True;
          respondent_edit.textbox_hh_age.ReadOnly := True;
          respondent_edit.textbox_hh_age.Text := respondent_edit.textbox_respondent_age.Text;
          idRecord := respondent_edit.combo_hh_gender.dbItemID;
          respondent_edit.textbox_hh_gender.Text := SQLExecute( 'SELECT gender.description FROM gender WHERE gender.id = '+IntToStr(idRecord) );
          respondent_edit.textbox_hh_name.Color := $00F2F2F2;
          respondent_edit.textbox_hh_age.Color := $00F2F2F2;
      end else
      begin
          respondent_edit.textbox_hh_name.Color := $00FFFFFF;
          respondent_edit.textbox_hh_age.Color := $00FFFFFF;
          respondent_edit.textbox_hh_name.ReadOnly := False;
          respondent_edit.textbox_hh_age.ReadOnly := False;
          respondent_edit.textbox_hh_name.clear;
          respondent_edit.textbox_hh_age.clear;
          respondent_edit.textbox_hh_gender.Visible := False;
          respondent_edit.combo_hh_gender.Visible := True;
      end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure copy_respondent_data_hh (Sender: string; Action: string);
var
    current_gender: string;
    current_gender_description: string;
begin
try
// Validate focus group gender matches respondent
   if (focus_group_edit.fg_convert_ng.Visible = true) AND (respondent_edit.combo_respondent_gender.dbItemID <> -1) then
   begin
     current_gender := SQLExecute( 'SELECT focus_group.id_gender FROM focus_group WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
     if IntToStr(respondent_edit.combo_respondent_gender.dbItemID) <> current_gender then
     begin
        current_gender_description := SQLExecute( 'SELECT gender.description FROM focus_group LEFT OUTER JOIN gender ON gender.id = focus_group.id_gender WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        ShowMessage('You cannot add a respondent of this gender to the focus group. Only '+current_gender_description+' respondents may be added.');
     end;
   end;

// update label if necessary

    respondent_edit.label_respondent_name.Caption := respondent_edit.textbox_respondent_name.Text;

// copy data over to hh box

    if respondent_edit.checkbox_respondent_hh.Checked then
    begin
    respondent_edit.textbox_hh_name.Text := respondent_edit.textbox_respondent_name.Text;
    respondent_edit.textbox_hh_age.Text := respondent_edit.textbox_respondent_age.Text;
    respondent_edit.combo_hh_gender.dbItemID := respondent_edit.combo_respondent_gender.dbItemID;
    idRecord := respondent_edit.combo_hh_gender.dbItemID;
    respondent_edit.textbox_hh_gender.Text := SQLExecute( 'SELECT gender.description FROM gender WHERE gender.id = '+IntToStr(idRecord) );
    if respondent_edit.textbox_hh_gender.Text = 'female' then
      begin
        respondent_edit.checkbox_hh_female_managed.Checked := true;
      end else
      begin
        respondent_edit.checkbox_hh_female_managed.Checked := false;
      end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

// *** PRE-POPULATE FORMS WITH RELATED DATA ***

// Populate registered user info

procedure splash_screen_OnShow (Sender: string; Action: string);
begin
try
 splash_screen.BorderIcons:= 0; // Allows you to hide all the windows system buttons

// Registration Check

    registration_application_drive_and_path := ExtractFilePath(Application.ExeName);
    report_path := registration_application_drive_and_path;
    delete(registration_application_drive_and_path, 1, 3);
    registration_application_path := registration_application_drive_and_path;
    registration_volume_serial := GetHardDiskSerial(ExtractFileDrive(Application.Exename));
    registration_existing_volume_serial := SQLExecute('SELECT app_registration.hard_drive_volume_serial FROM app_registration WHERE app_registration.id = 1');
    registration_concat_check := SQLExecute('SELECT app_registration.concatenated_identifier FROM app_registration WHERE app_registration.id = 1');
    registration_existing_application_path := SQLExecute('SELECT app_registration.app_path FROM app_registration WHERE app_registration.id = 1');
    registration_existing_random_id := SQLExecute('SELECT app_registration.random_identifier FROM app_registration WHERE app_registration.id = 1');
    registration_first_name :=  SQLExecute('SELECT app_registration.name_first FROM app_registration WHERE app_registration.id = 1');
    if (registration_existing_volume_serial = '') OR (registration_first_name = '') OR (registration_existing_random_id = '') OR (registration_existing_application_path <> registration_application_path) OR (registration_volume_serial <> registration_existing_volume_serial) OR (registration_concat_check = '') then
    begin
    registration_random_id := Trunc(Random * 999999999);
    SQLExecute('UPDATE app_registration SET hard_drive_volume_serial = "'+registration_volume_serial+'", random_identifier = "'+IntToStr(registration_random_id)+'", app_path = "'+registration_application_path+'" WHERE app_registration.id=1');
    registration.grid_registration.dbUpdate;
    registration.grid_registration.SelectedRow := 0;
    SQLExecute('UPDATE app_registration SET concatenated_identifier = "'+registration_volume_serial+'x'+FloatToStr(registration_random_id)+'", unique_identifier = "'+registration_volume_serial+'x'+FloatToStr(registration_random_id)+'_feast"');
    registration.button_edit_registration.Click;
    home_menu.ShowModal;
    splash_screen.Close;
    end else
    begin
    home_menu.ShowModal;
    splash_screen.Close;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure settings_registration_onShow (Sender:String; var Cancel: boolean);
begin
try
    settings_registration.BorderIcons:= 0; // Allows you to hide all the windows system buttons
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure home_menu_edit_registration_OnClick (Sender: string; var Cancel: boolean);
begin
try
    home_menu.hidden_grid_registration.SelectedRow := 0;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_settings_registration  (Sender: string; var Cancel: boolean);
begin
try
    if settings_registration.textbox_first_name.Text = '' then
    begin
        ShowMessage('Please enter a first name');
        Cancel := True;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_settings_registration_change  (Sender: string; var Cancel: boolean);
begin
try
    if settings_registration_change.textbox_name_first.Text = '' then
    begin
        ShowMessage('Please enter a first name');
        Cancel := True;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure settings_registration_change_afterclick (Sender: string; var Cancel: boolean);
begin
try
    register_first_name := SQLExecute('SELECT name_first FROM app_registration WHERE app_registration.id=1');
    register_last_name := SQLExecute('SELECT name_last FROM app_registration WHERE app_registration.id=1');
    register_org := SQLExecute('SELECT app_registration.organization_name FROM app_registration WHERE app_registration.id=1');
    home_menu.memo_registration.Text := 'This copy of the FEAST Data Utility Version '+FloatToStr(register_version)+' is registered to '+register_first_name+' '+register_last_name+', '+register_org+'.  Serial Number '+display_serial+' ' ;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure home_menu_OnShow (Sender: string; Action: string);
begin
try

// Populate home screen reg info

    registration_concatenated_id := SQLExecute('SELECT concatenated_identifier FROM app_registration WHERE app_registration.id = 1');

    display_serial := SQLExecute('SELECT app_registration.concatenated_identifier FROM app_registration WHERE app_registration.id = 1');
    register_first_name := SQLExecute('SELECT name_first FROM app_registration WHERE app_registration.id=1');
    register_last_name := SQLExecute('SELECT name_last FROM app_registration WHERE app_registration.id=1');
    register_org := SQLExecute('SELECT app_registration.organization_name FROM app_registration WHERE app_registration.id=1');
    register_version := SQLExecute('SELECT version FROM app_registration WHERE app_registration.id=1');
    home_menu.memo_registration.Text := 'This copy of the FEAST Data Utility Version '+FloatToStr(register_version)+' is registered to '+register_first_name+' '+register_last_name+', '+register_org+'.  Serial Number '+display_serial+' ' ;

    home_menu.hidden_grid_registration.dbUpdate;

except
    ShowMessage(ExceptionMessage);
end;
end;


// Stamp the project

procedure project_edit_OnShow (Sender: string; Action: string);
begin
try
    project_edit.stamp_updated_at.Checked := TRUE;
    project_edit.stamp_updated_at.DateTime := Now;
    project_edit.stamp_updated_by.Text := registration_concatenated_id;
    if project_edit.stamp_created_by.Text = '' then
        begin
        project_edit.stamp_created_by.Text := registration_concatenated_id;
        project_edit.stamp_created_at.Checked := TRUE;
        project_edit.stamp_created_at.DateTime:= Now;
    end;
    if project_edit.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        project_edit.stamp_unique_identifier.Text := 'proj_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;
except
    ShowMessage(ExceptionMessage);
end;
end;

// populate and stamp the site

procedure site_OnShow (Sender: string; Action: string);
var
   currency_selected: integer;
begin
try
        project_edit_site.stamp_updated_at.Checked := TRUE;
        project_edit_site.stamp_updated_at.DateTime := Now;
        project_edit_site.stamp_updated_by.Text := registration_concatenated_id;
        if project_edit_site.stamp_created_by.Text = '' then
        begin
        project_edit_site.stamp_created_by.Text := registration_concatenated_id;
        project_edit_site.stamp_created_at.Checked := TRUE;
        project_edit_site.stamp_created_at.DateTime:= Now;
        end;
        if project_edit_site.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        project_edit_site.stamp_unique_identifier.Text := 'site_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

   currency_selected := project_edit_site.combo_currency.dbItemID;
   currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM currency WHERE currency.id = '+IntToStr(currency_selected) );
   project_edit_site.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';
   id_site_record := project_edit_site.button_submit.dbGeneralTableId;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Populate and stamp the focus_group record

procedure focus_group_edit_OnShow (Sender: TObject; Action: string);
var
   i, c: integer;
   focus_group_count: integer;
   new_focus_group_site_id: integer;
   focus_group_rowcount: integer;
   current_gender: string;
begin
try
    focus_group_edit.tabs_focus_group_data.ActivePageIndex := 0;

    choose_focus_group_type.Hide;

// Get the record number

    id_focus_group_record := focus_group_edit.button_submit.dbGeneralTableId;

    if (Action ='NewRecord') AND (create_gendered_fg = true) then
        begin
        if create_fg_f = true then
            begin
            current_gender := 'female';
            end
        else
            begin
            current_gender := 'male';
            end;
        end
    else
        begin
        current_gender := SQLExecute( 'SELECT gender.description FROM focus_group LEFT OUTER JOIN gender ON gender.id = focus_group.id_gender WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    end;

    if Length(current_gender) > 0 then
    begin
        current_gender[1] := UpperCase(current_gender[1]);
    end;

    if current_gender <> '' then
    begin
        focus_group_edit.Label1.Caption := 'Edit Gendered Focus Group Data (' + current_gender + ')';
        focus_group_edit.GroupBox1.Left := 16;
        focus_group_edit.GroupBox1.Width := 673;
        focus_group_edit.GroupBox7.Visible := true;
        focus_group_edit.fg_convert_ng.Visible := true;
        if current_gender = 'Female' then
        begin
        focus_group_edit.label_participants_female.Top := 168;
        focus_group_edit.textbox_participants_female.Top := 168;
        focus_group_edit.label_participants_female.Visible := true;
        focus_group_edit.textbox_participants_female.Visible := true;
        focus_group_edit.label_participants_male.Visible := false;
        focus_group_edit.textbox_participants_male.Visible := false;
        end else
        begin
        focus_group_edit.label_participants_male.Top := 168;
        focus_group_edit.textbox_participants_male.Top := 168;
        focus_group_edit.label_participants_male.Visible := true;
        focus_group_edit.textbox_participants_male.Visible := true;
        focus_group_edit.label_participants_female.Visible := false;
        focus_group_edit.textbox_participants_female.Visible := false;
        end;
    end else
    begin
        focus_group_edit.Label1.Caption := 'Edit Focus Group Data';
        focus_group_edit.GroupBox1.Left := 104;
        focus_group_edit.GroupBox1.Width := 469;
        focus_group_edit.GroupBox7.Visible := false;
        focus_group_edit.fg_convert_ng.Visible := false;
        focus_group_edit.label_participants_female.Top := 152;
        focus_group_edit.textbox_participants_female.Top := 152;
        focus_group_edit.label_participants_male.Top := 184;
        focus_group_edit.textbox_participants_male.Top := 184;
        focus_group_edit.label_participants_female.Visible := true;
        focus_group_edit.textbox_participants_female.Visible := true;
        focus_group_edit.label_participants_male.Visible := true;
        focus_group_edit.textbox_participants_male.Visible := true;
    end;

// Stamp the record

    focus_group_edit.stamp_updated_at.Checked := TRUE;
    focus_group_edit.stamp_updated_at.DateTime := Now;
    focus_group_edit.stamp_updated_by.Text := registration_concatenated_id;
    if focus_group_edit.stamp_created_by.Text = '' then
        begin
        focus_group_edit.stamp_created_by.Text := registration_concatenated_id;
        focus_group_edit.stamp_created_at.Checked := TRUE;
        focus_group_edit.stamp_created_at.DateTime:= Now;
    end;
    if focus_group_edit.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        focus_group_edit.stamp_unique_identifier.Text := 'fcgr_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

// Populate the labels and country

    focus_group_edit.label_focus_group_title.Caption := DateToStr(focus_group_edit.date_meeting.Date)+' '+focus_group_edit.textbox_community.Text+' '+focus_group_edit.textbox_venue.Text;
    update_community_type_label();

// Check status color of houshold landholding percentages

        focus_group_edit.textbox_sum_landholding_pct.Value := focus_group_edit.textbox_hh_landless.Value +  focus_group_edit.textbox_hh_small.Value + focus_group_edit.textbox_hh_medium.Value + focus_group_edit.textbox_hh_large.Value;
        if focus_group_edit.textbox_sum_landholding_pct.Value = 100 then
        begin
        focus_group_edit.textbox_sum_landholding_pct.Color := $00EEFFDD;
        end else
        begin
        if focus_group_edit.textbox_sum_landholding_pct.Value > 0 then
        begin
        focus_group_edit.textbox_sum_landholding_pct.Color := $00EBE2FE;
        end else
        begin
            focus_group_edit.textbox_sum_landholding_pct.Color := $00F2F2F2;
        end;
        end;

// save the record

    PrevAction := Action;
     if Action='NewRecord' then
    begin
        ignore_validation := 1;
        focus_group_new_record := 1;
        focus_group_edit.button_submit.Tag := 1;
        focus_group_edit.cbSite.dbItemID:=enter_data.combo_site.dbItemID;
        focus_group_edit.button_submit.dbDoCloseForm := False;
        focus_group_edit.button_submit.dbDontResetID := True;
        focus_group_edit.button_submit.Click;
        id_focus_group_record := focus_group_edit.button_submit.dbGeneralTableId;
// Set gender once on create if we are making a gendered FG
        if create_gendered_fg= true then
        begin
            if create_fg_f = true then
            begin
                SQLExecute('UPDATE focus_group SET id_gender = 1 WHERE id = '+IntToStr(id_focus_group_record) );
                end
            else
              begin
                SQLExecute('UPDATE focus_group SET id_gender = 2 WHERE id = '+IntToStr(id_focus_group_record) );
            end;
        end;

 // generate the monthly records and techfit records   WAXY
        for i := 1 to 12 do
        begin
        SQLExecute('INSERT INTO focus_group_monthly_statistics(id_month, id_focus_group, created_at, created_by, updated_at, updated_by, unique_identifier) VALUES ('+IntToStr(i)+', '+IntToStr(id_focus_group_record)+', "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", "'+registration_concatenated_id+'", "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", "'+registration_concatenated_id+'", "fgms_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'")');
        end;
        SQLExecute('INSERT INTO techfit_assessment (id_focus_group, id_site) SELECT id, id_site FROM focus_group WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        SQLExecute('UPDATE techfit_assessment SET created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier="tfas_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_000", weight_core_feed_issue = (SELECT core_feed_issue FROM techfit_defaults WHERE id = 1), weight_commodity = (SELECT commodity FROM techfit_defaults WHERE id = 1), weight_fs = (SELECT fs FROM techfit_defaults WHERE id = 1), weight_context_attribute = (SELECT context_attribute FROM techfit_defaults WHERE id = 1), weight_impact = (SELECT impact FROM techfit_defaults WHERE id = 1) WHERE techfit_assessment.id_focus_group = '+IntToStr(id_focus_group_record) );
        id_techfit_assessment_record := SQLExecute('SELECT techfit_assessment.id FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        SQLExecute('INSERT INTO core_context_attribute_score (id_core_context_attribute) SELECT (id) FROM core_context_attribute');
        stamp_incremental := SQLExecute('SELECT COUNT (*) FROM core_context_attribute');
        for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE core_context_attribute_score SET id_techfit_assessment = ('+IntToStr(id_techfit_assessment_record)+'), created_by = "'+registration_concatenated_id+'", created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_at="'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by="'+registration_concatenated_id+'", unique_identifier="ccas_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id_techfit_assessment IS NULL AND id_core_context_attribute = '+IntToStr(i));
        end;
// carry over site data

        focus_group_edit.textbox_major_region.Text := SQLExecute( 'SELECT site.major_region FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        focus_group_edit.textbox_minor_region.Text := SQLExecute( 'SELECT site.minor_region FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        focus_group_edit.textbox_sub_region.Text := SQLExecute( 'SELECT site.sub_region FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        focus_group_edit.textbox_community.Text := SQLExecute( 'SELECT site.community FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        focus_group_edit.textbox_sub_region.Text := SQLExecute( 'SELECT site.sub_region FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
        focus_group_edit.combo_community_type.dbItemID := SQLExecute( 'Select IFNULL(site.id_community_type, -1) FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site WHERE focus_group.id = '+IntToStr(id_focus_group_record) );

 // Close and re-open

        focus_group_edit.button_submit.Click;
        new_focus_group_site_id := enter_data.combo_site.dbItemID;
        enter_data.hidden_button_search_focus_group.Click;
        focus_group_rowcount := (enter_data.grid_focus_group.RowCount) - 1;
        enter_data.grid_focus_group.SelectedRow := focus_group_rowcount;
        enter_data.button_edit_focus.Click;
        focus_group_edit.button_submit.dbDoCloseForm := True;
        focus_group_edit.button_submit.Tag := 0;
        ignore_validation := 0;

    end;

// Set the Site ID

    id_site_record := SQLExecute('SELECT focus_group.id_site FROM focus_group WHERE focus_group.id = '+IntToStr(id_focus_group_record) );

// Populate the country field

    focus_group_edit.textbox_country.Text := SQLExecute( 'SELECT country.name FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN country ON country.id = site.id_country WHERE focus_group.id = '+IntToStr(id_focus_group_record) );

// Populate the currency fields

    focus_group_edit.textbox_currency_1.Text := SQLExecute( 'SELECT currency.name FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_currency_2.Text := SQLExecute( 'SELECT currency.name FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.label_exchange_1.Caption := '(='+FloatToStr(currency_label)+' USD)';
    focus_group_edit.label_exchange_2.Caption := '(='+FloatToStr(currency_label)+' USD)';

    // Populate the core context attribute scores and other TechFit data

    core_context_populate_grid();

    focus_group_edit.textbox_price_lease_ha.Text :=  SQLExecute('SELECT techfit_assessment.lease_price_ha_land FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_percent_cash.Text :=  SQLExecute('SELECT techfit_assessment.percent_land_cash_crop FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_percent_fodder.Text :=  SQLExecute('SELECT techfit_assessment.percent_land_fodder FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_percent_subsistence.Text :=  SQLExecute('SELECT techfit_assessment.percent_land_subsistence FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_percent_cultivated.Text :=  SQLExecute('SELECT techfit_assessment.percent_land_cultivated FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_percent_fallow.Text :=  SQLExecute('SELECT techfit_assessment.percent_land_fallow FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_labour_cost_min.Text :=  SQLExecute('SELECT techfit_assessment.labour_daily_cost_min FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.textbox_labour_cost_max.Text :=  SQLExecute('SELECT techfit_assessment.labour_daily_cost_max FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.combo_agriculture_system.dbItemID := SQLExecute('SELECT IFNULL(techfit_assessment.id_agriculture_system_type, -1) FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit.combo_core_commodity.dbItemID := SQLExecute('SELECT IFNULL(techfit_assessment.id_core_commodity, -1) FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );

// Bring general tab to top

except
    ShowMessage(ExceptionMessage);
end;
end;

// Populate the core context attribute scores

procedure core_context_populate_grid();
begin
try
    focus_group_edit.grid_core_context_att_score.dbSQL:='SELECT core_context_attribute.prompt, techfit_scale.number, core_context_attribute.reference, core_context_attribute_score.id FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id LEFT OUTER JOIN core_context_attribute_score ON core_context_attribute_score.id_techfit_assessment = techfit_assessment.id LEFT OUTER JOIN core_context_attribute ON core_context_attribute.id = core_context_attribute_score.id_core_context_attribute LEFT OUTER JOIN core_context_attribute_type ON core_context_attribute_type.id = core_context_attribute.id_core_context_attribute_type LEFT OUTER JOIN techfit_scale ON techfit_scale.id = core_context_attribute_score.id_techfit_scale WHERE focus_group.id = '+IntToStr(id_focus_group_record)+' and techfit_assessment.id_focus_group = '+IntToStr(id_focus_group_record)+' ORDER BY core_context_attribute_type.description, core_context_attribute.prompt';
    focus_group_edit.grid_core_context_att_score.dbGeneralTable := 'core_context_attribute_score';
    focus_group_edit.grid_core_context_att_score.dbListFieldsNames :='Attribute,Score,Reference,delete_col';
    focus_group_edit.grid_core_context_att_score.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure gender_decision_populate_grid();
begin
try
    respondent_edit.grid_gender_decisions.dbSQL:='SELECT decision_type.description, decision.description, gender_group.description, decision_making_by_household.id FROM respondent LEFT OUTER JOIN decision_making_by_household ON decision_making_by_household.id_respondent = respondent.id LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision LEFT OUTER JOIN decision_type ON decision_type.id = decision.id_decision_type LEFT OUTER JOIN gender_group ON gender_group.id = decision_making_by_household.id_gender_group WHERE respondent.id = '+IntToStr(id_respondent_record)+' and decision_making_by_household.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY decision_type.description, decision.description';
    respondent_edit.grid_gender_decisions.dbGeneralTable := 'decision_making_by_household';
    respondent_edit.grid_gender_decisions.dbListFieldsNames :='Type,Decision,Group,delete_col';
    respondent_edit.grid_gender_decisions.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure feed_labor_populate_grid();
begin
try
    respondent_edit.grid_gender_labor.dbSQL:='SELECT feed_labor_type.description, labor_division_group.description, feed_labor_division.id FROM respondent LEFT OUTER JOIN feed_labor_division ON feed_labor_division.id_respondent = respondent.id LEFT OUTER JOIN feed_labor_type ON feed_labor_type.id = feed_labor_division.id_feed_labor_type LEFT OUTER JOIN labor_division_group ON labor_division_group.id = feed_labor_division.id_labor_division_group WHERE respondent.id = '+IntToStr(id_respondent_record)+' and feed_labor_division.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY feed_labor_type.description';
    respondent_edit.grid_gender_labor.dbGeneralTable := 'feed_labor_division';
    respondent_edit.grid_gender_labor.dbListFieldsNames :='Type,Group,delete_col';
    respondent_edit.grid_gender_labor.dbSQLExecute;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_units_OnShow (Sender: string; Action: string);
begin
try
   statistics_units.PageControl1.ActivePageIndex := 0;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Populate and stamp the Respondent record

procedure respondent_edit_OnShow (Sender: string; Action: string);
var
   respondent_hh_checked_test: integer;
   respondent_hh_female_managed_test: integer;
   respondent_count: integer;
   feed_source_count: integer;
   i, c: integer;
   feed_source_index: integer;
begin
try
respondent_edit.PageControl1.ActivePageIndex := 0; // select first tab

// Get the record number

    id_respondent_record := respondent_edit.button_submit.dbGeneralTableId;

// Stamp the record

    respondent_edit.stamp_updated_at.Checked := TRUE;
    respondent_edit.stamp_updated_at.DateTime := Now;
    respondent_edit.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit.stamp_created_by.Text = '' then
        begin
        respondent_edit.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit.stamp_created_at.Checked := TRUE;
        respondent_edit.stamp_created_at.DateTime:= Now;
    end;
    if respondent_edit.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        respondent_edit.stamp_unique_identifier.Text := 'rpdt_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;


// Write protect the HH data if respondent is head of HH is checked

      respondent_hh_checked_test := SQLExecute( 'SELECT respondent.head_of_household_is_respondent FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
      if respondent_hh_checked_test = 1 then
      begin
          respondent_edit.textbox_hh_name.ReadOnly := True;
          respondent_edit.combo_hh_gender.Visible := False;
          respondent_edit.combo_hh_gender.dbItemID := respondent_edit.combo_respondent_gender.dbItemID;
          respondent_edit.textbox_hh_gender.Visible := True;
          respondent_edit.textbox_hh_age.ReadOnly := True;
          idRecord := respondent_edit.combo_hh_gender.dbItemID;
          respondent_edit.textbox_hh_gender.Text := SQLExecute( 'SELECT gender.description FROM gender WHERE gender.id = '+IntToStr(idRecord) );
          respondent_edit.textbox_hh_name.Color := $00F2F2F2;
          respondent_edit.textbox_hh_age.Color := $00F2F2F2;
      end;

      if respondent_edit.textbox_hh_gender.Text = 'female' then
      begin
      respondent_edit.checkbox_hh_female_managed.Checked := true;
      end;

      if respondent_edit.checkbox_hh_female_managed.sqlValue <> '1' then
      begin
      respondent_edit.checkbox_hh_female_managed.Checked := false;
      end;


// update the form label

    respondent_edit.label_respondent_name.Caption := respondent_edit.textbox_respondent_name.Text;

 // save the record

    PrevAction := Action;
     if Action='NewRecord' then
    begin
        ignore_validation := 1;
        respondent_new_record := 1;
        respondent_edit.button_submit.Tag := 1;
        respondent_edit.hidden_combo_focus_group.dbItemID:=id_focus_group_record;
        respondent_edit.button_submit.dbDoCloseForm := False;
        respondent_edit.button_submit.dbDontResetID := True;
        respondent_edit.button_submit.Click;

    // Alit populate the country field

    respondent_edit.textbox_country.Text := focus_group_edit.textbox_country.Text;

  // auto-generate the monthly records

        id_respondent_record := respondent_edit.button_submit.dbGeneralTableId;
        for i := 1 to 12 do
        begin
            SQLExecute('INSERT INTO respondent_monthly_statistics(id_month, id_respondent, created_at, created_by, updated_at, updated_by, unique_identifier) VALUES ('+IntToStr(i)+', '+IntToStr(id_respondent_record)+', "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", "'+registration_concatenated_id+'", "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", "'+registration_concatenated_id+'", "rems_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'")');
        end;
        for i := 1 to 12 do
        begin
            SQLExecute('INSERT INTO feed_source_availability (id_feed_source) SELECT (id) FROM feed_source WHERE ((feed_source.id_site = '+IntToStr(id_site_record)+') OR (feed_source.canonical_data = 1))');
            feed_source_count := SQLExecute('SELECT COUNT (*) FROM feed_source WHERE ((feed_source.id_site = '+IntToStr(id_site_record)+') OR (feed_source.canonical_data = 1))');
            for c:= 1 to feed_source_count do
            begin
            feed_source_index := SQLExecute('SELECT MAX (id_feed_source) FROM feed_source_availability WHERE id_respondent IS NULL');
            SQLExecute('UPDATE feed_source_availability SET id_respondent = ('+IntToStr(id_respondent_record)+'), id_month = '+IntToStr(i)+', created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "fsav_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(c)))+'" WHERE id_respondent IS NULL AND id_feed_source = '+IntToStr(feed_source_index)+'');
            end;
        end;

// auto-generate livestock sales records

       id_respondent_record := respondent_edit.button_submit.dbGeneralTableId;
       begin
        SQLExecute('INSERT INTO livestock_sale (id_livestock_sale_category) SELECT (id) FROM livestock_sale_category');
        stamp_incremental := SQLExecute('SELECT COUNT (*) FROM livestock_sale_category');
        for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE livestock_sale SET id_respondent = ('+IntToStr(id_respondent_record)+'), created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "lssa_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM livestock_sale WHERE id_respondent IS NULL ORDER BY id ASC LIMIT 1)');
        end;
        end;

// auto-generate gendered decision and labor records
       begin
        SQLExecute('INSERT INTO decision_making_by_household (id_decision) SELECT (id) FROM decision');
        stamp_incremental := SQLExecute('SELECT COUNT (*) FROM decision');
        for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE decision_making_by_household SET id_respondent = ('+IntToStr(id_respondent_record)+'), created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "dmbh_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM decision_making_by_household WHERE id_respondent IS NULL ORDER BY id ASC LIMIT 1)');
        end;
        end;

       begin
        SQLExecute('INSERT INTO feed_labor_division (id_feed_labor_type) SELECT (id) FROM feed_labor_type');
        stamp_incremental := SQLExecute('SELECT COUNT (*) FROM decision');
        for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE feed_labor_division SET id_respondent = ('+IntToStr(id_respondent_record)+'), created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "fld'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM feed_labor_division WHERE id_respondent IS NULL ORDER BY id ASC LIMIT 1)');
        end;
        end;

  // carry over focus group data

        respondent_edit.textbox_country.Text := focus_group_edit.textbox_country.Text;
        respondent_edit.textbox_major_region.Text := focus_group_edit.textbox_major_region.Text;
        respondent_edit.textbox_minor_region.Text := focus_group_edit.textbox_minor_region.Text;
        respondent_edit.textbox_sub_region.Text := focus_group_edit.textbox_sub_region.Text;
        respondent_edit.textbox_community.Text := focus_group_edit.textbox_community.Text;
        respondent_edit.textbox_sub_region.Text := focus_group_edit.textbox_sub_region.Text;
        respondent_edit.combo_community_type.dbItemID := focus_group_edit.combo_community_type.dbItemID;

  // save and re-open the form

          respondent_edit.button_submit.Click;
          focus_group_edit.grid_respondent.dbUpdate;
          focus_group_edit.grid_respondent.SelectedRow := 0;
          focus_group_edit.button_edit_respondent.Click;
          respondent_edit.button_submit.dbDoCloseForm := True;
          respondent_edit.button_submit.Tag := 0;
          ignore_validation := 0;
    end;

// Use the visibility of the focus group "Convert to non-gendered" button as a flag here. Should be the same.
    respondent_edit.checkbox_hh_female_managed.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.groupbox_land_ownership.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.label_total_land.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.textbox_total_land.Visible := focus_group_edit.fg_convert_ng.Visible;

    respondent_edit.tab_gender_roles.TabVisible := focus_group_edit.fg_convert_ng.Visible;;
    respondent_edit.tab_income_women.TabVisible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.label_gender_tabs.Visible := focus_group_edit.fg_convert_ng.Visible;

    respondent_edit.memo_affiliations.Visible := focus_group_edit.fg_convert_ng.Visible = false;
    respondent_edit.grid_coop_membership.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.button_delete_coop_membership.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.button_edit_coop_membership.Visible := focus_group_edit.fg_convert_ng.Visible;
    respondent_edit.button_new_coop_membership.Visible := focus_group_edit.fg_convert_ng.Visible;

    if focus_group_edit.fg_convert_ng.Visible = true then
    begin
    gender_decision_populate_grid();
    feed_labor_populate_grid();
    end;

// Populate the country field


    respondent_edit.textbox_country.Text := SQLExecute( 'SELECT country.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN country ON country.id = site.id_country WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit.Show; // Paranoia.
except
    ShowMessage(ExceptionMessage);
end;
end;

// Populate and stamp livestock holding

procedure respondent_edit_livestock_holding_OnShow (Sender: string; Action: string);
var
       animal_type_combo_box: integer;
begin
try
    // Stamp the record

    respondent_edit_livestock_holding.stamp_updated_at.Checked := TRUE;
    respondent_edit_livestock_holding.stamp_updated_at.DateTime := Now;
    respondent_edit_livestock_holding.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_livestock_holding.stamp_created_by.Text = '' then
        begin
        respondent_edit_livestock_holding.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_livestock_holding.stamp_created_at.Checked := TRUE;
        respondent_edit_livestock_holding.stamp_created_at.DateTime:= Now;
    end;
     if respondent_edit_livestock_holding.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        respondent_edit_livestock_holding.stamp_unique_identifier.Text := 'lshd_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

    // Populate the Form

       animal_type_combo_box := respondent_edit_livestock_holding.combo_animal_type.dbItemID;
       if animal_type_combo_box <> -1 then
       begin
           animal_type_weight_min := SQLExecute('SELECT animal_type.weight_lower_limit FROM animal_type WHERE animal_type.id = '+IntToStr(animal_type_combo_box) );
           animal_type_weight_max := SQLExecute('SELECT animal_type.weight_upper_limit FROM animal_type WHERE animal_type.id = '+IntToStr(animal_type_combo_box) );
           respondent_edit_livestock_holding.label_weight_range.Caption:= 'Accepted weight range for this type of animal is '+FloatToStr(animal_type_weight_min)+' to '+FloatToStr(animal_type_weight_max)+' kg';
       end;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp and populate the crop cultivation record

procedure respondent_edit_crop_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    respondent_edit_crop.stamp_updated_at.Checked := TRUE;
    respondent_edit_crop.stamp_updated_at.DateTime := Now;
    respondent_edit_crop.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_crop.stamp_created_by.Text = '' then
        begin
        respondent_edit_crop.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_crop.stamp_created_at.Checked := TRUE;
        respondent_edit_crop.stamp_created_at.DateTime:= Now;
    end;
    if respondent_edit_crop.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        respondent_edit_crop.stamp_unique_identifier.Text := 'crop_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;


// Color the residue usage total box

   respondent_edit_crop.textbox_total.Value := respondent_edit_crop.textbox_percent_other.Value + respondent_edit_crop.textbox_percent_burned.Value + respondent_edit_crop.textbox_percent_fed.Value + respondent_edit_crop.textbox_percent_sold.Value + respondent_edit_crop.textbox_percent_mulched.Value;
    if respondent_edit_crop.textbox_total.Value = 100 then
    begin
    respondent_edit_crop.textbox_total.Color := $00EEFFDD;
    end else
    if respondent_edit_crop.textbox_total.Value > 0 then
    begin
    respondent_edit_crop.textbox_total.Color := $00EBE2FE;
    end else
    begin
    respondent_edit_crop.textbox_total.Color := $00F2F2F2;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp the fodder crop record

procedure respondent_edit_fodder_crop_OnShow (Sender: String; Action: String);
begin
try

// Stamp the record

    respondent_edit_fodder_crop.stamp_updated_at.Checked := TRUE;
    respondent_edit_fodder_crop.stamp_updated_at.DateTime := Now;
    respondent_edit_fodder_crop.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_fodder_crop.stamp_created_by.Text = '' then
        begin
        respondent_edit_fodder_crop.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_fodder_crop.stamp_created_at.Checked := TRUE;
        respondent_edit_fodder_crop.stamp_created_at.DateTime:= Now;
    end;
    if respondent_edit_fodder_crop.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        respondent_edit_fodder_crop.stamp_unique_identifier.Text := 'fdcp_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp the purchase feed record and populate the form with currency info

procedure respondent_edit_purchase_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    respondent_edit_purchase.stamp_updated_at.Checked := TRUE;
    respondent_edit_purchase.stamp_updated_at.DateTime := Now;
    respondent_edit_purchase.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_purchase.stamp_created_by.Text = '' then
        begin
        respondent_edit_purchase.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_purchase.stamp_created_at.Checked := TRUE;
        respondent_edit_purchase.stamp_created_at.DateTime:= Now;
    end;
    if respondent_edit_purchase.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        respondent_edit_purchase.stamp_unique_identifier.Text := 'prch_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

    respondent_edit_purchase.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_purchase.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp the custom feed source record

procedure statistics_edit_custom_feed_source_OnShow (Sender: string; Action: string);
begin
try
    global_action := Action;

// Stamp the record

    statistics_edit_custom_feed_source.stamp_updated_at.Checked := TRUE;
    statistics_edit_custom_feed_source.stamp_updated_at.DateTime := Now;
    statistics_edit_custom_feed_source.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_custom_feed_source.stamp_created_by.Text = '' then
        begin
        statistics_edit_custom_feed_source.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_custom_feed_source.stamp_created_at.Checked := TRUE;
        statistics_edit_custom_feed_source.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_custom_feed_source.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_custom_feed_source.stamp_unique_identifier.Text := 'fdsr_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

except
    ShowMessage(ExceptionMessage);
end;
end;


  // Stamp the season record

procedure focus_group_edit_season_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    focus_group_edit_season.stamp_updated_at.Checked := TRUE;
    focus_group_edit_season.stamp_updated_at.DateTime := Now;
    focus_group_edit_season.stamp_updated_by.Text := registration_concatenated_id;
    if focus_group_edit_season.stamp_created_by.Text = '' then
        begin
        focus_group_edit_season.stamp_created_by.Text := registration_concatenated_id;
        focus_group_edit_season.stamp_created_at.Checked := TRUE;
        focus_group_edit_season.stamp_created_at.DateTime:= Now;
    end;
    if Action = 'NewRecord' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        focus_group_edit_season.stamp_unique_identifier.Text := 'fgsn_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

except
    ShowMessage(ExceptionMessage);
end;
end;

  // Stamp the income activity record

procedure edit_income_source_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    edit_income_source.stamp_updated_at.Checked := TRUE;
    edit_income_source.stamp_updated_at.DateTime := Now;
    edit_income_source.stamp_updated_by.Text := registration_concatenated_id;
    if edit_income_source.stamp_created_by.Text = '' then
        begin
        edit_income_source.stamp_created_by.Text := registration_concatenated_id;
        edit_income_source.stamp_created_at.Checked := TRUE;
        edit_income_source.stamp_created_at.DateTime:= Now;
    end;
    if edit_income_source.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        edit_income_source.stamp_unique_identifier.Text := 'icsr_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

    edit_income_source.label_income_use_gender.Visible := focus_group_edit.fg_convert_ng.Visible;
    edit_income_source.combo_income_use_gender.Visible := focus_group_edit.fg_convert_ng.Visible;

except
    ShowMessage(ExceptionMessage);
end;
end;

  // Stamp the core context score record

procedure core_context_attribute_score_edit_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    core_context_attribute_score_edit.stamp_updated_at.Checked := TRUE;
    core_context_attribute_score_edit.stamp_updated_at.DateTime := Now;
    core_context_attribute_score_edit.stamp_updated_by.Text := registration_concatenated_id;
    if core_context_attribute_score_edit.stamp_created_by.Text = '' then
        begin
        core_context_attribute_score_edit.stamp_created_by.Text := registration_concatenated_id;
        core_context_attribute_score_edit.stamp_created_at.Checked := TRUE;
        core_context_attribute_score_edit.stamp_created_at.DateTime:= Now;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp and populate the focus group monthly rainfall stats

 procedure focus_group_stats_OnShow (Sender: string; Action: string);
var
    i: integer;
    idCombo: integer;
begin
try
    // Stamp the record

    focus_group_edit_month_stat.stamp_updated_at.Checked := TRUE;
    focus_group_edit_month_stat.stamp_updated_at.DateTime := Now;
    focus_group_edit_month_stat.stamp_updated_by.Text := registration_concatenated_id;
    if focus_group_edit_month_stat.stamp_created_by.Text = '' then
        begin
        focus_group_edit_month_stat.stamp_created_by.Text := registration_concatenated_id;
        focus_group_edit_month_stat.stamp_created_at.Checked := TRUE;
        focus_group_edit_month_stat.stamp_created_at.DateTime:= Now;
    end;

    idRecord := focus_group_edit_month_stat.button_submit.dbGeneralTableId;
    focus_group_edit_month_stat.textbox_month.Text := SQLExecute( 'SELECT month.name FROM focus_group_monthly_statistics LEFT OUTER JOIN month ON month.id = focus_group_monthly_statistics.id_month WHERE focus_group_monthly_statistics.id = '+IntToStr(idRecord) );

    idCombo := focus_group_edit_month_stat.combo_season.dbItemID;
    focus_group_edit_month_stat.combo_season.dbFilter := 'active=1 AND id_focus_group='+ IntToStr(focus_group_edit.button_submit.dbGeneralTableId);
    UpdateDatabase('season');
    focus_group_edit_month_stat.combo_season.dbItemID := idCombo;

except
    ShowMessage(ExceptionMessage);
end;
end;

  // Stamp and populate monthly respondent_edit_milk_data

procedure respondent_edit_milk_data_OnShow (Sender: string; Action: string);
begin
try
    // Stamp the record

    respondent_edit_milk_data.stamp_updated_at.Checked := TRUE;
    respondent_edit_milk_data.stamp_updated_at.DateTime := Now;
    respondent_edit_milk_data.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_milk_data.stamp_created_by.Text = '' then
        begin
        respondent_edit_milk_data.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_milk_data.stamp_created_at.Checked := TRUE;
        respondent_edit_milk_data.stamp_created_at.DateTime:= Now;
    end;

// month

    idRecord := respondent_edit_milk_data.button_submit.dbGeneralTableId;
    respondent_edit_milk_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_milk_data.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_milk_data.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

   // Stamp and populate monthly respondent_edit_livestock_price

procedure respondent_edit_livestock_price_OnShow (Sender: string; Action: string);
begin
try

 // Stamp the record

    respondent_edit_livestock_price.stamp_updated_at.Checked := TRUE;
    respondent_edit_livestock_price.stamp_updated_at.DateTime := Now;
    respondent_edit_livestock_price.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_livestock_price.stamp_created_by.Text = '' then
        begin
        respondent_edit_livestock_price.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_livestock_price.stamp_created_at.Checked := TRUE;
        respondent_edit_livestock_price.stamp_created_at.DateTime:= Now;
    end;

// month

    idRecord := respondent_edit_livestock_price.button_submit.dbGeneralTableId;
    respondent_edit_livestock_price.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_livestock_price.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_livestock_price.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp and populate monthly respondent_edit_availability_data

procedure respondent_edit_availability_data_OnShow (Sender: string; Action: string);
var
    name_month: string;
begin
try

// Stamp the record

    respondent_edit_availability_data.stamp_updated_at.Checked := TRUE;
    respondent_edit_availability_data.stamp_updated_at.DateTime := Now;
    respondent_edit_availability_data.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_availability_data.stamp_created_by.Text = '' then
        begin
        respondent_edit_availability_data.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_availability_data.stamp_created_at.Checked := TRUE;
        respondent_edit_availability_data.stamp_created_at.DateTime:= Now;
    end;

    idRecord := respondent_edit_availability_data.button_submit.dbGeneralTableId;
    respondent_edit_availability_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );
    name_month := respondent_edit_availability_data.textbox_month.Text;


// Populate the feed sources


    respondent_edit_availability_data.grid_feed_availability.dbSQL:='SELECT feed_source_availability.id, feed_source.list_order, feed_source.description, feed_source_availability.percentage FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source_availability.id_feed_source = feed_source.id LEFT OUTER JOIN month ON feed_source_availability.id_month = month.id WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = "'+name_month+'" ORDER BY feed_source.list_order DESC';
    respondent_edit_availability_data.grid_feed_availability.dbGeneralTable := 'feed_source_availability';
    respondent_edit_availability_data.grid_feed_availability.dbListFieldsNames :='delete_col, Order, Source, Rating';
    respondent_edit_availability_data.grid_feed_availability.dbSQLExecute;

    respondent_edit_availability_data.grid_feed_availability.Columns[0].Visible := False;

    respondent_edit_availability_data.textbox_diet_composition_total.Value := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM month INNER JOIN feed_source_availability ON feed_source_availability.id_month = month.id WHERE month.name = "'+name_month+'" AND feed_source_availability.id_respondent = '+IntToStr(id_respondent_record) );

// Check status color of diet composition percentages

        if respondent_edit_availability_data.textbox_diet_composition_total.Value = 10 then
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EEFFDD;
        end else
        begin
           if respondent_edit_availability_data.textbox_diet_composition_total.Value > 0 then
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00EBE2FE;
        end else
        begin
            respondent_edit_availability_data.textbox_diet_composition_total.Color := $00F2F2F2;
        end;
        end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Stamp record and gender and species in respondent_edit_livestock_sale

procedure respondent_edit_livestock_sale_OnShow (Sender: string; Action: string);
begin
try
// Stamp the record

    respondent_edit_livestock_sale.stamp_updated_at.Checked := TRUE;
    respondent_edit_livestock_sale.stamp_updated_at.DateTime := Now;
    respondent_edit_livestock_sale.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_livestock_sale.stamp_created_by.Text = '' then
        begin
        respondent_edit_livestock_sale.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_livestock_sale.stamp_created_at.Checked := TRUE;
        respondent_edit_livestock_sale.stamp_created_at.DateTime:= Now;
    end;


    idRecord := respondent_edit_livestock_sale.button_submit.dbGeneralTableId;
    respondent_edit_livestock_sale.textbox_gender.Text := SQLExecute( 'SELECT gender.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN gender ON gender.id = livestock_sale_category.id_gender WHERE livestock_sale.id = '+IntToStr(idRecord) );
    respondent_edit_livestock_sale.textbox_species.Text := SQLExecute( 'SELECT animal_species.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN animal_species ON animal_species.id = livestock_sale_category.id_animal_species WHERE livestock_sale.id = '+IntToStr(idRecord) );

except
    ShowMessage(ExceptionMessage);
end;
end;

// Livestock Species ID on Livestock Custom Category

procedure livestock_custom_category_OnShow (Sender: string; Action: string);
begin
try

  // Stamp the record

    statistics_custom_animal_category.stamp_updated_at.Checked := TRUE;
    statistics_custom_animal_category.stamp_updated_at.DateTime := Now;
    statistics_custom_animal_category.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_custom_animal_category.stamp_created_by.Text = '' then
        begin
        statistics_custom_animal_category.stamp_created_by.Text := registration_concatenated_id;
        statistics_custom_animal_category.stamp_created_at.Checked := TRUE;
        statistics_custom_animal_category.stamp_created_at.DateTime:= Now;
    end;
    if statistics_custom_animal_category.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_custom_animal_category.stamp_unique_identifier.Text := 'anct_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

  if add_category_from_species_flag = 1 then
  begin;
  statistics_custom_animal_category.combo_species.dbItemID := statistics_custom_species.button_submit.dbGeneralTableId;
  add_category_from_species_flag := 0
  end else
  begin
  if statistics_custom_animal_type.combo_species.dbItemID = -1 then
  begin
  statistics_custom_animal_category.combo_species.dbItemID := statistics_units.grid_species.dbItemID;
  end else
  begin
  statistics_custom_animal_category.combo_species.dbItemID := statistics_custom_animal_type.combo_species.dbItemID;
  end;
  end;
      // Check where the user is coming from

 If statistics_custom_animal_type.Visible then
        statistics_custom_animal_category.combo_species.dbItemID := statistics_custom_animal_type.combo_species.dbItemID;

  statistics_custom_animal_category.textbox_species.Text := SQLExecute('SELECT animal_species.description FROM animal_species WHERE animal_species.id = '+IntToStr(statistics_custom_animal_category.combo_species.dbItemID) );


except
    ShowMessage(ExceptionMessage);
end;
end;


procedure livestock_custom_species_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    statistics_custom_species.stamp_updated_at.Checked := TRUE;
    statistics_custom_species.stamp_updated_at.DateTime := Now;
    statistics_custom_species.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_custom_species.stamp_created_by.Text = '' then
        begin
        statistics_custom_species.stamp_created_by.Text := registration_concatenated_id;
        statistics_custom_species.stamp_created_at.Checked := TRUE;
        statistics_custom_species.stamp_created_at.DateTime:= Now;
    end;
    if statistics_custom_species.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_custom_species.stamp_unique_identifier.Text := 'ansp_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

  new_custom_livestock_species_id := statistics_custom_species.button_submit.dbGeneralTableId;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Currency exchange rate on focus_group_edit_labour_activity

procedure focus_group_edit_labour_activity_OnShow (Sender: string; Action: string);
begin
try

// Stamp the record

    focus_group_edit_labour_activity.stamp_updated_at.Checked := TRUE;
    focus_group_edit_labour_activity.stamp_updated_at.DateTime := Now;
    focus_group_edit_labour_activity.stamp_updated_by.Text := registration_concatenated_id;
    if focus_group_edit_labour_activity.stamp_created_by.Text = '' then
        begin
        focus_group_edit_labour_activity.stamp_created_by.Text := registration_concatenated_id;
        focus_group_edit_labour_activity.stamp_created_at.Checked := TRUE;
        focus_group_edit_labour_activity.stamp_created_at.DateTime:= Now;
    end;
    if focus_group_edit_labour_activity.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        focus_group_edit_labour_activity.stamp_unique_identifier.Text := 'fgla_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

    focus_group_edit_labour_activity.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    focus_group_edit_labour_activity.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

// Show month and crop on statistics_edit_feed_source_availability

procedure statistics_edit_feed_source_availability_OnShow (Sender: string; Action: string);
var
allocated_other_sources: integer;
allocated_total: extended;
begin
try

// Stamp the record

    respondent_edit_feed_source_availability.stamp_updated_at.Checked := TRUE;
    respondent_edit_feed_source_availability.stamp_updated_at.DateTime := Now;
    respondent_edit_feed_source_availability.stamp_updated_by.Text := registration_concatenated_id;
    if respondent_edit_feed_source_availability.stamp_created_by.Text = '' then
        begin
        respondent_edit_feed_source_availability.stamp_created_by.Text := registration_concatenated_id;
        respondent_edit_feed_source_availability.stamp_created_at.Checked := TRUE;
        respondent_edit_feed_source_availability.stamp_created_at.DateTime:= Now;
    end;

     respondent_edit_feed_source_availability.textbox_month.Text := respondent_edit_availability_data.textbox_month.Text;
     idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
     respondent_edit_feed_source_availability.textbox_source.Text := SQLExecute('SELECT feed_source.description FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source.id = feed_source_availability.id_feed_source WHERE feed_source_availability.id = '+IntToStr(idRecord) );
     allocated_other_sources := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM feed_source_availability LEFT OUTER JOIN month ON month.id = feed_source_availability.id_month WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = '''+respondent_edit_feed_source_availability.textbox_month.Text+''' AND feed_source_availability.id <> '+IntToStr(respondent_edit_feed_source_availability.button_submit.dbGeneralTableId) );
     allocated_total := (allocated_other_sources + respondent_edit_feed_source_availability.textbox_percentage.Value);
     respondent_edit_feed_source_availability.label_allocated.Caption := FloatToStr(allocated_total)+' points allocated';

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_feed_source_avialability (Sender: string; var cancel: boolean);
begin
try
 if (respondent_edit_feed_source_availability.textbox_percentage.Value > 10) OR (respondent_edit_feed_source_availability.textbox_percentage.Value < 0) then
 begin
     ShowMessage('For availability, enter a whole number between 0 and 10');
     Cancel := True;
 end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure submit_feed_source_avialability_afterclick (Sender: string; var cancel: boolean);
begin
try
 respondent_edit_availability_data.grid_feed_availability.Columns[0].Visible := False;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure allocated_onchange (Sender: string; var cancel: boolean);
var
allocated_other_sources: integer;
allocated_total: extended;
begin
try
     allocated_other_sources := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM feed_source_availability LEFT OUTER JOIN month ON month.id = feed_source_availability.id_month WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = '''+respondent_edit_feed_source_availability.textbox_month.Text+''' AND feed_source_availability.id <> '+IntToStr(respondent_edit_feed_source_availability.button_submit.dbGeneralTableId) );
     allocated_total := (allocated_other_sources + respondent_edit_feed_source_availability.textbox_percentage.Value);
     respondent_edit_feed_source_availability.label_allocated.Caption := FloatToStr(allocated_total)+' points allocated';
  except
    ShowMessage(ExceptionMessage);
end;
end;

//Populate and stamp custom animal type form

 procedure statistics_custom_animal_type_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_custom_animal_type.stamp_updated_at.Checked := TRUE;
    statistics_custom_animal_type.stamp_updated_at.DateTime := Now;
    statistics_custom_animal_type.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_custom_animal_type.stamp_created_by.Text = '' then
        begin
        statistics_custom_animal_type.stamp_created_by.Text := registration_concatenated_id;
        statistics_custom_animal_type.stamp_created_at.Checked := TRUE;
        statistics_custom_animal_type.stamp_created_at.DateTime:= Now;
    end;
    if statistics_custom_animal_type.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_custom_animal_type.stamp_unique_identifier.Text := 'anty_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

 except
    ShowMessage(ExceptionMessage);
end;
end;

 // Populate and stamp custom community type form

 procedure statistics_edit_community_OnShow (Sender: string; Action: string);
 begin
 try
 // Stamp the record

    statistics_edit_community.stamp_updated_at.Checked := TRUE;
    statistics_edit_community.stamp_updated_at.DateTime := Now;
    statistics_edit_community.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_community.stamp_created_by.Text = '' then
        begin
        statistics_edit_community.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_community.stamp_created_at.Checked := TRUE;
        statistics_edit_community.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_community.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_community.stamp_unique_identifier.Text := 'comm_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;


except
    ShowMessage(ExceptionMessage);
end;
end;

 // Populate and stamp custom crop type form

 procedure statistics_edit_crop_information_OnShow(Sender: string; Action: string);
 begin
try

 // Stamp the record

    statistics_edit_crop_information.stamp_updated_at.Checked := TRUE;
    statistics_edit_crop_information.stamp_updated_at.DateTime := Now;
    statistics_edit_crop_information.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_crop_information.stamp_created_by.Text = '' then
        begin
        statistics_edit_crop_information.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_crop_information.stamp_created_at.Checked := TRUE;
        statistics_edit_crop_information.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_crop_information.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_crop_information.stamp_unique_identifier.Text := 'crty_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

except
    ShowMessage(ExceptionMessage);
end;
 end;

// Populate and stamp custom income source form

 procedure statistics_edit_custom_income_source_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_custom_income_source.stamp_updated_at.Checked := TRUE;
    statistics_edit_custom_income_source.stamp_updated_at.DateTime := Now;
    statistics_edit_custom_income_source.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_custom_income_source.stamp_created_by.Text = '' then
        begin
        statistics_edit_custom_income_source.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_custom_income_source.stamp_created_at.Checked := TRUE;
        statistics_edit_custom_income_source.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_custom_income_source.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_custom_income_source.stamp_unique_identifier.Text := 'inty_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

 except
    ShowMessage(ExceptionMessage);
end;
 end;

// Populate and stamp custom fodder crop type form

 procedure statistics_edit_fodder_crop_information_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_fodder_crop_information.stamp_updated_at.Checked := TRUE;
    statistics_edit_fodder_crop_information.stamp_updated_at.DateTime := Now;
    statistics_edit_fodder_crop_information.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_fodder_crop_information.stamp_created_by.Text = '' then
        begin
        statistics_edit_fodder_crop_information.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_fodder_crop_information.stamp_created_at.Checked := TRUE;
        statistics_edit_fodder_crop_information.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_fodder_crop_information.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_fodder_crop_information.stamp_unique_identifier.Text := 'foty_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

 except
    ShowMessage(ExceptionMessage);
end;
 end;

  // Populate and stamp custom purchased feed type form

 procedure statistics_edit_purchased_feed_information_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_purchased_feed_information.stamp_updated_at.Checked := TRUE;
    statistics_edit_purchased_feed_information.stamp_updated_at.DateTime := Now;
    statistics_edit_purchased_feed_information.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_purchased_feed_information.stamp_created_by.Text = '' then
        begin
        statistics_edit_purchased_feed_information.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_purchased_feed_information.stamp_created_at.Checked := TRUE;
        statistics_edit_purchased_feed_information.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_purchased_feed_information.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_purchased_feed_information.stamp_unique_identifier.Text := 'prty_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

 except
    ShowMessage(ExceptionMessage);
end;
 end;


 // Populate and stamp custom unit area form

 procedure statistics_edit_unit_area_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_unit_area.stamp_updated_at.Checked := TRUE;
    statistics_edit_unit_area.stamp_updated_at.DateTime := Now;
    statistics_edit_unit_area.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_unit_area.stamp_created_by.Text = '' then
        begin
        statistics_edit_unit_area.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_unit_area.stamp_created_at.Checked := TRUE;
        statistics_edit_unit_area.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_unit_area.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_unit_area.stamp_unique_identifier.Text := 'unar_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

 except
    ShowMessage(ExceptionMessage);
end;
 end;

 // Populate and stamp custom units of mass form

 procedure statistics_edit_unit_mass_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_unit_mass.stamp_updated_at.Checked := TRUE;
    statistics_edit_unit_mass.stamp_updated_at.DateTime := Now;
    statistics_edit_unit_mass.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_unit_mass.stamp_created_by.Text = '' then
        begin
        statistics_edit_unit_mass.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_unit_mass.stamp_created_at.Checked := TRUE;
        statistics_edit_unit_mass.stamp_created_at.DateTime:= Now;
    end;
    if statistics_edit_unit_mass.stamp_unique_identifier.Text = '' then
        begin
        registration_exact_time_stamp := FloatToStr(Now);
        statistics_edit_unit_mass.stamp_unique_identifier.Text := 'unmw_'+registration_concatenated_id+'_'+registration_exact_time_stamp+'_000';
        end;

except
    ShowMessage(ExceptionMessage);
end;
 end;

// Populate edit currency form

 procedure statistics_edit_currency_OnShow (Sender: string; Action: string);
 begin
 try

 // Stamp the record

    statistics_edit_currency.stamp_updated_at.Checked := TRUE;
    statistics_edit_currency.stamp_updated_at.DateTime := Now;
    statistics_edit_currency.stamp_updated_by.Text := registration_concatenated_id;
    if statistics_edit_currency.stamp_created_by.Text = '' then
        begin
        statistics_edit_currency.stamp_created_by.Text := registration_concatenated_id;
        statistics_edit_currency.stamp_created_at.Checked := TRUE;
        statistics_edit_currency.stamp_created_at.DateTime:= Now;
    end;

except
    ShowMessage(ExceptionMessage);
end;
 end;


// Show month and filter seasons in monthly fg statistics edit form

procedure focus_group_stats_OnClick (Sender: string; Action: string; var Cancel: boolean);
begin
try

 if (focus_group_edit.grid_rainfall.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end else
   SQLExecute( 'UPDATE season SET active="1" WHERE id_focus_group = '+IntToStr(id_focus_group_record) );
   SQLExecute( 'UPDATE season SET active="0" WHERE id_focus_group <> '+IntToStr(id_focus_group_record) );
   focus_group_edit_month_stat.combo_season.dbFilter := 'active = 1';

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure season_update (Sender: string; Action: string);
begin
try
    UpdateDatabase('season');
    UpdateDatabase('focus_group_monthly_statistics');
except
    ShowMessage(ExceptionMessage);
end;
end;


// Change the community type in the label

procedure update_community_type_label ();
var
community_type_text: string;
community_type_dropdown: integer;
begin
try
    if focus_group_edit.combo_community_type.dbItemID <> -1 then
    community_type_dropdown := focus_group_edit.combo_community_type.dbItemID;
    community_type_text := SQLExecute('SELECT community_type.description FROM community_type WHERE community_type.id = '+IntToStr(community_type_dropdown)+ );
    focus_group_edit.label_hh_area.Caption := 'Total households in the '+community_type_text+':';
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure community_type_OnChange (Sender: string; Action: string);
begin
try
update_community_type_label();
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure cancel_create_focus_group (Sender: string; var Cancel: boolean);
begin
try
    if focus_group_new_record = 1 then
    begin
        SQLExecute('DELETE FROM focus_group WHERE id='+IntToStr(id_focus_group_record));
        focus_group_new_record := 0;
        enter_data.grid_focus_group.dbUpdate;
        choose_focus_group_type.Close;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure cancel_create_techfit_assessment (Sender: string; var Cancel: boolean);
begin
try
    if techfit_assessment_new_record = 1 then
    begin
        SQLExecute('DELETE FROM techfit_assessment WHERE id='+IntToStr(id_techfit_assessment_record));
        techfit_assessment_new_record := 0;
        techfit_assessments.grid_techfit_assessments.dbUpdate;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure cancel_create_respondent (Sender: string; var Cancel: boolean);
begin
try
    if respondent_new_record = 1 then
    begin
        SQLExecute('DELETE FROM respondent WHERE id='+IntToStr(id_respondent_record));
        respondent_new_record := 0;
        focus_group_edit.grid_respondent.dbUpdate;
    end;
    // Prevent gender validation warning when reloading form for opposite gender
    respondent_edit.combo_respondent_gender.dbItemID := -1;
except
    ShowMessage(ExceptionMessage);
end;
end;

// *** NAVIGATION CONTROLS ***

// Prev Next Month Navigation for Various Forms

// Respondent Monthly Feed Availability Previous Next

procedure respondent_edit_availability_Prev_OnClick (Sender: string; var Cancel: boolean);
var
    name_month: string;
    validate_total: extended;
begin
try
        validate_total := respondent_edit_availability_data.textbox_diet_composition_total.Value;
    if validate_total <> 10 then
    begin
        ShowMessage ('The ratings for the various feed categories must add up to 10');
        Exit;
    end;
    if respondent_edit_availability_data.combo_availability.dbItemID = -1 then
    begin
        ShowMessage ('Please assign a rating for overall feed availability.');
        Exit;
    end;

    respondent_edit_availability_data.button_submit.dbDoCloseForm := False;
    respondent_edit_availability_data.button_submit.Click;
    respondent_edit.grid_monthly_availability.dbUpdate;
    respondent_edit_availability_data.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_monthly_availability.SelectedRow := respondent_edit.grid_monthly_availability.SelectedRow -1;
    if respondent_edit.grid_monthly_availability.SelectedRow < 0 then respondent_edit.grid_monthly_availability.SelectedRow := 0;
    respondent_edit.button_edit_monthly_availability.Click;
    idRecord := respondent_edit_availability_data.button_submit.dbGeneralTableId;
    respondent_edit_availability_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );
    name_month := respondent_edit_availability_data.textbox_month.Text;
    respondent_edit_availability_data.textbox_diet_composition_total.Value := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM month LEFT OUTER JOIN feed_source_availability ON feed_source_availability.id_month = month.id WHERE month.name = "'+name_month+'" AND feed_source_availability.id_respondent = '+IntToStr(id_respondent_record) );

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_availability_Next_OnClick (Sender: string; var Cancel: boolean);
var
    name_month: string;
validate_total: extended;
begin
try
        validate_total := respondent_edit_availability_data.textbox_diet_composition_total.Value;
    if validate_total <> 10 then
    begin
        ShowMessage ('The ratings for the various feed categories must add up to 10');
        Exit;
    end;
    if respondent_edit_availability_data.combo_availability.dbItemID = -1 then
    begin
        ShowMessage ('Please assign a rating for overall feed availability.');
        Exit;
    end;

    respondent_edit_availability_data.button_submit.dbDoCloseForm := False;
    respondent_edit_availability_data.button_submit.Click;
    respondent_edit.grid_monthly_availability.dbUpdate;
    respondent_edit_availability_data.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_monthly_availability.SelectedRow := respondent_edit.grid_monthly_availability.SelectedRow +1;
    if respondent_edit.grid_monthly_availability.SelectedRow > 12 then respondent_edit.grid_monthly_availability.SelectedRow := 12;
    respondent_edit.button_edit_monthly_availability.Click;
    idRecord := respondent_edit_availability_data.button_submit.dbGeneralTableId;
    respondent_edit_availability_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );
    name_month := respondent_edit_availability_data.textbox_month.Text;
    respondent_edit_availability_data.textbox_diet_composition_total.Value := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM month LEFT OUTER JOIN feed_source_availability ON feed_source_availability.id_month = month.id WHERE month.name = "'+name_month+'" AND feed_source_availability.id_respondent = '+IntToStr(id_respondent_record) );


except
    ShowMessage(ExceptionMessage);
end;
end;


procedure respondent_edit_feed_source_availability_Prev_OnClick (Sender: string; var Cancel: boolean);
var
    name_month: string;
    allocated_other_sources: integer;
    allocated_total: extended;
begin
try
    respondent_edit_feed_source_availability.button_submit.dbDoCloseForm := False;
    respondent_edit_feed_source_availability.button_submit.Click;
    respondent_edit.grid_monthly_availability.dbUpdate;
    respondent_edit_feed_source_availability.button_submit.dbDoCloseForm := True;
    respondent_edit_availability_data.grid_feed_availability.SelectedRow := respondent_edit_availability_data.grid_feed_availability.SelectedRow -1;
    if respondent_edit_availability_data.grid_feed_availability.SelectedRow < 0 then respondent_edit_availability_data.grid_feed_availability.SelectedRow := 0;
    respondent_edit_availability_data.button_edit_feed_availability.Click;
    idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
    respondent_edit_feed_source_availability.textbox_month.Text := respondent_edit_availability_data.textbox_month.Text;
    idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
    respondent_edit_feed_source_availability.textbox_source.Text := SQLExecute('SELECT feed_source.description FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source.id = feed_source_availability.id_feed_source WHERE feed_source_availability.id = '+IntToStr(idRecord) );

    respondent_edit_feed_source_availability.textbox_month.Text := respondent_edit_availability_data.textbox_month.Text;
     idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
     respondent_edit_feed_source_availability.textbox_source.Text := SQLExecute('SELECT feed_source.description FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source.id = feed_source_availability.id_feed_source WHERE feed_source_availability.id = '+IntToStr(idRecord) );
     allocated_other_sources := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM feed_source_availability LEFT OUTER JOIN month ON month.id = feed_source_availability.id_month WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = '''+respondent_edit_feed_source_availability.textbox_month.Text+''' AND feed_source_availability.id <> '+IntToStr(respondent_edit_feed_source_availability.button_submit.dbGeneralTableId) );
     allocated_total := (allocated_other_sources + respondent_edit_feed_source_availability.textbox_percentage.Value);
     respondent_edit_feed_source_availability.label_allocated.Caption := FloatToStr(allocated_total)+' points allocated';


except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_feed_source_availability_Next_OnClick (Sender: string; var Cancel: boolean);
var
    name_month: string;
    max_source: integer;
    allocated_other_sources: integer;
    allocated_total: extended;
begin
try
    name_month := respondent_edit_availability_data.textbox_month.Text;
    max_source := SQLExecute('SELECT COUNT (*) FROM feed_source WHERE ((feed_source.id_site = '+IntToStr(id_site_record)+') OR (feed_source.canonical_data = 1))');
    respondent_edit_feed_source_availability.button_submit.dbDoCloseForm := False;
    respondent_edit_feed_source_availability.button_submit.Click;
    respondent_edit_feed_source_availability.button_submit.dbDoCloseForm := True;
    respondent_edit_availability_data.grid_feed_availability.SelectedRow := respondent_edit_availability_data.grid_feed_availability.SelectedRow +1;
    if respondent_edit_availability_data.grid_feed_availability.SelectedRow > max_source then respondent_edit_availability_data.grid_feed_availability.SelectedRow := max_source;
    respondent_edit_availability_data.button_edit_feed_availability.Click;
    idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
    respondent_edit_feed_source_availability.textbox_month.Text := respondent_edit_availability_data.textbox_month.Text;
    idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
    respondent_edit_feed_source_availability.textbox_source.Text := SQLExecute('SELECT feed_source.description FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source.id = feed_source_availability.id_feed_source WHERE feed_source_availability.id = '+IntToStr(idRecord) );

    respondent_edit_feed_source_availability.textbox_month.Text := respondent_edit_availability_data.textbox_month.Text;
     idRecord := respondent_edit_feed_source_availability.button_submit.dbGeneralTableId;
     respondent_edit_feed_source_availability.textbox_source.Text := SQLExecute('SELECT feed_source.description FROM feed_source_availability LEFT OUTER JOIN feed_source ON feed_source.id = feed_source_availability.id_feed_source WHERE feed_source_availability.id = '+IntToStr(idRecord) );
     allocated_other_sources := SQLExecute('SELECT TOTAL(feed_source_availability.percentage) FROM feed_source_availability LEFT OUTER JOIN month ON month.id = feed_source_availability.id_month WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' AND month.name = '''+respondent_edit_feed_source_availability.textbox_month.Text+''' AND feed_source_availability.id <> '+IntToStr(respondent_edit_feed_source_availability.button_submit.dbGeneralTableId) );
     allocated_total := (allocated_other_sources + respondent_edit_feed_source_availability.textbox_percentage.Value);
     respondent_edit_feed_source_availability.label_allocated.Caption := FloatToStr(allocated_total)+' points allocated';


except
    ShowMessage(ExceptionMessage);
end;
end;

// Respondent Market Price LIvestock Previous Next

procedure respondent_edit_livestock_price_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    respondent_edit_livestock_price.button_submit.dbDoCloseForm := False;
    respondent_edit_livestock_price.button_submit.Click;
    respondent_edit.grid_market_prices.dbUpdate;
    respondent_edit_livestock_price.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_market_prices.SelectedRow := respondent_edit.grid_market_prices.SelectedRow -1;
    if respondent_edit.grid_market_prices.SelectedRow < 0 then respondent_edit.grid_market_prices.SelectedRow := 0;
    respondent_edit.button_edit_market_prices.Click;
    idRecord := respondent_edit_livestock_price.button_submit.dbGeneralTableId;
    respondent_edit_livestock_price.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_livestock_price.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_livestock_price.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_livestock_price_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    respondent_edit_livestock_price.button_submit.dbDoCloseForm := False;
    respondent_edit_livestock_price.button_submit.Click;
    respondent_edit.grid_market_prices.dbUpdate;
    respondent_edit_livestock_price.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_market_prices.SelectedRow := respondent_edit.grid_market_prices.SelectedRow +1;
    if respondent_edit.grid_market_prices.SelectedRow > 12 then respondent_edit.grid_market_prices.SelectedRow := 12;
    respondent_edit.button_edit_market_prices.Click;
    idRecord := respondent_edit_livestock_price.button_submit.dbGeneralTableId;
    respondent_edit_livestock_price.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_livestock_price.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_livestock_price.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

// Respondent Monthly Milk Data Previous Next

procedure respondent_edit_milk_data_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if respondent_edit_milk_data.textbox_retained.Value > respondent_edit_milk_data.textbox_yield.Value then
    begin
        ShowMessage('Amount of milk retained cannot be higher than the yield.');
        Exit;
    end;
    respondent_edit_milk_data.button_submit.dbDoCloseForm := False;
    respondent_edit_milk_data.button_submit.Click;
    respondent_edit.grid_milk_data.dbUpdate;
    respondent_edit_milk_data.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_milk_data.SelectedRow := respondent_edit.grid_milk_data.SelectedRow -1;
    if respondent_edit.grid_milk_data.SelectedRow < 0 then respondent_edit.grid_milk_data.SelectedRow := 0;
    respondent_edit.button_edit_milk_data.Click;
    idRecord := respondent_edit_milk_data.button_submit.dbGeneralTableId;
    respondent_edit_milk_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_milk_data.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_milk_data.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure respondent_edit_milk_data_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if respondent_edit_milk_data.textbox_retained.Value > respondent_edit_milk_data.textbox_yield.Value then
    begin
        ShowMessage('Amount of milk retained cannot be higher than the yield.');
        Exit;
    end;
    respondent_edit_milk_data.button_submit.dbDoCloseForm := False;
    respondent_edit_milk_data.button_submit.Click;
    respondent_edit.grid_milk_data.dbUpdate;
    respondent_edit_milk_data.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_milk_data.SelectedRow := respondent_edit.grid_milk_data.SelectedRow +1;
    if respondent_edit.grid_milk_data.SelectedRow > 12 then respondent_edit.grid_milk_data.SelectedRow := 12;
    respondent_edit.button_edit_milk_data.Click;
    idRecord := respondent_edit_milk_data.button_submit.dbGeneralTableId;
    respondent_edit_milk_data.textbox_month.Text := SQLExecute( 'SELECT month.name FROM respondent_monthly_statistics LEFT OUTER JOIN month ON month.id = respondent_monthly_statistics.id_month WHERE respondent_monthly_statistics.id = '+IntToStr(idRecord) );

// currency labels

    respondent_edit_milk_data.textbox_currency.Text := SQLExecute( 'SELECT currency.name FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    currency_label := SQLExecute('SELECT currency.current_usd_exchange_rate FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent.id = '+IntToStr(id_respondent_record) );
    respondent_edit_milk_data.label_exchange_rate.Caption := '(='+FloatToStr(currency_label)+' USD)';

except
    ShowMessage(ExceptionMessage);
end;
end;

// Focus Group Monthly Stat Previous Next

procedure focus_group_edit_month_stat_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    button_fail := 0;
    focus_group_edit_month_stat.button_submit.dbDoCloseForm := False;
    focus_group_edit_month_stat.button_submit.Click;
    focus_group_edit.grid_rainfall.dbUpdate;
    focus_group_edit_month_stat.button_submit.dbDoCloseForm := True;
    focus_group_edit.grid_rainfall.SelectedRow := focus_group_edit.grid_rainfall.SelectedRow -1;
    if focus_group_edit.grid_rainfall.SelectedRow < 0 then focus_group_edit.grid_rainfall.SelectedRow := 0;
    focus_group_edit.button_edit_rainfall.Click;
    if button_fail = 1 then
    begin
    button_fail := 0;
    exit;
    end;
    idRecord := focus_group_edit_month_stat.button_submit.dbGeneralTableId;
    focus_group_edit_month_stat.textbox_month.Text := SQLExecute('SELECT month.name FROM focus_group_monthly_statistics LEFT OUTER JOIN month ON month.id = focus_group_monthly_statistics.id_month WHERE focus_group_monthly_statistics.id = '+IntToStr(idRecord) );
except
    ShowMessage(ExceptionMessage);
end;
 end;

procedure focus_group_edit_month_stat_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    button_fail := 0;
    focus_group_edit_month_stat.button_submit.dbDoCloseForm := False;
    focus_group_edit_month_stat.button_submit.Click;
    focus_group_edit.grid_rainfall.dbUpdate;
    focus_group_edit_month_stat.button_submit.dbDoCloseForm := True;
    focus_group_edit.grid_rainfall.SelectedRow := focus_group_edit.grid_rainfall.SelectedRow +1;
    if focus_group_edit.grid_rainfall.SelectedRow > 12 then focus_group_edit.grid_rainfall.SelectedRow := 12;
    focus_group_edit.button_edit_rainfall.Click;
    if button_fail = 1 then
    begin
    button_fail := 0;
    exit;
    end;
    idRecord := focus_group_edit_month_stat.button_submit.dbGeneralTableId;
    focus_group_edit_month_stat.textbox_month.Text := SQLExecute( 'SELECT month.name FROM focus_group_monthly_statistics LEFT OUTER JOIN month ON month.id = focus_group_monthly_statistics.id_month WHERE focus_group_monthly_statistics.id = '+IntToStr(idRecord) );

except
    ShowMessage(ExceptionMessage);
end;
end;

// Core Context Attributes Previous Next

procedure focus_group_core_context_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    core_context_attribute_score_edit.button_submit.dbDoCloseForm := False;
    core_context_attribute_score_edit.button_submit.Click;
//  focus_group_edit.grid_core_context_att_score.dbUpdate;
    core_context_populate_grid();
    core_context_attribute_score_edit.button_submit.dbDoCloseForm := True;
If techfit_grid_select = FALSE then
begin
    focus_group_edit.grid_core_context_att_score.SelectedRow := focus_group_edit.grid_core_context_att_score.SelectedRow -1;
    if focus_group_edit.grid_core_context_att_score.SelectedRow < 0 then focus_group_edit.grid_core_context_att_score.SelectedRow := 0;
    focus_group_edit.button_edit_cc_attribute_score.Click;
end else
begin
    techfit_assessment_edit.grid_core_context.SelectedRow := techfit_assessment_edit.grid_core_context.SelectedRow -1;
    if techfit_assessment_edit.grid_core_context.SelectedRow < 0 then techfit_assessment_edit.grid_core_context.SelectedRow := 0;
    techfit_assessment_edit.button_edit_cc_attribute_score.Click;
end
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure focus_group_core_context_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    grid_record_count := SQLExecute('SELECT COUNT(*) FROM core_context_attribute');
    core_context_attribute_score_edit.button_submit.dbDoCloseForm := False;
    core_context_attribute_score_edit.button_submit.Click;
    core_context_populate_grid();
//  focus_group_edit.grid_core_context_att_score.dbUpdate;
    core_context_attribute_score_edit.button_submit.dbDoCloseForm := True;
If techfit_grid_select = FALSE then
begin
    focus_group_edit.grid_core_context_att_score.SelectedRow := focus_group_edit.grid_core_context_att_score.SelectedRow +1;
    if focus_group_edit.grid_core_context_att_score.SelectedRow > grid_record_count then focus_group_edit.grid_core_context_att_score.SelectedRow := grid_record_count;
    focus_group_edit.button_edit_cc_attribute_score.Click;
end else
begin
    techfit_assessment_edit.grid_core_context.SelectedRow := techfit_assessment_edit.grid_core_context.SelectedRow +1;
    if techfit_assessment_edit.grid_core_context.SelectedRow > grid_record_count then techfit_assessment_edit.grid_core_context.SelectedRow := grid_record_count;
    techfit_assessment_edit.button_edit_cc_attribute_score.Click;
end
 except
    ShowMessage(ExceptionMessage);
end;
 end;


// Gendered Decision-making Prev / Next


procedure  grid_gender_decisions_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_gender_decisions.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure gender_decision_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    gender_decision_edit.button_submit.dbDoCloseForm := False;
    gender_decision_edit.button_submit.Click;
    gender_decision_populate_grid();
    gender_decision_edit.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_gender_decisions.SelectedRow := respondent_edit.grid_gender_decisions.SelectedRow -1;
    if respondent_edit.grid_gender_decisions.SelectedRow < 0 then respondent_edit.grid_gender_decisions.SelectedRow := 0;
    respondent_edit.button_edit_gender_decision.Click;

    idRecord := gender_decision_edit.button_submit.dbGeneralTableId;
    gender_decision_edit.textbox_decision_type.Text := SQLExecute( 'SELECT decision_type.description FROM decision_making_by_household LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision LEFT OUTER JOIN decision_type ON decision_type.id = decision.id_decision_type WHERE decision_making_by_household.id = '+IntToStr(idRecord) );
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure gender_decision_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    grid_record_count := SQLExecute('SELECT COUNT(*) FROM decision');
    gender_decision_edit.button_submit.dbDoCloseForm := False;
    gender_decision_edit.button_submit.Click;
    gender_decision_populate_grid();
    gender_decision_edit.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_gender_decisions.SelectedRow := respondent_edit.grid_gender_decisions.SelectedRow +1;
    if respondent_edit.grid_gender_decisions.SelectedRow > grid_record_count then respondent_edit.grid_gender_decisions.SelectedRow := grid_record_count;
    respondent_edit.button_edit_gender_decision.Click;

    idRecord := gender_decision_edit.button_submit.dbGeneralTableId;
    gender_decision_edit.textbox_decision_type.Text := SQLExecute( 'SELECT decision_type.description FROM decision_making_by_household LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision LEFT OUTER JOIN decision_type ON decision_type.id = decision.id_decision_type WHERE decision_making_by_household.id = '+IntToStr(idRecord) );
 except
    ShowMessage(ExceptionMessage);
end;
end;

// Respondent Livestock Sales Previous Next

procedure respondent_livestock_sale_Prev_OnClick (Sender: string; var Cancel: boolean);
begin
try
    respondent_edit_livestock_sale.button_submit.dbDoCloseForm := False;
    respondent_edit_livestock_sale.button_submit.Click;
    respondent_edit.grid_livestock_sale.dbUpdate;
    respondent_edit_livestock_sale.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_livestock_sale.SelectedRow := respondent_edit.grid_livestock_sale.SelectedRow -1;
    if respondent_edit.grid_livestock_sale.SelectedRow < 0 then respondent_edit.grid_livestock_sale.SelectedRow := 0;
    respondent_edit.button_edit_livestock_sale.Click;
    idRecord := respondent_edit_livestock_sale.button_submit.dbGeneralTableId;
    respondent_edit_livestock_sale.textbox_gender.Text := SQLExecute( 'SELECT gender.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN gender ON gender.id = livestock_sale_category.id_gender WHERE livestock_sale.id = '+IntToStr(idRecord) );
    respondent_edit_livestock_sale.textbox_species.Text := SQLExecute( 'SELECT animal_species.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN animal_species ON animal_species.id = livestock_sale_category.id_animal_species WHERE livestock_sale.id = '+IntToStr(idRecord) );
except
    ShowMessage(ExceptionMessage);
end;
 end;

procedure respondent_livestock_sale_Next_OnClick (Sender: string; var Cancel: boolean);
begin
try
    grid_record_count := SQLExecute('SELECT COUNT(*) FROM livestock_sale_category');
    respondent_edit_livestock_sale.button_submit.dbDoCloseForm := False;
    respondent_edit_livestock_sale.button_submit.Click;
    respondent_edit.grid_livestock_sale.dbUpdate;
    respondent_edit_livestock_sale.button_submit.dbDoCloseForm := True;
    respondent_edit.grid_livestock_sale.SelectedRow := respondent_edit.grid_livestock_sale.SelectedRow +1;
    if respondent_edit.grid_livestock_sale.SelectedRow > grid_record_count then respondent_edit.grid_livestock_sale.SelectedRow := grid_record_count;
    respondent_edit.button_edit_livestock_sale.Click;
    idRecord := respondent_edit_livestock_sale.button_submit.dbGeneralTableId;
    respondent_edit_livestock_sale.textbox_gender.Text := SQLExecute( 'SELECT gender.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN gender ON gender.id = livestock_sale_category.id_gender WHERE livestock_sale.id = '+IntToStr(idRecord) );
    respondent_edit_livestock_sale.textbox_species.Text := SQLExecute( 'SELECT animal_species.description FROM livestock_sale LEFT OUTER JOIN livestock_sale_category ON livestock_sale_category.id = livestock_sale.id_livestock_sale_category LEFT OUTER JOIN animal_species ON animal_species.id = livestock_sale_category.id_animal_species WHERE livestock_sale.id = '+IntToStr(idRecord) );

except
    ShowMessage(ExceptionMessage);
end;
end;

// *** VALIDATIONS ***

// Project - Require title

procedure validate_project (Sender: string; var Cancel: boolean);
var
   project_title: string;
   project_title_count: integer;
   validate_id: integer;
begin
try
    project_title := project_edit.textbox_title.Text;
    if (project_edit.textbox_title.Text='') then
    begin
        ShowMessage('Please enter a title for the project.');
        Cancel := True;
    end;
    validate_id := project_edit.button_submit.dbGeneralTableId;
    project_title_count := SQLExecute ('SELECT COUNT (*) FROM project WHERE project.title = "'+project_title+'" AND project.id <> '+IntToStr(validate_id)+' ORDER BY project.id LIMIT 1');
    if project_title_count > 0 then
    begin
    ShowMessage('A project with this title already exists in the database.');
        Cancel := True;
    end;
    if project_edit.date_start_date.Checked = FALSE then
    begin
    ShowMessage('Please enter a start date for the project.');
        Cancel := True;
    end;
    if project_edit.date_start_date.DateTime > project_edit.date_end_date.DateTime then
    begin;
    ShowMessage('The start date may not be later than the end date.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Site - Require name and country

procedure validate_site (Sender: string; var Cancel: boolean);
var
   site_name: string;
   site_name_count: integer;
   validate_id: integer;
   project_id: integer;
begin
try
    if (project_edit_site.textbox_name.Text='') or (project_edit_site.combo_country.dbItemID=-1) or (project_edit_site.combo_currency.dbItemID=-1) then
    begin
        ShowMessage('Please enter a name and select a country and local currency for the site.');
        Cancel := True;
    end;
    if ((project_edit_site.textbox_collected_cp.Text = '') OR (project_edit_site.textbox_collected_me.Text = '') OR (project_edit_site.textbox_grazing_cp.Text = '') OR (project_edit_site.textbox_grazing_me.Text = '')) then
    begin
        ShowMessage('Please enter the crude protein and metabolisable energy content for grazing and collected fodder.');
        Cancel := True;
    end;
    project_id := project_edit.button_submit.dbGeneralTableId;
    site_name := project_edit_site.textbox_name.Text;
    validate_id := project_edit_site.button_submit.dbGeneralTableId;
    site_name_count := SQLExecute('SELECT COUNT (*) FROM site WHERE site.id <> '+IntToStr(validate_id)+' AND site.name = "'+site_name+'" AND site.id_project = '+IntToStr(project_id)+' ORDER BY site.id LIMIT 1');
    if site_name_count > 0 then
    begin
        ShowMessage('A site with this name already exists for this project.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Require project and site to add focus group

procedure enter_data_Button3_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if (enter_data.combo_project.dbItemID=-1) or (enter_data.combo_site.dbItemID=-1) then
    begin
        ShowMessage('Please select Project and Site.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Require project and site to add Techfit Assessment

procedure techfit_assessment_new_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if (techfit_assessments.combo_project.dbItemID=-1) or (techfit_assessments.combo_site.dbItemID=-1) then
    begin
        ShowMessage('Please select Project and Site.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

// Validate table row selection on edit or delete

procedure grid_income_edit_women_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if (ignore_validation = 0) then
    begin
    if (respondent_edit.grid_womens_income.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure grid_income_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if (ignore_validation = 0) then
    begin
    if (respondent_edit.grid_income.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure grid_livestock_holding_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_livestock_holding.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_crop_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try

    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_crop.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_fodder_crop_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_fodder_crop.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_purchased_fodder_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_purchased_fodder.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_livestock_sale_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_livestock_sale.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_market_prices_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_market_prices.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_milk_data_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_milk_data.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_feed_availability_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit.grid_monthly_availability.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure grid_techfit_assessment_delete_OnClick (Sender: string; var Cancel: boolean);
var
   techfit_feast_fg_check: integer;
begin
try
    if ignore_validation = 0 then
    begin
    if (techfit_assessments.grid_techfit_assessments.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    techfit_feast_fg_check := SQLExecute('SELECT COUNT (*) FROM techfit_assessment WHERE techfit_assessment.id_focus_group IS NULL AND techfit_assessment.id = '+IntToStr(techfit_assessments.grid_techfit_assessments.dbItemID)+' ORDER BY techfit_assessment.id LIMIT 1');
    if (techfit_feast_fg_check = 0) then
    begin
        ShowMessage('The selected Techfit assessment is connected to a FEAST focus group and cannot be deleted.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure grid_techfit_assessment_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (techfit_assessments.grid_techfit_assessments.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
          Cancel := True;
          button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure grid_focus_group_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (enter_data.grid_focus_group.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_seasons_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (focus_group_edit.grid_seasons.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_core_context_edit_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (focus_group_edit.grid_core_context_att_score.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
       techfit_grid_select := FALSE;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_labour_activity_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (focus_group_edit.grid_labour_activity.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_respondent_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (focus_group_edit.grid_respondent.dbItemID = -1) AND (ignore_validation = 0) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_site_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (project_edit.grid_site.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_feed_source_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (project_edit_site.grid_feed_source.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure  grid_projects_edit_delete_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (project_manage.grid_projects.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_animal_category_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_custom_species.grid_animal_category.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_custom_crop_type_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_crop_type.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure  grid_custom_fodder_crop_type_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_fodder_types.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure  grid_custom_purchased_feed_type_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_purchased_feed_types.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_custom_livestock_type_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_livestock_types.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_custom_species_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_species.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_unit_mass_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_unit_mass.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_unit_area_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_unit_area.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_currency_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_currency.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_custom_income_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_income.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure  grid_custom_community_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (statistics_units.grid_custom_community.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

//

procedure  grid_feed_availability_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if ignore_validation = 0 then
    begin
    if (respondent_edit_availability_data.grid_feed_availability.dbItemID = -1) then
    begin
        ShowMessage('Please select a record from the table.');
        Cancel := True;
        button_fail := 1;
    end;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_techfit_assessment (Sender: string; var Cancel: boolean);
var
techfit_assessment_title : string;
count_blanks : integer;
begin
try
    if techfit_assessment_edit.button_submit.Tag=1 then exit;
    techfit_assessment_new_record := 0;

if (techfit_assessment_edit.title.Text='') then
    begin
        ShowMessage('Enter a title for the techfit assessment.');
        Cancel := True;
    end;
if (techfit_assessment_edit.combo_core_commodity.dbItemID = -1) OR (techfit_assessment_edit.combo_agricultural_system.dbItemID = -1) then
   begin
       ShowMessage('Please select a description for the agricultural system and core commodity (Feed / Context Issues Tab)');
       Cancel := True;
   end;
   count_blanks := SQLExecute('SELECT COUNT (*) FROM core_context_attribute_score LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id = core_context_attribute_score.id_techfit_assessment LEFT OUTER JOIN focus_group ON focus_group.id = techfit_assessment.id_focus_group WHERE core_context_attribute_score.id_techfit_scale IS NULL AND techfit_assessment.id = '+IntToStr(id_techfit_assessment_record) );
   if count_blanks > 0 then
   begin
       ShowMessage('Please enter all of the core context attributes / feed attribute scores (Feed / Context Issues Tab)');
       Cancel := True;
   end;
except
   ShowMessage(ExceptionMessage);
end;
end;

// Validate focus group and save Techfit core context data to techfit_assessment table

procedure validate_focus_group (Sender: string; var Cancel: boolean);
var
    id_core_commodity_selected: integer;
    id_agriculture_system_selected: integer;
    max_cost_labour: extended;
    min_cost_labour: extended;
    price_lease_ha: extended;
    percent_land_cultivated: integer;
    percent_land_fallow: integer;
    percent_crop_cash: integer;
    percent_crop_subsistence: integer;
    percent_crop_fodder: integer;
    buttonSelected : Integer;
    techfit_assessment_title : string;
    validate_skip : Integer;
    dialog_response: Integer;
    count_blanks: Integer;
    count_target: Integer;
    stamp_update: string;

begin
try

// Ignore during auto-save process when creating a new record

    if focus_group_edit.button_submit.Tag=1 then exit;
    if ignore_validation = 0 then
    begin;

// Validating input - Basic validation before leaving the form to drill down to respondents techfit etc

    if (focus_group_edit.textbox_venue.Text='') OR (focus_group_edit.textbox_community.Text='') OR (focus_group_edit.combo_community_type.dbItemID = -1) then
    begin
        ShowMessage('Enter a community, community type and venue for the focus group.');
        Cancel := True;
    end;
    if (focus_group_edit.date_meeting.Checked = FALSE) then
    begin
        ShowMessage('Enter a date for the focus group.');
        Cancel := True;
    end;

// Validating Input - Thorough validation when exiting the form

   if ((focus_group_edit.textbox_participants_female.Text = '') OR (focus_group_edit.textbox_participants_female.Text = '0')) AND ((focus_group_edit.textbox_participants_male.Text = '') OR (focus_group_edit.textbox_participants_male.Text = '0')) then
   begin
        ShowMessage('Please enter the number of female and male focus group participants.');
        Cancel := True;
   end;
   if (((focus_group_edit.textbox_gps_lat_deg.Text = '') OR (focus_group_edit.textbox_gps_lon_deg.Text = '') OR (focus_group_edit.textbox_gps_lat_min.Text = '') OR (focus_group_edit.textbox_gps_lat_sec.Text = '') OR (focus_group_edit.textbox_gps_lon_min.Text = '') OR (focus_group_edit.textbox_gps_lon_sec.Text = '')) AND ((focus_group_edit.textbox_gps_lat_deg.Text <> '') OR (focus_group_edit.textbox_gps_lon_deg.Text <> '') OR (focus_group_edit.textbox_gps_lat_min.Text <> '') OR (focus_group_edit.textbox_gps_lat_sec.Text <> '') OR (focus_group_edit.textbox_gps_lon_min.Text <> '') OR (focus_group_edit.textbox_gps_lon_sec.Text <> ''))) then
   begin
       ShowMessage('Enter GPS degrees, minutes and seconds for both latitude and longitude.');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_gps_lat_deg.Value > 90) OR (focus_group_edit.textbox_gps_lat_deg.Value < -90) OR (focus_group_edit.textbox_gps_lon_deg.Value > 180) OR (focus_group_edit.textbox_gps_lon_deg.Value < -180) OR (focus_group_edit.textbox_gps_lat_min.Value > 60) OR (focus_group_edit.textbox_gps_lat_min.Value < 0) OR (focus_group_edit.textbox_gps_lat_sec.Value > 60) OR (focus_group_edit.textbox_gps_lat_sec.Value < 0) OR (focus_group_edit.textbox_gps_lon_min.Value > 60) OR (focus_group_edit.textbox_gps_lon_min.Value < 0) OR (focus_group_edit.textbox_gps_lon_sec.Value > 60) OR (focus_group_edit.textbox_gps_lon_sec.Value < 0) then
   begin
       ShowMessage('For GPS coordinates, enter + or - 90 degrees latitude, + or - 180 degrees longitude, then 0 to 60 minutes and 0 to 60 seconds.');
       Cancel := True;
   end;
   if ((focus_group_edit.textbox_total_households.Text = '') OR (focus_group_edit.textbox_total_households.Text = '')) then
   begin
        ShowMessage('Please enter the number of households in the region (Farm / HH Size Tab).');
        Cancel := True;
   end;
   if ((focus_group_edit.textbox_threshold_small.Text = '') OR (focus_group_edit.textbox_threshold_large.Text = '')) then
   begin
        ShowMessage('Please enter the size ranges for small, medium and large farms (Farm / HH Size Tab).');
        Cancel := True;
   end else
   if (focus_group_edit.textbox_threshold_small.Value >= focus_group_edit.textbox_threshold_large.Value) then
   begin
        ShowMessage('The small and large farm size ranges cannot overlap (Farm / HH Size Tab).');
        Cancel := True;
   end;
   if (focus_group_edit.combo_units.dbItemID = -1) then
   begin
        ShowMessage('Please designate units of area for the farm size ranges (Farm / HH Size Tab).');
        Cancel := True;
   end;
   if (focus_group_edit.textbox_sum_landholding_pct.Value <> 100) then
   begin
        ShowMessage('The percentages of households for the different farm size ranges must add up to 100 (Farm / HH Size Tab).');
        Cancel := True;
   end;
   
   if focus_group_edit.fg_convert_ng.Visible = true then
   begin
     if (focus_group_edit.percent_hh_landless_m.Text = '') or ((focus_group_edit.percent_hh_landless_m.Value + focus_group_edit.percent_hh_landless_f.Value) <> 100) then
     begin
     ShowMessage('You must enter the percentages of land ownership by gender for each farm size range.');
        Cancel := True;
     end;
   end;
   
   count_blanks := SQLExecute('SELECT COUNT (*) FROM focus_group_monthly_statistics WHERE focus_group_monthly_statistics.id_scale_zero_five IS NULL AND focus_group_monthly_statistics.id_focus_group = '+IntToStr(id_focus_group_record) );
   if count_blanks > 0 then
   begin
        ShowMessage('Please enter a rainfall value for each month of the year (Seasons/Rainfall Tab).');
        Cancel := True;
   end;
   count_blanks := SQLExecute('SELECT COUNT (*) FROM core_context_attribute_score LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id = core_context_attribute_score.id_techfit_assessment LEFT OUTER JOIN focus_group ON focus_group.id = techfit_assessment.id_focus_group WHERE core_context_attribute_score.id_techfit_scale IS NULL AND focus_group.id = '+IntToStr(id_focus_group_record) );
   if count_blanks > 0 then
   begin
       ShowMessage('Please enter all of the core context attributes / feed attribute scores (Feed / Context Issues Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.combo_core_commodity.dbItemID = -1) OR (focus_group_edit.combo_agriculture_system.dbItemID = -1) then
   begin
       ShowMessage('Please select a description for the agricultural system and core commodity (Feed / Context Issues Tab)');
       Cancel := True;
   end;

   if (focus_group_edit.textbox_percent_cultivated.Value + focus_group_edit.textbox_percent_fallow.Value > 100) then
   begin
       ShowMessage('The total percentage of cultiavted land plus land left fallow may not exceed 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_percent_cash.Value + focus_group_edit.textbox_percent_fodder.Value + focus_group_edit.textbox_percent_subsistence.Value > 100) then
   begin
       ShowMessage('The total percentage of land devoted to cash crops, subsistence plus fodder may not exceed 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_percent_ai.Value + focus_group_edit.textbox_percent_bull.Value > 100) then
   begin
       ShowMessage('The total percentage of farmers using A.I. plus bull service may not exceed 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_credit_formal.Value + focus_group_edit.textbox_credit_informal.Value > 100) then
   begin
       ShowMessage('The total percentage of informal plus formal credit availability may not exceed 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_feed_processing.Value > 100) then
   begin
       ShowMessage('The percentage of farmers engaged in feed processing may not exceed 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (((focus_group_edit.textbox_feed_processing_female.Text <> '') OR (focus_group_edit.textbox_feed_processing_male.Text <> '')) AND (focus_group_edit.textbox_feed_processing_female.Value + focus_group_edit.textbox_feed_processing_male.Value <> 100)) then
   begin
       ShowMessage('The total percentage of female plus male farmers engaged in feed processing should equal 100 (Agro-Economic Data Tab)');
       Cancel := True;
   end;
   if (focus_group_edit.textbox_labour_cost_max.Value= 0) AND (focus_group_edit.textbox_labour_cost_min.Value = 0) then
   begin
       ShowMessage('Please enter the minimum and maximum cost of labour (Labour Tab)');
       Cancel := True;
   end else
   if (focus_group_edit.textbox_labour_cost_max.Value <= focus_group_edit.textbox_labour_cost_min.Value) then
   begin
       ShowMessage('The maximum daily cost of labour must be greater than the minimum (Labour Tab)');
       Cancel := True;
   end;

    validate_skip := SQLExecute('SELECT validate_no_respondents FROM focus_group WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    if validate_skip = 0 then
    begin
    count_target := 9;
    if focus_group_edit.fg_convert_ng.Visible = true then
    begin
      count_target := 6;
    end;
    count_blanks := SQLExecute('SELECT COUNT (*) FROM respondent WHERE respondent.id_focus_group = '+IntToStr(id_focus_group_record) );
    if count_blanks < count_target then
    begin
          dialog_response := MessageDlg('You have entered data for '+IntToStr(count_blanks)+' interview respondents.  The recommended minimum number of interview respondents is '+IntToStr(count_target)+'.  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE focus_group SET validate_no_respondents = 1 WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

end;

if Cancel <> True then
begin
focus_group_new_record := 0;


// Write TechFit Data

    id_techfit_assessment_record := SQLExecute('SELECT techfit_assessment.id FROM focus_group LEFT OUTER JOIN techfit_assessment ON techfit_assessment.id_focus_group = focus_group.id WHERE focus_group.id = '+IntToStr(id_focus_group_record) );
    id_core_commodity_selected := focus_group_edit.combo_core_commodity.dbItemID;
    id_agriculture_system_selected := focus_group_edit.combo_agriculture_system.dbItemID;
    max_cost_labour := focus_group_edit.textbox_labour_cost_max.Value;
    min_cost_labour := focus_group_edit.textbox_labour_cost_min.Value;
    price_lease_ha := focus_group_edit.textbox_price_lease_ha.Value;
    percent_land_cultivated := Trunc(focus_group_edit.textbox_percent_cultivated.Value);
    percent_land_fallow := Trunc(focus_group_edit.textbox_percent_fallow.Value);
    percent_crop_cash := Trunc(focus_group_edit.textbox_percent_cash.Value);
    percent_crop_fodder := Trunc(focus_group_edit.textbox_percent_fodder.Value);
    percent_crop_subsistence := Trunc(focus_group_edit.textbox_percent_subsistence.Value);
    stamp_update := FormatDateTime('yyyy-MM-DD 00:00:00.000', Now);
    techfit_assessment_title := DateToStr(focus_group_edit.date_meeting.Date)+' '+focus_group_edit.textbox_community.Text+' '+focus_group_edit.textbox_venue.Text;
    SQLExecute('UPDATE techfit_assessment SET updated_at = "'+stamp_update+'", updated_by = "'+registration_concatenated_id+'", labour_daily_cost_min = ('+FloatToStr(min_cost_labour)+'), labour_daily_cost_max = ('+FloatToStr(max_cost_labour)+'), percent_land_subsistence = ('+IntToStr(percent_crop_subsistence)+'), percent_land_fodder = ('+IntToStr(percent_crop_fodder)+'), percent_land_cash_crop = ('+IntToStr(percent_crop_cash)+'), percent_land_fallow = ('+IntToStr(percent_land_fallow)+'), percent_land_cultivated = ('+IntToStr(percent_land_cultivated)+'), lease_price_ha_land = ('+FloatToStr(price_lease_ha)+'), id_core_commodity = ('+IntToStr(id_core_commodity_selected)+'), id_agriculture_system_type = ('+IntToStr(id_agriculture_system_selected)+'), title = "'+techfit_assessment_title+'" WHERE techfit_assessment.id = '+IntToStr(id_techfit_assessment_record) );

end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_respondent (Sender: string; var Cancel: boolean);
var
    income_source_total: integer;
    womens_income_source_total: integer;
    dialog_response: integer;
    blank_grid_check: integer;
    validate_skip: integer;
begin
try
    if respondent_edit.button_submit.Tag=1 then exit;
    if ignore_validation = 1 then exit;
    if (respondent_edit.textbox_respondent_name.Text='') OR (respondent_edit.textbox_respondent_age.Text= '') or (respondent_edit.combo_respondent_gender.dbItemID = -1) then
    begin
        ShowMessage('Enter name, age and gender for the respondent.');
        Cancel := True;
    end;
    if respondent_edit.date_interview.Checked = FALSE then
    begin
        ShowMessage('Please enter a date for the interview.');
        Cancel := True;
    end;
    if (respondent_edit.textbox_hh_name.Text='') OR (respondent_edit.textbox_hh_age.Text= '') or (respondent_edit.combo_hh_gender.dbItemID = -1) then
    begin
        ShowMessage('Enter name, age and gender for the head of household (if same as respondent, check the box for "Respondent is Head of Household").');
        Cancel := True;
    end;

    if (respondent_edit.textbox_cultivated_land.Text = '') OR (respondent_edit.combo_unit_area.dbItemID = -1) OR (respondent_edit.combo_landholding_category.dbItemID = -1) then
    begin
        ShowMessage('Please enter the amount of cultivated land, units of area and landholding category for the respondent (Property / Income tab)');
        Cancel := True;
    end;
    if focus_group_edit.fg_convert_ng.Visible = true then
    begin

    validate_skip := SQLExecute('SELECT validate_no_coop FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM coop_membership WHERE coop_membership.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY coop_membership.id_respondent LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There are no coop memberships for this respondent. Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_coop = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;                                                                                                                                                                                                                    
    end;    
    
      if ((respondent_edit.textbox_land_own_joint.Value + respondent_edit.textbox_land_own_m.Value + respondent_edit.textbox_land_own_f.Value) <> respondent_edit.textbox_total_land.Value) then
      begin
      ShowMessage('The percentages of joint, male, and female land ownership must add up to total land owned / controlled by household (Property/Income tab).');
         Cancel := True;
      end;
        womens_income_source_total := SQLExecute('SELECT TOTAL(womens_income_activity.pct_womens_income) FROM womens_income_activity WHERE womens_income_activity.id_respondent = '+IntToStr(id_respondent_record) );
        if womens_income_source_total <> 100 then
        begin
            ShowMessage('Percentages for sources of income for women must add up to 100 (Property / Income tab)');
            Cancel := True;
        end;
    end;
    income_source_total := SQLExecute('SELECT TOTAL(income_activity.percent_of_hh_income) FROM income_activity WHERE income_activity.id_respondent = '+IntToStr(id_respondent_record) );
    if income_source_total <> 100 then
    begin
        ShowMessage('Percentages for sources of income must add up to 100 (Property / Income tab)');
        Cancel := True;
    end;
    validate_skip := SQLExecute('SELECT validate_no_livestock_holdings FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM livestock_holding WHERE livestock_holding.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY livestock_holding.id LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There is no data for livestock holdings (Livestock Holdings Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_livestock_holdings = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

    validate_skip := SQLExecute('SELECT validate_no_crops FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM crop_cultivation WHERE crop_cultivation.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY crop_cultivation.id LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There is no data for crops (Crops Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_crops = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

    if (respondent_edit.textbox_diet_grazing.Text = '') OR (respondent_edit.textbox_diet_collected.Text  = '') OR (respondent_edit.textbox_diet_crop_residue.Text  = '') OR (respondent_edit.textbox_diet_purchased_feed.Text  = '') OR (respondent_edit.textbox_diet_cultivated_fodder.Text  = '')then
    begin
        ShowMessage('Enter values for percent contributions of each feed source - grazing, collected fodder, crop residue, cultivated fodder and purchased fodder - to the animals'' diet (Fodder and Diet Tab).');
        Cancel := True;
    end else
    if (respondent_edit.textbox_diet_grazing.Value + respondent_edit.textbox_diet_collected.Value + respondent_edit.textbox_diet_cultivated_fodder.Value + respondent_edit.textbox_diet_purchased_feed.Value + respondent_edit.textbox_diet_crop_residue.Value) > 100 then
    begin
        ShowMessage('Contributions of the various feed sources to the animals diet cannot exceed 100 percent (Fodder and Diet Tab).").');
        Cancel := True;
    end;

    validate_skip := SQLExecute('SELECT validate_no_cultivated_fodder FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM fodder_crop_cultivation WHERE fodder_crop_cultivation.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY fodder_crop_cultivation.id LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There is no data for fodder crops (Fodder and Diet Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_cultivated_fodder = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

    validate_skip := SQLExecute('SELECT validate_no_purchased_feed FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM purchased_feed WHERE purchased_feed.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY purchased_feed.id LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There is no data for purchased feed (Fodder and Diet Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_purchased_feed = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;


    validate_skip := SQLExecute('SELECT validate_no_livestock_sales FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM livestock_sale WHERE livestock_sale.number_sold IS NOT NULL AND livestock_sale.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY livestock_sale.id LIMIT 1');
    if (blank_grid_check = 0) then
    begin
          dialog_response := MessageDlg('There is no data for livestock sales (Livestock Sales Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_livestock_sales = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

    validate_skip := SQLExecute('SELECT validate_no_market_prices FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM respondent_monthly_statistics WHERE respondent_monthly_statistics.market_price_cattle IS NULL AND respondent_monthly_statistics.market_price_sheep IS NULL and respondent_monthly_statistics.market_price_goat IS NULL AND respondent_monthly_statistics.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY respondent_monthly_statistics.id_respondent LIMIT 1');
    if (blank_grid_check > 0) then
    begin
          dialog_response := MessageDlg('There are months without any data for livestock prices (Livestock Sales Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_market_prices = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;

    validate_skip := SQLExecute('SELECT validate_no_milk_yield FROM respondent WHERE respondent.id = '+IntToStr(id_respondent_record) );
    if validate_skip = 0 then
    begin
    blank_grid_check := SQLExecute('SELECT COUNT (*) FROM respondent_monthly_statistics WHERE (respondent_monthly_statistics.milk_average_yield IS NULL OR respondent_monthly_statistics.milk_average_price_litre IS NULL) AND respondent_monthly_statistics.id_respondent = '+IntToStr(id_respondent_record)+' ORDER BY respondent_monthly_statistics.id_respondent LIMIT 1');
    if (blank_grid_check > 0) then
    begin
          dialog_response := MessageDlg('There are months without any data for milk yield or milk price (Milk Tab).  Was this intentional?', mtInformation, mbYes+mbNo+mbIgnore, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE respondent SET validate_no_milk_yield = 1 WHERE respondent.id = '+IntToStr(id_respondent_record) );
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end else
          if dialog_response = mrIgnore then
          begin
          end;
     end;
    end;


    count_blanks := SQLExecute('WITH monthly_availability AS (SELECT TOTAL(feed_source_availability.percentage) AS sum_of_percentages FROM feed_source_availability WHERE feed_source_availability.id_respondent = '+IntToStr(id_respondent_record)+' GROUP BY feed_source_availability.id_month) SELECT COUNT (*) FROM monthly_availability WHERE monthly_availability.sum_of_percentages <> 10');
    if count_blanks > 0 then
    begin
        ShowMessage('Please enter feed availability data for every month of the year (Feed Availability Tab).');
        Cancel := True;
    end;

    if (focus_group_edit.fg_convert_ng.Visible = true) then
    begin
       count_blanks := SQLExecute('SELECT COUNT (*) FROM decision_making_by_household WHERE decision_making_by_household.id_gender_group IS NULL AND decision_making_by_household.id_respondent = '+IntToStr(id_respondent_record) );
       if count_blanks > 0 then
       begin
           ShowMessage('Please enter gender information for all decisions (Gender Roles Tab)');
           Cancel := True;
       end;

    count_blanks := SQLExecute('SELECT COUNT (*) FROM feed_labor_division WHERE feed_labor_division.id_labor_division_group IS NULL AND feed_labor_division.id_respondent = '+IntToStr(id_respondent_record) );
    if count_blanks > 0 then
    begin
       ShowMessage('Please enter labor group information for all labor types (Gender Roles Tab)');
       Cancel := True;
    end;

    end;

if Cancel <> True then
begin
respondent_new_record := 0;
end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_income_source_count (Sender: string; var Cancel: boolean);
var
income_source_count: integer;
begin
try
    income_source_count := SQLExecute('SELECT COUNT (*) FROM income_activity WHERE income_activity.id_respondent = '+IntToStr(id_respondent_record) );
    if income_source_count < 4 then exit;
    ShowMessage('Only the top four sources of income may be entered.');
    Cancel := True;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_income_source_count_women (Sender: string; var Cancel: boolean);
var
income_source_count: integer;
begin
try
    income_source_count := SQLExecute('SELECT COUNT (*) FROM womens_income_activity WHERE womens_income_activity.id_respondent = '+IntToStr(id_respondent_record) );
    if income_source_count < 4 then exit;
    ShowMessage('Only the top four sources of income may be entered.');
    Cancel := True;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure validate_feed_source_availability (Sender: string; var Cancel: boolean);
begin
try
    if respondent_edit_feed_source_availability.textbox_percentage.Text = '' then
    begin
    ShowMessage('Please enter the percentage of animal nutrition that comes from this source during this month.');
    Cancel := True;
    end else
    if respondent_edit_feed_source_availability.textbox_percentage.Value > 100 then
    begin
    ShowMessage('The percentage contribution to the animal diet may not exceed 100');
    Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_livestock_holding (Sender: string; var Cancel: boolean);
var
    livestock_weight: extended;
    livestock_holding_count: integer;
    livestock_holding_type_dbid: integer;
begin
try
    livestock_holding_type_dbid := respondent_edit_livestock_holding.combo_animal_type.dbItemID;
    livestock_holding_count := SQLExecute('SELECT COUNT (*) FROM livestock_holding WHERE livestock_holding.id_animal_type = '+IntToStr(livestock_holding_type_dbid)+' AND livestock_holding.id_respondent = '+IntToStr(id_respondent_record)+' AND livestock_holding.id <> '+IntToStr(respondent_edit_livestock_holding.button_submit.dbGeneralTableId)+' ORDER BY livestock_holding.id LIMIT 1');
    if livestock_holding_count > 0 then
    begin
    ShowMessage('An entry for this type of livestock already exists for this respondent.');
    Cancel := True;
    end;
    if ((respondent_edit_livestock_holding.textbox_average_weight.Text = '') or (respondent_edit_livestock_holding.textbox_average_weight.Text = '0')) then
    begin
        ShowMessage('Please enter the average weight of the animals.');
        Cancel := True;
    end else
    if ((respondent_edit_livestock_holding.textbox_average_weight.Value > animal_type_weight_max) or (respondent_edit_livestock_holding.textbox_average_weight.Value < animal_type_weight_min)) then
    begin
        ShowMessage('The average weight entered is outside the accepted range for this type of animal.');
        Cancel := True;
    end;
    if respondent_edit_livestock_holding.textbox_headcount.Value = 0 then
    begin
        ShowMessage('Please enter the headcount for animals of this type.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_respondent_edit_availability (Sender: string; var Cancel: boolean);
var
    validate_total: extended;
begin
try
    validate_total := respondent_edit_availability_data.textbox_diet_composition_total.Value;
    if validate_total <> 10 then
    begin
        ShowMessage ('The ratings for the various feed categories must add up to 10');
        Cancel := True;
    end;
    if respondent_edit_availability_data.combo_availability.dbItemID = -1 then
    begin
        ShowMessage ('Please assign a rating for overall feed availability.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_crop (Sender: string; Cancel: boolean);
var
    validate_total: extended;
    validate_crop_type: integer;
    validate_crop_type_count: integer;
    validate_id: integer;
begin
try
    validate_crop_type := respondent_edit_crop.combo_crop_type.dbItemID;
    validate_id := respondent_edit_crop.button_submit.dbGeneralTableId;
    validate_crop_type_count := SQLExecute('SELECT COUNT (*) FROM crop_cultivation WHERE crop_cultivation.id_respondent = '+IntToStr(id_respondent_record)+' AND crop_cultivation.id_crop_type = '+IntToStr(validate_crop_type)+' AND crop_cultivation.id <> '+IntToStr(validate_id)+' ORDER BY crop_cultivation.id LIMIT 1');
    if validate_crop_type_count > 0 then
    begin
        ShowMessage('An entry for this type of crop already exists for this respondent.');
        Cancel := True;
    end;
    validate_total := respondent_edit_crop.textbox_total.Value;
    if validate_total <> 100 then
    begin
        ShowMessage('The percentages for uses of residue must add up to 100');
        Cancel := True;
    end;
    if respondent_edit_crop.combo_crop_type.dbItemID = -1 then
    begin
        ShowMessage ('Please select a crop type.');
        Cancel := True;
    end;
    if respondent_edit_crop.textbox_cultivated_area.Value = 0 then
    begin
        ShowMessage('Please enter the area of cultivated land.');
        Cancel := True;
    end;
    if respondent_edit_crop.combo_unit_area.dbItemID = -1 then
    begin
        ShowMessage('Please select a unit of area.');
        Cancel := True;
    end;
    if respondent_edit_crop.textbox_yield.Value = 0 then
    begin
        ShowMessage('Please enter the yield.');
        Cancel := True;
    end;
    if respondent_edit_crop.combo_unit_mass.dbItemID = -1 then
    begin
        ShowMessage('Please select a unit of weight.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure validate_fodder_crop (Sender: string; Cancel: boolean);
var
    validate_fodder_crop_type: integer;
    validate_fodder_crop_type_count: integer;
    validate_id: integer;
begin
try
    if respondent_edit_fodder_crop.combo_fodder_crop.dbItemID = -1 then
    begin
        ShowMessage('Please select a fodder crop type.');
        Cancel := True;
    end;
    validate_fodder_crop_type := respondent_edit_fodder_crop.combo_fodder_crop.dbItemID;
    validate_id := respondent_edit_fodder_crop.button_submit.dbGeneralTableId;
    validate_fodder_crop_type_count := SQLExecute('SELECT COUNT (*) FROM fodder_crop_cultivation WHERE fodder_crop_cultivation.id_respondent = '+IntToStr(id_respondent_record)+' AND fodder_crop_cultivation.id <> '+IntToStr(validate_id)+' AND fodder_crop_cultivation.id_fodder_crop_type = '+IntToStr(validate_fodder_crop_type)+' ORDER BY fodder_crop_cultivation.id LIMIT 1');
    if validate_fodder_crop_type_count > 0 then
    begin
        ShowMessage('An entry for this fodder crop type already exists for this respondent.');
        Cancel := True;
    end;
    if respondent_edit_fodder_crop.textbox_cultivated_area.Value = 0 then
    begin
        ShowMessage('Please enter the area of cultivated land.');
        Cancel := True;
    end;
    if respondent_edit_fodder_crop.combo_unit_area.dbItemID = -1 then
    begin
        ShowMessage('Please select a unit of area.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_purchase (Sender: string; Cancel: boolean);
var
    validate_purchase_type: integer;
    validate_purchase_type_count: integer;
    validate_id: integer;
begin
try
    if respondent_edit_purchase.combo_purchased_feed_type.dbItemID = -1 then
    begin
        ShowMessage ('Please select a feed type.');
        Cancel := True;
    end;
    validate_purchase_type := respondent_edit_purchase.combo_purchased_feed_type.dbItemID;
    validate_id := respondent_edit_purchase.button_submit.dbGeneralTableId;
    validate_purchase_type_count := SQLExecute('SELECT COUNT (*) FROM purchased_feed WHERE  purchased_feed.id_respondent = '+IntToStr(id_respondent_record)+' AND purchased_feed.id_purchased_feed_type = '+IntToStr(validate_purchase_type)+' AND purchased_feed.id <> '+IntToStr(validate_id)+' ORDER BY purchased_feed.id LIMIT 1');
    if validate_purchase_type_count > 0 then
    begin
        ShowMessage('An entry for this type of purchased feed already exists for this respondent.');
        Cancel := True;
    end;
    if respondent_edit_purchase.textbox_quantity.Value = 0 then
    begin
        ShowMessage('Please enter the quantity purchased.');
        Cancel := True;
    end;
    if respondent_edit_purchase.combo_units_mass.dbItemID = -1 then
    begin
        ShowMessage('Please select a unit of weight/mass.');
        Cancel := True;
    end;
    if respondent_edit_purchase.textbox_price.Value = 0 then
    begin
        ShowMessage('Please enter the price per unit.');
        Cancel := True;
    end;
    if respondent_edit_purchase.textbox_purchases.Value = 0 then
    begin
        ShowMessage('Please enter the number of times purchased per year.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_milk_data (Sender: string; Cancel: boolean);
begin
try
    if respondent_edit_milk_data.textbox_retained.Value > respondent_edit_milk_data.textbox_yield.Value then
    begin
        ShowMessage('Amount of milk retained cannot be higher than the yield.');
        Cancel := True;
    end;

 except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_offtake (Sender: string; Cancel: boolean);
begin
try
    if (respondent_edit_livestock_sale.textbox_number_sold.Value > 0) AND (respondent_edit_livestock_sale.textbox_weight.Value = 0) then
    begin
        ShowMessage('Please enter an approximate average weight for the livestock slaughtered or sold.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure validate_edit_custom_income_source (Sender: string; var Cancel: boolean);
var
    validate_income_source: string;
    validate_income_source_count: integer;
    validate_id: integer;
begin
try
    validate_income_source := statistics_edit_custom_income_source.textbox_description.Text;
    validate_id := statistics_edit_custom_income_source.button_submit.dbGeneralTableId;
    validate_income_source_count := SQLExecute('SELECT COUNT (*) FROM income_activity_type WHERE income_activity_type.description = "'+validate_income_source+'" AND income_activity_type.id <> '+IntToStr(validate_id)+' ORDER BY income_activity_type.id LIMIT 1');
    if validate_income_source_count > 0 then
    begin
        ShowMessage('An income source with this name already exists.')
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_focus_group_edit_season (Sender: string; var Cancel: boolean);
var
    validate_season: string;
    validate_season_count: integer;
    validate_id: integer;
begin
try
    validate_season := focus_group_edit_season.textbox_season.Text;
    validate_id := focus_group_edit_season.button_submit.dbGeneralTableId;
    validate_season_count := SQLExecute('SELECT COUNT (*) FROM season WHERE season.name = "'+validate_season+'" AND season.id <> '+IntToStr(validate_id)+' AND season.id_focus_group = '+IntToStr(id_focus_group_record)+' ORDER BY season.id LIMIT 1');
    if validate_season_count > 0 then
    begin
        ShowMessage('A season with this name already exists for this focus group.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_focus_group_edit_labour_activity (Sender: string; var Cancel: boolean);
var
    validate_activity: string;
    validate_activity_count: integer;
    validate_id: integer;
begin
try
    validate_id := focus_group_edit_labour_activity.button_submit.dbGeneralTableId;
    validate_activity := focus_group_edit_labour_activity.textbox_description.Text;
    validate_activity_count := SQLExecute('SELECT COUNT (*) FROM labour_activity WHERE labour_activity.description = "'+validate_activity+'" AND labour_activity.id <> '+IntToStr(validate_id)+' AND labour_activity.id_focus_group = '+IntToStr(id_focus_group_record)+' ORDER BY labour_activity.id LIMIT 1');
    if validate_activity_count > 0 then
    begin
        ShowMessage('An entry for this labour activity already exists for this focus group.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_edit_income_source (Sender: string; var Cancel: boolean);
var
    validate_integer: integer;
    validate_check_against_input: integer;
    validate_difference: integer;
    validate_input: integer;
    validate_income_source: integer;
    validate_income_source_count: integer;
    validate_id: integer;
begin
try
    validate_income_source := edit_income_source.combo_activity.dbItemID;
    validate_id := edit_income_source.button_submit.dbGeneralTableId;
    validate_income_source_count := SQLExecute('SELECT COUNT (*) FROM income_activity WHERE (income_activity.id_respondent = '+IntToStr(id_respondent_record)+' AND income_activity.id <> '+IntToStr(validate_id)+' AND income_activity.id_income_activity_type = '+IntToStr(validate_income_source)+') ORDER BY income_activity.id LIMIT 1');
    if validate_income_source_count > 0 then
    begin
        ShowMessage('An entry for this income source already exists for this respondent.');
        Cancel := True;
    end;
    validate_input := StrToInt(edit_income_source.textbox_contribution.Text);
    validate_integer := SQLExecute('SELECT TOTAL(income_activity.percent_of_hh_income) as income_validation FROM income_activity LEFT OUTER JOIN respondent ON income_activity.id_respondent WHERE income_activity.id_respondent = '+IntToStr(id_respondent_record)+' AND income_activity.id <> '+IntToStr(validate_id)+' GROUP BY respondent.id');
    validate_check_against_input := validate_integer + validate_input;
    validate_difference := 100 - validate_integer;
    if validate_check_against_input > 100 then
    begin
        ShowMessage('The total percentage of all income sources may not exceed 100.  Please edit the amounts for other income sources or enter a value between zero and '+IntToStr(validate_difference));
        Cancel := True;
    end;
    if focus_group_edit.fg_convert_ng.Visible = true then
    begin
      if edit_income_source.combo_income_use_gender.dbItemID = -1 then
      begin
        ShowMessage('Please specify which gender can access / determines the use of this income source.');
        Cancel := True;
      end;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_edit_income_source_women (Sender: string; var Cancel: boolean);
var
    validate_integer: integer;
    validate_check_against_input: integer;
    validate_difference: integer;
    validate_input: integer;
    validate_income_source: integer;
    validate_income_source_count: integer;
    validate_id: integer;
begin
try
    validate_income_source := edit_income_source_women.combo_activity.dbItemID;
    validate_id := edit_income_source_women.button_submit.dbGeneralTableId;
    validate_income_source_count := SQLExecute('SELECT COUNT (*) FROM womens_income_activity WHERE (womens_income_activity.id_respondent = '+IntToStr(id_respondent_record)+' AND womens_income_activity.id <> '+IntToStr(validate_id)+' AND womens_income_activity.id_income_activity_type = '+IntToStr(validate_income_source)+') ORDER BY womens_income_activity.id LIMIT 1');
    if validate_income_source_count > 0 then
    begin
        ShowMessage('An entry for this income source already exists for this respondent.');
        Cancel := True;
    end;
    validate_input := StrToInt(edit_income_source_women.textbox_contribution.Text);
    validate_integer := SQLExecute('SELECT TOTAL(womens_income_activity.pct_womens_income) as income_validation FROM womens_income_activity LEFT OUTER JOIN respondent ON womens_income_activity.id_respondent WHERE womens_income_activity.id_respondent = '+IntToStr(id_respondent_record)+' AND womens_income_activity.id <> '+IntToStr(validate_id)+' GROUP BY respondent.id');
    validate_check_against_input := validate_integer + validate_input;
    validate_difference := 100 - validate_integer;
    if validate_check_against_input > 100 then
    begin
        ShowMessage('The total percentage of all income sources may not exceed 100.  Please edit the amounts for other income sources or enter a value between zero and '+IntToStr(validate_difference));
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure validate_statistics_custom_animal_category (Sender: string; var Cancel: boolean);
var
    validate_category: string;
    validate_category_count: integer;
    validate_id: integer;
begin
try
    validate_id := statistics_custom_animal_category.button_submit.dbGeneralTableId;
    validate_category := statistics_custom_animal_category.textbox_description.Text;
    validate_category_count := SQLExecute('SELECT COUNT (*) FROM animal_category WHERE animal_category.description = "'+validate_category+'" AND animal_category.id <> '+IntToStr(validate_id)+' ORDER BY animal_category.id LIMIT 1');
    if validate_category_count > 0 then
    begin
        ShowMessage('An animal category with this name already exists.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure update_animal_category_combos (Sender: string; var Cancel: boolean);
begin
try
UpdateDatabase('animal_category');
If statistics_custom_animal_type.Visible then
        statistics_custom_animal_type.combo_species.dbItemID := -1;
except
ShowMessage(ExceptionMessage);
end;
end;

procedure validate_statistics_custom_species (Sender: string; var Cancel: boolean);
var
    validate_species: string;
    validate_species_count: integer;
    validate_id: integer;
begin
try
    if statistics_custom_species.textbox_description.Text = '' then
    begin
        ShowMessage('Enter a name for the species.');
        Cancel := True;
    end;
    validate_id := statistics_custom_species.button_submit.dbGeneralTableId;
    validate_species := statistics_custom_species.textbox_description.Text;
    validate_species_count := SQLExecute('SELECT COUNT (*) FROM animal_species WHERE animal_species.description = "'+validate_species+'" AND animal_species.id <> '+IntToStr(validate_id)+' ORDER BY animal_species.id LIMIT 1');
    if validate_species_count > 0 then
    begin
        ShowMessage('An animal category with this name already exists.');
        Cancel := True;
    end;
    add_category_from_species_flag := 1;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_statistics_edit_community (Sender: string; var Cancel: boolean);
var
    validate_community: string;
    validate_community_count: integer;
    validate_id: integer;
begin
try
    validate_id := statistics_custom_species.button_submit.dbGeneralTableId;
    validate_community := statistics_custom_species.textbox_description.Text;
    validate_community_count := SQLExecute('SELECT COUNT (*) FROM community_type WHERE community_type.description = "'+validate_community+'" AND community_type.id <> '+IntToStr(validate_id)+' ORDER BY community_type.id LIMIT 1');
    if validate_community_count > 0 then
    begin
        ShowMessage('An entry already exists for this type of community.');
        Cancel := True;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_crop_information (Sender: string; var Cancel: boolean);
var
    validate_crop_type: string;
    validate_crop_type_count: integer;
    validate_id: integer;
begin
try
    validate_id := statistics_edit_crop_information.button_submit.dbGeneralTableId;
    validate_crop_type := statistics_edit_crop_information.textbox_name.Text;
    if validate_crop_type = '' then
    begin
        ShowMessage('Please enter a name for the crop type');
        Cancel := True;
    end;
    validate_crop_type_count := SQLExecute('SELECT COUNT (*) FROM crop_type WHERE crop_type.name = "'+validate_crop_type+'" AND crop_type.id <> '+IntToStr(validate_id)+' ORDER BY crop_type.id LIMIT 1');
    if validate_crop_type_count > 0 then
    begin
        ShowMessage('A crop with this name already exists in the database.');
        Cancel := True;
    end;
    if (statistics_edit_crop_information.textbox_cp.Text = '') OR (statistics_edit_crop_information.textbox_cp.Value > 100) OR (statistics_edit_crop_information.textbox_cp.Value <0) then
    begin
        ShowMessage('Please enter a value between 0 and 100 for crude protein content percentage.');
        Cancel := True;
    end;
    if statistics_edit_crop_information.textbox_me.Text = '' then
    begin
        ShowMessage('Please enter a value for metabolisable energy content.');
        Cancel := True;
    end;
    if (statistics_edit_crop_information.textbox_dm.Text = '') OR (statistics_edit_crop_information.textbox_dm.Value > 100) OR (statistics_edit_crop_information.textbox_dm.Value <0) then
    begin
        ShowMessage('Please enter a value between 0 and 100 for dry matter content percentage.');
        Cancel := True;
    end;
    if (statistics_edit_crop_information.textbox_harvest_index.Value > 1) OR (statistics_edit_crop_information.textbox_harvest_index.Value < 0) OR (statistics_edit_crop_information.textbox_harvest_index.Text = '') then
    begin
        ShowMessage('Please enter a value between 0 and 1 for the harvest index.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_fodder_crop_information (Sender: string; var Cancel: boolean);
var
    validate_fodder_crop_type: string;
    validate_fodder_crop_type_count: integer;
    validate_id: integer;
begin
try
    validate_id := statistics_edit_fodder_crop_information.button_submit.dbGeneralTableId;
    validate_fodder_crop_type := statistics_edit_fodder_crop_information.textbox_name.Text;
    if validate_fodder_crop_type = '' then
    begin
        ShowMessage('Please enter a name for the fodder crop type');
        Cancel := True;
    end;
    validate_fodder_crop_type_count := SQLExecute('SELECT COUNT (*) FROM fodder_crop_type WHERE fodder_crop_type.name = "'+validate_fodder_crop_type+'" AND fodder_crop_type.id <> '+IntToStr(validate_id)+' ORDER BY fodder_crop_type.id LIMIT 1');
    if validate_fodder_crop_type_count > 0 then
    begin
        ShowMessage('A fodder crop with this name already exists in the database.');
        Cancel := True;
    end;
    if (statistics_edit_fodder_crop_information.textbox_cp.Text = '') OR (statistics_edit_fodder_crop_information.textbox_cp.Value > 100) OR (statistics_edit_fodder_crop_information.textbox_cp.Value <0) then
    begin
        ShowMessage('Please enter a value between 0 and 100 for crude protein content percentage.');
        Cancel := True;
    end;
    if statistics_edit_fodder_crop_information.textbox_me.Text = '' then
    begin
        ShowMessage('Please enter a value for metabolisable energy content.');
        Cancel := True;
    end;
    if (statistics_edit_fodder_crop_information.textbox_kg_dm_ha_year.Text = '') then
    begin
        ShowMessage('Please enter a value for kg dry matter per hectare per yeare.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_purchased_feed_information (Sender: string; var Cancel: boolean);
var
    validate_purchased_feed_type: string;
    validate_purchased_feed_type_count: integer;
    validate_id: integer;
begin
try
    validate_purchased_feed_type := statistics_edit_purchased_feed_information.textbox_name.Text;
    if validate_purchased_feed_type = '' then
    begin
        ShowMessage('Please enter a name for the purchased feed type');
        Cancel := True;
    end;
    validate_id := statistics_edit_purchased_feed_information.button_submit.dbGeneralTableId;
    validate_purchased_feed_type_count := SQLExecute('SELECT COUNT (*) FROM purchased_feed_type WHERE purchased_feed_type.name = "'+validate_purchased_feed_type+'" AND purchased_feed_type.id <> '+IntToStr(validate_id)+' ORDER BY purchased_feed_type.id LIMIT 1');
    if validate_purchased_feed_type_count > 0 then
    begin
        ShowMessage('A purchased feed type with this name already exists in the database.');
        Cancel := True;
    end;
    if (statistics_edit_purchased_feed_information.textbox_cp.Text = '') OR (statistics_edit_purchased_feed_information.textbox_cp.Value > 100) OR (statistics_edit_purchased_feed_information.textbox_cp.Value <0) then
    begin
        ShowMessage('Please enter a value between 0 and 100 for crude protein content percentage.');
        Cancel := True;
    end;
    if statistics_edit_purchased_feed_information.textbox_me.Text = '' then
    begin
        ShowMessage('Please enter a value for metabolisable energy content.');
        Cancel := True;
    end;
    if (statistics_edit_purchased_feed_information.textbox_dm_pct.Text = '') OR (statistics_edit_purchased_feed_information.textbox_dm_pct.Value > 100) OR (statistics_edit_purchased_feed_information.textbox_dm_pct.Value <0) then
    begin
        ShowMessage('Please enter a value between 0 and 100 for dry matter content percentage.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_statistics_edit_unit_area (Sender: string; var Cancel: boolean);
var
    validate_unit_area: string;
    validate_unit_area_count: integer;
    validate_id: integer;
begin
try
    validate_unit_area := statistics_edit_unit_area.textbox_name.Text;
    validate_id := statistics_edit_unit_area.button_submit.dbGeneralTableId;
    validate_unit_area_count := SQLExecute('SELECT COUNT (*) FROM unit_area WHERE unit_area.name = "'+validate_unit_area+'" AND unit_area.id <> '+IntToStr(validate_id)+' ORDER BY unit_area.id LIMIT 1');
    if validate_unit_area_count > 0 then
    begin
        ShowMessage('A unit_ with this name already exists in the database.');
        Cancel := True;
    end;
    if (statistics_edit_unit_area.textbox_equivalent_ha.Text = '') then
    begin
        ShowMessage('Please enter the equivalent value in hectares.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_statistics_edit_unit_mass_weight (Sender: string; var Cancel: boolean);
var
    validate_unit_mass_weight: string;
    validate_unit_mass_weight_count: integer;
    validate_id: integer;
begin
try
    validate_unit_mass_weight := statistics_edit_unit_mass.textbox_name.Text;
    validate_id := statistics_edit_unit_mass.button_submit.dbGeneralTableId;
    validate_unit_mass_weight_count := SQLExecute('SELECT COUNT (*) FROM unit_mass_weight WHERE unit_mass_weight.name = "'+validate_unit_mass_weight+'" AND unit_mass_weight.id <> '+IntToStr(validate_id)+' ORDER BY unit_mass_weight.id LIMIT 1');
    if validate_unit_mass_weight_count > 0 then
    begin
        ShowMessage('A unit with this name already exists in the database.');
        Cancel := True;
    end;
    if statistics_edit_unit_mass.textbox_equivalent_kg.Text = '' then
    begin
        ShowMessage('Please enter the equivalent value in kilograms.');
        Cancel := True;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_custom_feed_source (Sender: string; var Cancel: boolean);
var
    validate_feed_source: string;
    validate_feed_source_count: integer;
    validate_id: integer;
begin
try
    validate_feed_source := statistics_edit_custom_feed_source.textbox_description.Text;
    validate_id := statistics_edit_custom_feed_source.button_submit.dbGeneralTableId;
    validate_feed_source_count := SQLExecute('SELECT COUNT (*) FROM feed_source WHERE feed_source.description = "'+validate_feed_source+'" AND id_site = '+IntToStr(id_site_record)+' AND feed_source.id <> '+IntToStr(validate_id)+' ORDER BY feed_source.id LIMIT 1');
    if validate_feed_source_count > 0 then
    begin
        ShowMessage('A feed source with this name already exists in the database.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure custom_feed_source_OnAfterClick (Sender: string; var Cancel: boolean);
var
    validate_id: integer;
    i: integer;
begin
try
  if global_action = 'NewRecord' then
  validate_id := statistics_edit_custom_feed_source.button_submit.dbGeneralTableId;
  begin
    for i := 1 to 12 do
        begin
            SQLExecute('INSERT INTO feed_source_availability (id_respondent, id_feed_source, id_month) SELECT respondent.id, '+IntToStr(validate_id)+', '+IntToStr(i)+' FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group WHERE focus_group.id_site = '+IntToStr(id_site_record) );
        end;
    stamp_incremental := SQLExecute('SELECT COUNT (*) FROM feed_source_availability WHERE unique_identifier IS NULL');
    for i:= 1 to stamp_incremental do
        begin
            SQLExecute('UPDATE feed_source_availability SET created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "fsav_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM feed_source_availability WHERE unique_identifier IS NULL ORDER BY id ASC LIMIT 1)');
        end;
  end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_custom_livestock_sale_category (Sender: string; var Cancel: boolean);
var
    validate_sale_category_count: integer;
    sale_category_identifier: integer;
    livestock_sale_records: integer;
    livestock_sale_records_plus_one: integer;
    i: integer;
begin
try
    idRecord := edit_livestock_sale_category.combo_species.dbItemID;
    validate_sale_category_count := SQLExecute('SELECT COUNT (*) FROM livestock_sale_category WHERE livestock_sale_category.id_animal_species = '+IntToStr(idRecord)+' ORDER BY livestock_sale_category.id LIMIT 1');
    if validate_sale_category_count > 0 then
    begin
        ShowMessage('That species is already included as a livestock sale category.');
        Cancel := True;
    end else
    begin
    edit_livestock_sale_category.Close;
    livestock_sale_records := SQLExecute('SELECT MAX (livestock_sale_category.id) FROM livestock_sale_category');
    livestock_sale_records_plus_one := livestock_sale_records + 1;
    SQLExecute('INSERT INTO livestock_sale_category (id_gender, id_animal_species, canonical_data) VALUES (1,'+IntToStr(idRecord)+', 0)');
    SQLExecute('UPDATE livestock_sale_category SET created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "lsct_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(livestock_sale_records)))+'" WHERE unique_identifier IS NULL');
    sale_category_identifier := SQLExecute('SELECT livestock_sale_category.id FROM livestock_sale_category WHERE livestock_sale_category.id_animal_species = '+IntToStr(idRecord)+' AND livestock_sale_category.id_gender = 1');
    SQLExecute('INSERT INTO livestock_sale (id_respondent) SELECT respondent.id FROM respondent');
    stamp_incremental := SQLExecute('SELECT COUNT (*) FROM livestock_sale WHERE unique_identifier IS NULL');
    for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE livestock_sale SET canonical_data = 0, id_livestock_sale_category = '+IntToStr(sale_category_identifier)+', created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "lssa_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM livestock_sale WHERE unique_identifier IS NULL ORDER BY id ASC LIMIT 1)');
        end;
    SQLExecute('INSERT INTO livestock_sale_category (id_gender, id_animal_species, canonical_data) VALUES (2, '+IntToStr(idRecord)+', 0)');
    SQLExecute('UPDATE livestock_sale_category SET created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "lsct_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(livestock_sale_records_plus_one)))+'" WHERE unique_identifier IS NULL');
    sale_category_identifier := SQLExecute('SELECT livestock_sale_category.id FROM livestock_sale_category WHERE livestock_sale_category.id_animal_species = '+IntToStr(idRecord)+' AND livestock_sale_category.id_gender = 2');
    SQLExecute('INSERT INTO livestock_sale (id_respondent) SELECT respondent.id FROM respondent');
    stamp_incremental := SQLExecute('SELECT COUNT (*) FROM livestock_sale WHERE unique_identifier IS NULL');
    for i := 1 to stamp_incremental do
        begin
        SQLExecute('UPDATE livestock_sale SET canonical_data = 0, id_livestock_sale_category = '+IntToStr(sale_category_identifier)+', created_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", created_by = "'+registration_concatenated_id+'", updated_at = "'+FormatDateTime('yyyy-MM-DD 00:00:00.000', Now)+'", updated_by = "'+registration_concatenated_id+'", unique_identifier = "lssa_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i)))+'" WHERE id IN (SELECT id FROM livestock_sale WHERE unique_identifier IS NULL ORDER BY id ASC LIMIT 1)');
        end;
    statistics_units.grid_custom_livestock_sales.dbUpdate;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure delete_livestock_sale_category (Sender: string; var Cancel: boolean);
var
    validate_id: integer;
    species_to_remove: integer;
    i: integer;
begin
try
  idRecord := statistics_units.grid_custom_livestock_sales.dbItemID;
  if idRecord = -1 then
  begin
      ShowMessage('Please select a record from the table.'); //bookmark
      Cancel := true;
  end;
  species_to_remove := SQLExecute('SELECT livestock_sale_category.id_animal_species FROM livestock_sale_category WHERE livestock_sale_category.id = '+IntToStr(idRecord) );
  SQLExecute('DELETE FROM livestock_sale_category WHERE livestock_sale_category.id_animal_species = '+IntToStr(species_to_remove) );
  statistics_units.grid_custom_livestock_sales.dbUpdate;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure new_livestock_category_onclick (Sender: string; var Cancel: boolean);
begin
try
  idRecord := statistics_edit_species_categories.grid_categories.dbItemID;
  if idRecord = -1 then
  begin
      ShowMessage('Please select a record from the table.'); //bookmark
      Cancel := true;
  end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure validate_statistics_custom_animal_type (Sender: string; var Cancel: boolean);
var
    validate_custom_animal_type: string;
    validate_custom_animal_type_count: integer;
    validate_id: integer;
begin
try
    validate_custom_animal_type := statistics_custom_animal_type.textbox_description.Text;
    validate_id := statistics_custom_animal_type.button_submit.dbGeneralTableId;
    validate_custom_animal_type_count := SQLExecute('SELECT COUNT (*) FROM animal_type WHERE animal_type.description = "'+validate_custom_animal_type+'" AND animal_type.id <> '+IntToStr(validate_id)+' ORDER BY animal_type.id LIMIT 1');
    if validate_custom_animal_type_count > 0 then
    begin
        ShowMessage('An animal type with this name already exists for this species and category.');
        Cancel := True;
    end;
    if statistics_custom_animal_type.combo_category.dbItemID = -1 then
    begin
        ShowMessage('Please select a species and category.');
        Cancel := True;
    end;
    if statistics_custom_animal_type.textbox_weight_max.Value <= statistics_custom_animal_type.textbox_weight_min.Value then
    begin
        ShowMessage('The maximum weight must be greater than the minimum weight.');
        Cancel := True;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;


// *** TEXT LINKS ***

procedure statistics_edit_unit_mass_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_unit_mass.textbox_equivalent_kg.Text := '';
    statistics_edit_unit_mass.textbox_name.Text := '';
    statistics_edit_unit_mass.combo_standard_local.dbItemID := -1;
    statistics_edit_unit_mass.stamp_created_at.Checked := FALSE;
    statistics_edit_unit_mass.stamp_created_by.Text := '';
    statistics_edit_unit_mass.stamp_unique_identifier.Text := '';
    statistics_edit_unit_mass.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_unit_area_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_unit_area.textbox_equivalent_ha.Text := '';
    statistics_edit_unit_area.textbox_name.Text := '';
    statistics_edit_unit_area.combo_standard_local.dbItemID := -1;
    statistics_edit_unit_area.stamp_created_at.Checked := FALSE;
    statistics_edit_unit_area.stamp_created_by.Text := '';
    statistics_edit_unit_area.stamp_unique_identifier.Text := '';
    statistics_edit_unit_area.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_currency_OnClick (Sender: string; Action: string);
begin
try
    statistics_units.grid_currency.dbSQL := ('SELECT currency.abbreviation, currency.name, default_usd_exchange_rate, currency.current_usd_exchange_rate, currency.id FROM site LEFT OUTER JOIN currency ON site.id_currency = currency.id WHERE site.id = '+IntToStr(id_site_record)) ;
    statistics_units.grid_currency.dbGeneralTable := 'currency';
    statistics_units.grid_currency.dbListFieldsNames := 'Currency,Name,Default Value in USD,Current Exchange Rate,delete_col';
    statistics_units.grid_currency.dbSQLExecute;
    statistics_units.grid_currency.SelectedRow := 0;
    ignore_validation := 1;
    statistics_units.button_edit_exchange_rate.Click;
    ignore_validation := 0;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure statistics_edit_currency_site_OnClick (Sender: string; var Cancel: boolean);
begin
try
    idRecord := project_edit_site.combo_currency.dbItemID;
    if idRecord = -1 then
    begin;
        ShowMessage('Please select a currency');
        Cancel := True;
    end else
    begin
    statistics_units.grid_currency.dbSQL := ('SELECT currency.abbreviation, currency.name, default_usd_exchange_rate, currency.current_usd_exchange_rate, currency.id FROM site LEFT OUTER JOIN currency ON site.id_currency = currency.id WHERE site.id = '+IntToStr(id_site_record)) ;
    statistics_units.grid_currency.dbGeneralTable := 'currency';
    statistics_units.grid_currency.dbListFieldsNames := 'Currency,Name,Default Value in USD,Current Exchange Rate,delete_col';
    statistics_units.grid_currency.dbSQLExecute;
    statistics_units.grid_currency.SelectedRow := 0;
    ignore_validation := 1;
    statistics_units.button_edit_exchange_rate.Click;
    ignore_validation := 0;
    end;

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_currency_reset_OnClick (Sender: string; var Cancel: boolean);
var
dialog_response: integer;
begin
try
    dialog_response := MessageDlg('This will reset all currency exchange rates to their default values.  Do you wish to continue?', mtInformation, mbYes+mbNo, 0);
          if dialog_response = mrYes then
          begin
          SQLExecute('UPDATE currency SET current_usd_exchange_rate = default_usd_exchange_rate');
          end else
          if dialog_response = mrNo then
          begin
          Cancel := True;
          end;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure statistics_edit_community_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_community.textbox_name.Text := '';
    statistics_edit_community.stamp_created_at.Checked := FALSE;
    statistics_edit_community.stamp_created_by.Text := '';
    statistics_edit_community.stamp_unique_identifier.Text := '';
    statistics_edit_community.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_custom_animal_type_OnClick (Sender: string; Action: string);
begin
try
    statistics_custom_animal_type.textbox_description.Text := '';
    statistics_custom_animal_type.textbox_weight_max.Text := '';
    statistics_custom_animal_type.textbox_weight_min.Text := '';
    statistics_custom_animal_type.combo_category.dbItemID := -1;
    statistics_custom_animal_type.combo_species.dbItemID := -1;
    statistics_custom_animal_type.stamp_created_at.Checked := FALSE;
    statistics_custom_animal_type.stamp_created_by.Text := '';
    statistics_custom_animal_type.stamp_unique_identifier.Text := '';
    statistics_custom_animal_type.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_custom_animal_species_OnClick (Sender: string; Action: string);
begin
try
    statistics_custom_species.textbox_description.Text := '';
    statistics_custom_species.stamp_created_by.Text := '';
    statistics_custom_species.stamp_created_at.Checked := FALSE;
    statistics_custom_species.stamp_created_by.Text := '';
    statistics_custom_species.stamp_unique_identifier.Text := '';
    statistics_custom_species.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_custom_animal_category_OnClick (Sender: string; var Cancel: boolean);
begin
try
    if statistics_custom_animal_type.combo_species.dbItemID = -1 then
    begin
        ShowMessage('Please select a species.');
        Cancel := True;
        Exit;
    end;
    statistics_custom_animal_category.textbox_description.Text := '';
    statistics_custom_animal_category.stamp_created_by.Text := '';
    statistics_custom_animal_category.stamp_created_at.Checked := FALSE;
    statistics_custom_animal_category.stamp_created_by.Text := '';
    statistics_custom_animal_category.stamp_unique_identifier.Text := '';
    statistics_custom_animal_category.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_fodder_crop_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_fodder_crop_information.textbox_name.Text := '';
    statistics_edit_fodder_crop_information.textbox_kg_dm_ha_year.Text := '';
    statistics_edit_fodder_crop_information.textbox_cp.Text := '';
    statistics_edit_fodder_crop_information.textbox_me.Text := '';
    statistics_edit_fodder_crop_information.textbox_reference.Text := '';
    statistics_edit_fodder_crop_information.stamp_created_at.Checked := FALSE;
    statistics_edit_fodder_crop_information.stamp_created_by.Text := '';
    statistics_edit_fodder_crop_information.stamp_unique_identifier.Text := '';
    statistics_edit_fodder_crop_information.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_crop_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_crop_information.textbox_name.Text := '';
    statistics_edit_crop_information.textbox_dm.Text := '';
    statistics_edit_crop_information.textbox_cp.Text := '';
    statistics_edit_crop_information.textbox_me.Text := '';
    statistics_edit_crop_information.textbox_reference.Text := '';
    statistics_edit_crop_information.stamp_created_at.Checked := FALSE;
    statistics_edit_crop_information.stamp_created_by.Text := '';
    statistics_edit_crop_information.stamp_unique_identifier.Text := '';
    statistics_edit_crop_information.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_purchased_feed_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_purchased_feed_information.textbox_name.Text := '';
    statistics_edit_purchased_feed_information.textbox_dm_pct.Text := '';
    statistics_edit_purchased_feed_information.textbox_cp.Text := '';
    statistics_edit_purchased_feed_information.textbox_me.Text := '';
    statistics_edit_purchased_feed_information.textbox_reference.Text := '';
    statistics_edit_purchased_feed_information.stamp_created_at.Checked := FALSE;
    statistics_edit_purchased_feed_information.stamp_created_by.Text := '';
    statistics_edit_purchased_feed_information.stamp_unique_identifier.Text := '';
    statistics_edit_purchased_feed_information.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure statistics_edit_income_activity_OnClick (Sender: string; Action: string);
begin
try
    statistics_edit_custom_income_source.combo_category.dbItemID := -1;
    statistics_edit_custom_income_source.textbox_description.Text := '';
    statistics_edit_custom_income_source.stamp_created_at.Checked := FALSE;
    statistics_edit_custom_income_source.stamp_created_by.Text := '';
    statistics_edit_custom_income_source.stamp_unique_identifier.Text := '';
    statistics_edit_custom_income_source.ShowModal;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure doc_link_discussion_guide (Sender: string; Action: string);
begin
try
    OpenFile(report_path+'Resources\feast_focus_group_discussion_guide.pdf');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure doc_link_interview_questionnaire (Sender: string; Action: string);
begin
try
    OpenFile(report_path+'Resources\feast_interview_questionnaire.pdf');
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure doc_link_user_manual (Sender: string; Action: string);
begin
try
    OpenFile(report_path+'Resources\feast_user_manual.pdf');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure doc_link_report_package (Sender: string; var Cancel: boolean);
begin
try
    OpenFile(report_path+'report_update.bat');
    OpenFile(report_path+'Report\feast_excel_export.xlsm');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure web_link_sonata (Sender: string; Action: string);
begin
try
    OpenURL('http://www.sonatalearning.com');
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure web_link_ilri2 (Sender: string; Action: string);
begin
try
    OpenURL('https://www.ilri.org');
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure web_link_feastdata (Sender: string; Action: string);
begin
try
    OpenURL('https://feastdata.ilri.org');
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure web_link_ilri (Sender: string; Action: string);
begin
try
    OpenURL('https://www.ilri.org/feast');
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure web_link_cc (Sender: string; Action: string);
begin
try
    OpenURL('https://www.ilri.org/CopyRight');
except
    ShowMessage(ExceptionMessage);                                                           
end;
end;
procedure web_link_cgiar (Sender: string; Action: string);
begin
try
    OpenURL('https://www.cgiar.org');
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure folder_link_reports (Sender: string; Action: string);
begin
try
  //  SelectDirectory('Report');

except
    ShowMessage(ExceptionMessage);
end;
end;

// *** REPORTING ***

// Select data to export

procedure run_excel_snapshot_project(Sender: string; var Cancel: boolean);
begin
try
     If reports.combo_project.dbItemID <> -1 then
     begin
     report_export_id := reports.combo_project.dbItemID;
     report_export_filter := ('WHERE project.id = '+IntToStr(report_export_id) );
     report_export_filter_short := ('AND project.id = '+IntToStr(report_export_id)+' ');
     report_export_gender_filter := ('WHERE focus_group.id_gender IS NOT NULL AND project.id = '+IntToStr(report_export_id) );
     report_export_gender_filter_short := ('AND focus_group.id_gender IS NOT NULL AND project.id = '+IntToStr(report_export_id)+' ');
     report_export_level := 'Project';
     report_export_label := SQLExecute('SELECT project.title FROM project WHERE project.id ='+IntToStr(report_export_id) );
     excel_snapshot_project();
     end else
     ShowMessage('Please select a project.');
     Cancel := True;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure run_excel_snapshot_site(Sender: string; var Cancel: boolean);
begin
try
     If reports.combo_site.dbItemID <> -1 then
     begin
     report_export_id := reports.combo_site.dbItemID;
     report_export_filter := ('WHERE site.id = '+IntToStr(report_export_id) );
     report_export_filter_short := ('AND site.id = '+IntToStr(report_export_id)+' ');
     report_export_gender_filter := ('WHERE focus_group.id_gender IS NOT NULL AND site.id = '+IntToStr(report_export_id) );
     report_export_gender_filter_short := ('AND focus_group.id_gender IS NOT NULL AND site.id = '+IntToStr(report_export_id)+' ');
     report_export_level := 'Site';
     report_export_label := SQLExecute('SELECT site.name FROM site WHERE site.id ='+IntToStr(report_export_id) );
     excel_snapshot_project();
     end else
     ShowMessage('Please select a site.');
     Cancel := True;
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure run_excel_snapshot_focus_group(Sender: string; var Cancel: boolean);
begin
try
     If reports.combo_focus_group.dbItemID <> -1 then
     begin
     report_export_id := reports.combo_focus_group.dbItemID;
     report_export_filter := ('WHERE focus_group.id = '+IntToStr(report_export_id) );
     report_export_filter_short := ('AND focus_group.id = '+IntToStr(report_export_id)+' ');
     report_export_gender_filter := ('WHERE focus_group.id_gender IS NOT NULL AND focus_group.id = '+IntToStr(report_export_id) );
     report_export_gender_filter_short := ('AND focus_group.id_gender IS NOT NULL AND focus_group.id = '+IntToStr(report_export_id)+' ');
     report_export_level := 'Focus Group';
     report_export_label := SQLExecute('SELECT (focus_group.meeting_date_time || '' '' || focus_group.community || '' '' || focus_group.venue_name) as fg_title FROM focus_group WHERE focus_group.id ='+IntToStr(report_export_id) );
     excel_snapshot_project();
     end else
     ShowMessage('Please select a focus group.');
     Cancel := True;
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure run_excel_snapshot_all (Sender: string; var Cancel: boolean);
begin
try
     report_export_filter := (' ');
     report_export_filter_short := (' ');
     report_export_gender_filter := (' WHERE focus_group.id_gender IS NOT NULL ');
     report_export_gender_filter_short := (' AND focus_group.id_gender IS NOT NULL ');
     report_export_level := 'All Data';
     report_export_label := 'from All Projects';
     excel_snapshot_project();
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure confirm_excel_snapshot ();
begin
try
    if FileExists(report_path+'Report\xml\report_metadata.xml') = TRUE then
    begin
    reports.label_export_confirmation.Caption := 'Export complete at '+FormatDateTime('yyyy-MM-DD 00:00:00', Now);
    reports.label_export_confirmation.Visible := TRUE;
    end;
except
    ShowMessage(ExceptionMessage);
end;
end;
procedure reports_OnShow (Sender: string; Action: String);
begin
try
    reports.label_export_confirmation.Visible := FALSE;
except
    ShowMessage(ExceptionMessage);
end;
end;

// Export all data as XML

procedure excel_snapshot_project();
var
    Results: TDataSet;
    current_time: TDateTime;
    currency_conversion: extended;
    currency_name: string;
    count_of_respondents: integer;
begin
try

current_time := Now;
currency_name := SQLExecute('SELECT currency.name FROM site LEFT OUTER JOIN focus_group ON focus_group.id_site = site.id LEFT OUTER JOIN currency ON site.id_currency = currency.id '+report_export_filter+' ORDER BY currency.id LIMIT 1');
currency_conversion := SQLExecute('SELECT currency.current_USD_exchange_rate FROM site LEFT OUTER JOIN focus_group on focus_group.id_site = site.id LEFT OUTER JOIN currency ON site.id_currency = currency.id '+report_export_filter+' ORDER BY currency.id LIMIT 1');
count_of_respondents:= SQLExecute('SELECT COUNT (*) FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY focus_group.id LIMIT 1');

// Metadata for data set

    SQLQuery('SELECT '''+report_export_level+''' as report_level, "'+report_export_label+'" as report_title, '''+DateToStr(current_time)+''' as export_date, '''+TimeToStr(current_time)+''' as export_time, '''+currency_name+''' as currency_name, '''+FloatToStr(currency_conversion)+''' as currency_exchange_rate, '''+IntToStr(count_of_respondents)+''' as respondent_count FROM app_registration ORDER BY app_registration.id LIMIT 1', Results);

    if not DirectoryExists(ExtractFileDir(Application.ExeName)+'\Report') then
        CreateDir(ExtractFileDir(Application.ExeName)+'\Report');

    if not DirectoryExists(report_path+'Report\xml') then
        CreateDir(report_path+'Report\xml');

    DatasetToXML(Results, report_path+'Report\xml\report_metadata.xml');
    Results.Free;

// Focus Group Landholding Stats

    SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, focus_group.percent_households_large as percent_farms_large, focus_group.percent_households_medium as percent_farms_medium, focus_group.percent_households_small as percent_farms_small, focus_group.threshold_small_farm_ha as small_threshold, focus_group.threshold_large_farm_ha as large_threshold FROM focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project '+report_export_filter, Results);
    DatasetToXML(Results, report_path+'Report\xml\report_landholding.xml');
    Results.Free;

// Livestock Holdings

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id), resp_by_category AS (SELECT respondent.id_landholding_category AS cat_landholding, COUNT(*) as number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' GROUP BY respondent.id_landholding_category) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, landholding_category.description as farm_size, animal_species.description as species, animal_category.description as category, animal_type.description as type, TOTAL(livestock_holding.headcount) as head, AVG(livestock_holding.average_weight) as average_weight, TOTAL((livestock_holding.average_weight * livestock_holding.headcount)/250) as tlus, animal_type.lactating, animal_type.dairy, (TOTAL(livestock_holding.headcount)/resp_by_category.number_of) AS average_headcount, ((livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN resp_by_category ON resp_by_category.cat_landholding = respondent.id_landholding_category LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN landholding_category ON respondent.id_landholding_category = landholding_category.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL '+report_export_filter_short+'GROUP BY animal_type.description, landholding_category.description, respondent.id', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_livestock_holdings.xml');
    Results.Free;

// Crop Cultivation in hectares and Residue Usage

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, crop_type.name as crop, TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha) as hectares, TOTAL(crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) as kilograms, TOTAL(percent_burned * 0.01) as residue_percent_burned, TOTAL(percent_fed * 0.01) as residue_percent_fed, TOTAL(percent_mulched * 0.01) as residue_percent_mulched, TOTAL(percent_sold * 0.01) as residue_percent_sold, TOTAL(percent_other * 0.01) as residue_percent_other, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id LEFT OUTER JOIN unit_mass_weight on crop_cultivation.id_unit_mass_weight = unit_mass_weight.id WHERE crop_cultivation.cultivated_land IS NOT NULL '+report_export_filter_short+' GROUP BY respondent.id, crop_type.name', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_crop_cultivation.xml');
    Results.Free;

// Fodder Crop Cultivation in hectares

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, fodder_crop_type.name as fodder_crop, TOTAL(fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha) as hectares, (TOTAL(fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type LEFT OUTER JOIN unit_area on fodder_crop_cultivation.id_unit_area = unit_area.id LEFT OUTER JOIN interview_respondents WHERE fodder_crop_cultivation.cultivated_land IS NOT NULL '+report_export_filter_short+'GROUP BY respondent.id, fodder_crop_type.name', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_fodder_cultivation.xml');
    Results.Free;

// Purchased Feed in kilograms

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, purchased_feed_type.name as feed, (purchased_feed.quantity_purchased * purchased_feed.purchases_per_year * unit_mass_weight.conversion_kg) as kilograms, (purchased_feed.unit_price * currency.current_usd_exchange_rate * purchased_feed.quantity_purchased * purchased_feed.purchases_per_year) AS expenditures, ((purchased_feed.quantity_purchased * purchased_feed.purchases_per_year * unit_mass_weight.conversion_kg)/interview_respondents.number_of) as average_kg_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN currency ON currency.id = site.id_currency LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type LEFT OUTER JOIN unit_mass_weight on purchased_feed.id_unit_mass_weight = unit_mass_weight.id LEFT OUTER JOIN interview_respondents WHERE purchased_feed.quantity_purchased IS NOT NULL '+report_export_filter_short+' GROUP BY respondent.id, purchased_feed_type.name', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_purchased_feed.xml');
    Results.Free;

// Income Sources

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, income_activity_category.description as category, income_activity_type.description as activity, COALESCE((income_activity.percent_of_hh_income * .01), 0) as percent, (COALESCE((income_activity.percent_of_hh_income * .01), 0)/interview_respondents.number_of) as average_percent FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category LEFT OUTER JOIN interview_respondents WHERE income_activity_type.description IS NOT NULL '+report_export_filter_short+'GROUP BY respondent.id, income_activity_category.description, income_activity_type.description', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_income_by_activity.xml');
    Results.Free;
                              
// Monthly Rainfall

    SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, month.name as month_name, month.ordering, season.name as season_name, scale_zero_five.number AS rainfall FROM month LEFT OUTER JOIN focus_group_monthly_statistics ON focus_group_monthly_statistics.id_month = month.id LEFT OUTER JOIN season ON focus_group_monthly_statistics.id_season = season.id LEFT OUTER JOIN focus_group ON focus_group.id = focus_group_monthly_statistics.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN scale_zero_five ON focus_group_monthly_statistics.id_scale_zero_five = scale_zero_five.id WHERE scale_zero_five.number IS NOT NULL '+report_export_filter_short+'GROUP BY month.ordering', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_monthly_rainfall.xml');
    Results.Free;

// Monthly Feed Availablity

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_filter+' ORDER BY respondent.id) SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, month.name as month_name, month.ordering, season.name as season_name, feed_source.description as source_of_feed, (IFNULL(feed_source_availability.percentage, 0) * scale_zero_ten.number * 0.1) as availability, ((IFNULL(feed_source_availability.percentage, 0) * scale_zero_ten.number * 0.1)/interview_respondents.number_of) as average_availability FROM feed_source_availability INNER JOIN respondent ON respondent.id = feed_source_availability.id_respondent LEFT OUTER JOIN month ON month.id = feed_source_availability.id_month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_respondent = respondent.id LEFT OUTER JOIN scale_zero_ten ON respondent_monthly_statistics.id_scale_zero_ten = scale_zero_ten.id LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN focus_group_monthly_statistics ON focus_group_monthly_statistics.id_month = month.id LEFT OUTER JOIN season ON focus_group_monthly_statistics.id_season = season.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN feed_source ON feed_source_availability.id_feed_source = feed_source.id LEFT OUTER JOIN interview_respondents WHERE respondent_monthly_statistics.id_month = feed_source_availability.id_month '+report_export_filter_short+' GROUP BY respondent.id, month.ordering, feed_source.description', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_monthly_feed_availability.xml');
    Results.Free;

// Monthly Milk Statistics

    SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, month.name as month_name, month.ordering, month.days, AVG(respondent_monthly_statistics.milk_average_yield) as average_yield, AVG(respondent_monthly_statistics.milk_retained_for_household) as average_retained, AVG(respondent_monthly_statistics.milk_average_price_litre * currency.current_usd_exchange_rate) as price_litre_milk_usd, AVG(month.days * (respondent_monthly_statistics.milk_average_yield - respondent_monthly_statistics.milk_retained_for_household) * respondent_monthly_statistics.milk_average_price_litre * currency.current_usd_exchange_rate) as sales FROM month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE respondent_monthly_statistics.milk_average_yield IS NOT NULL '+report_export_filter_short+'GROUP BY focus_group.id, month.ordering', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_monthly_milk_stats.xml');
    Results.Free;

// Monthly Market Prices

    SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, month.name as month_name, month.ordering, (AVG(respondent_monthly_statistics.market_price_cattle) * currency.current_usd_exchange_rate) as price_head_cattle_usd, (AVG(respondent_monthly_statistics.market_price_sheep) * currency.current_usd_exchange_rate) as price_head_sheep_usd, (AVG(respondent_monthly_statistics.market_price_goat) * currency.current_usd_exchange_rate) as price_head_goat_usd FROM month LEFT OUTER JOIN respondent_monthly_statistics ON respondent_monthly_statistics.id_month = month.id LEFT OUTER JOIN respondent ON respondent.id = respondent_monthly_statistics.id_respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN currency ON currency.id = site.id_currency WHERE (respondent_monthly_statistics.market_price_cattle IS NOT NULL OR respondent_monthly_statistics.market_price_goat IS NOT NULL OR respondent_monthly_statistics.market_price_sheep IS NOT NULL) '+report_export_filter_short+' GROUP BY focus_group.id, month.ordering', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_monthly_market_price.xml');
    Results.Free;

// Livestock Offtake

    SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, animal_species.description, gender.description, livestock_sale.number_sold, livestock_sale.approximate_weight, ((livestock_sale.number_sold * 1.0 * livestock_sale.approximate_weight)/250) AS tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_sale ON livestock_sale.id_respondent = respondent.id LEFT OUTER JOIN livestock_sale_category ON livestock_sale.id_livestock_sale_category = livestock_sale_category.id LEFT OUTER JOIN gender ON gender.id = livestock_sale_category.id_gender LEFT OUTER JOIN animal_species ON livestock_sale_category.id_animal_species = animal_species.id WHERE livestock_sale.number_sold IS NOT NULL '+report_export_filter_short+'GROUP BY animal_species.description, gender.description', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_livestock_offtake.xml');
    Results.Free;

 // Gender Pay Equality

     SQLQuery('SELECT project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, (AVG(labour_activity.daily_rate_female) * currency.current_usd_exchange_rate) as avg_pay_female, (AVG(labour_activity.daily_rate_male) * currency.current_usd_exchange_rate) as avg_pay_male FROM focus_group LEFT OUTER JOIN labour_activity ON focus_group.id = labour_activity.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN currency ON site.id_currency = currency.id LEFT OUTER JOIN project ON project.id = site.id_project WHERE labour_activity.daily_rate_female IS NOT NULL AND labour_activity.daily_rate_male IS NOT NULL '+report_export_filter_short+' GROUP BY focus_group.id', Results);
     DatasetToXML(Results, report_path+'Report\xml\report_gender_pay_equality.xml');
     Results.Free;

 // Diet Composition

 SQLQuery('WITH '+
'crop_stuff AS (SELECT '+
'project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id,'+
'TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0))) as dm_crop_residue,'+
'TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_metabolisable_energy) as me_crop_residue, '+
'TOTAL((IFNULL(((((crop_cultivation.annual_yield * unit_mass_weight.conversion_kg) / crop_type.harvest_index) - (crop_cultivation.annual_yield * unit_mass_weight.conversion_kg)) * crop_cultivation.percent_fed * 0.01 * crop_type.content_percent_dry_matter * 0.01), 0)) * crop_type.content_crude_protein * 0.01) as cp_crop_residue '+
'FROM respondent '+
     'LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group '+
     'LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id '+
     'LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type  '+
     'LEFT OUTER JOIN site ON focus_group.id_site = site.id '+
        ' LEFT OUTER JOIN project ON project.id = site.id_project '+
     'LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = crop_cultivation.id_unit_mass_weight '+
'GROUP BY respondent.id), '+
'fodder_stuff AS '+
'(SELECT '+
'project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, '+
'TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0))) as dm_cultivated_fodder, '+
'TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_metabolisable_energy) as me_cultivated_fodder, '+
'TOTAL((IFNULL((fodder_crop_cultivation.cultivated_land * unit_area.conversion_ha *  fodder_crop_type.annual_dry_matter_per_hectare), 0)) * fodder_crop_type.content_crude_protein * 0.01) as cp_cultivated_fodder '+
'FROM respondent '+
     'LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group '+
     'LEFT OUTER JOIN fodder_crop_cultivation ON fodder_crop_cultivation.id_respondent = respondent.id  '+
     'LEFT OUTER JOIN fodder_crop_type ON fodder_crop_type.id = fodder_crop_cultivation.id_fodder_crop_type '+
     'LEFT OUTER JOIN site ON focus_group.id_site = site.id '+
         'LEFT OUTER JOIN project ON project.id = site.id_project '+
       'LEFT OUTER JOIN unit_area ON unit_area.id = fodder_crop_cultivation.id_unit_area '+
'GROUP BY respondent.id), '+
'purchased_stuff AS (SELECT '+
'project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, '+
'TOTAL(IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) as dm_purchased_feed, '+
'TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_metabolisable_energy) as me_purchased_feed, '+
'TOTAL((IFNULL((purchased_feed.quantity_purchased * unit_mass_weight.conversion_kg * purchased_feed.purchases_per_year * purchased_feed_type.content_percent_dry_matter * 0.01), 0)) * purchased_feed_type.content_crude_protein * 0.01) as cp_purchased_feed '+
'FROM respondent '+
     'LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group '+
     'LEFT OUTER JOIN purchased_feed ON purchased_feed.id_respondent = respondent.id '+
         'LEFT OUTER JOIN purchased_feed_type ON purchased_feed_type.id = purchased_feed.id_purchased_feed_type '+
     'LEFT OUTER JOIN site ON focus_group.id_site = site.id '+
         'LEFT OUTER JOIN project ON project.id = site.id_project '+
     'LEFT OUTER JOIN unit_mass_weight ON unit_mass_weight.id = purchased_feed.id_unit_mass_weight '+
'GROUP BY respondent.id) '+
'SELECT '+
'project.id as project_id, site.id as site_id, focus_group.id as focus_group_id, respondent.id as respondent_id, '+
'crop_stuff.dm_crop_residue AS dm_crop_residue, '+
'crop_stuff.me_crop_residue AS me_crop_residue, '+
'crop_stuff.cp_crop_residue AS cp_crop_residue, '+
'fodder_stuff.dm_cultivated_fodder AS dm_cultivated_fodder, '+
'fodder_stuff.me_cultivated_fodder AS me_cultivated_fodder, '+
'fodder_stuff.cp_cultivated_fodder AS cp_cultivated_fodder, '+
'purchased_stuff.dm_purchased_feed AS dm_purchased_feed, '+
'purchased_stuff.me_purchased_feed AS me_purchased_feed, '+
'purchased_stuff.cp_purchased_feed AS cp_purchased_feed, '+
'TOTAL((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) as dm_grazing, '+
'TOTAL(((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_crude_protein_percentage * 0.01) as cp_grazing, '+
'TOTAL(((IFNULL(respondent.diet_percent_grazing, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.grazing_metabolisable_energy) as me_grazing, '+
'TOTAL((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) as dm_collected_fodder, '+
'TOTAL(((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_crude_protein_percentage * 0.01) as cp_collected_fodder, '+
'TOTAL(((IFNULL(respondent.diet_percent_collected_fodder, 0) * 0.01) * ((IFNULL(purchased_stuff.dm_purchased_feed, 0)) + (IFNULL(crop_stuff.dm_crop_residue, 0)) + (IFNULL(fodder_stuff.dm_cultivated_fodder, 0))) /(1-((IFNULL(respondent.diet_percent_grazing, 0) + IFNULL(respondent.diet_percent_collected_fodder, 0))*0.01)) ) * site.collected_fodder_metabolisable_energy) as me_collected_fodder '+
'FROM respondent '+
     'LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group '+
     'LEFT OUTER JOIN crop_stuff ON crop_stuff.respondent_id = respondent.id '+
     'LEFT OUTER JOIN fodder_stuff ON fodder_stuff.respondent_id = respondent.id '+
         'LEFT OUTER JOIN purchased_stuff ON purchased_stuff.respondent_id = respondent.id '+
     'LEFT OUTER JOIN site ON focus_group.id_site = site.id '+
         'LEFT OUTER JOIN project ON project.id = site.id_project '+report_export_filter+' GROUP BY respondent.id', Results);

     DatasetToXML(Results, report_path+'Report\xml\report_animal_diet_nutrition.xml');
     Results.Free;
     
     
// G - Coop Membership

    SQLQuery('SELECT TOTAL(coop_membership.membership_count_male) AS total_male, TOTAL(coop_membership.membership_count_female) AS total_female FROM coop_membership LEFT JOIN respondent ON respondent.id = coop_membership.id_respondent  LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project '+report_export_gender_filter+' GROUP BY focus_group.id', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_coop_membership.xml');
    Results.Free;     

// G - Farm Size

    SQLQuery('SELECT respondent.id_landholding_category, respondent.id_gender, respondent.id_gender1, AVG(respondent.land_under_control * unit_area.conversion_ha) AS avg_land FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN unit_area on respondent.id_unit_area = unit_area.id '+report_export_gender_filter+' GROUP BY respondent.id_gender1, respondent.id_landholding_category, focus_group.id', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_farm_size.xml');
    Results.Free;             

// G - Land Ownership

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_gender_filter+' ORDER BY respondent.id) SELECT (TOTAL(respondent.land_ownership_joint * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_joint, (TOTAL(respondent.land_ownership_male * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_male, (TOTAL(respondent.land_ownership_female * unit_area.conversion_ha)/interview_respondents.number_of) AS avg_female FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN unit_area on respondent.id_unit_area = unit_area.id  LEFT OUTER JOIN interview_respondents '+report_export_gender_filter+' GROUP BY focus_group.id', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_land_ownership.xml');
    Results.Free;         
    
// G - Animal TLUs by HH Head Gender

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_gender_filter+' ORDER BY respondent.id), top_categories AS (SELECT animal_category.id as category_id, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents '+report_export_gender_filter+' GROUP BY animal_category.description ORDER BY average_tlus DESC LIMIT 5) SELECT respondent.id_gender1, animal_category.description as category_of_animal, (TOTAL(livestock_holding.average_weight * livestock_holding.headcount)/(250*interview_respondents.number_of)) AS average_tlus FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN livestock_holding ON livestock_holding.id_respondent = respondent.id LEFT OUTER JOIN animal_type ON animal_type.id = livestock_holding.id_animal_type LEFT OUTER JOIN animal_category ON animal_category.id = animal_type.id_animal_category LEFT OUTER JOIN animal_species ON animal_species.id = animal_category.id_animal_species LEFT OUTER JOIN interview_respondents WHERE livestock_holding.headcount IS NOT NULL AND animal_category.id IN (SELECT category_id FROM top_categories) '+report_export_gender_filter_short+' GROUP BY animal_category.description, respondent.id_gender1 ORDER BY average_tlus DESC', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_livestock_holdings.xml');
    Results.Free;
    
// G - Crop Hectares by HH Head Gender

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_gender_filter+' ORDER BY respondent.id), top_categories AS (SELECT crop_type.id as category_id, crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL '+report_export_gender_filter_short+' GROUP BY crop_type.name ORDER BY average_ha_per_hh DESC LIMIT 5) SELECT respondent.id_gender1, crop_type.name as type_of_crop, (TOTAL(crop_cultivation.cultivated_land * unit_area.conversion_ha)/interview_respondents.number_of) as average_ha_per_hh FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN interview_respondents LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN crop_cultivation ON crop_cultivation.id_respondent = respondent.id LEFT OUTER JOIN crop_type ON crop_type.id = crop_cultivation.id_crop_type LEFT OUTER JOIN unit_area on crop_cultivation.id_unit_area = unit_area.id WHERE crop_cultivation.cultivated_land IS NOT NULL AND crop_type.id IN (SELECT category_id FROM top_categories) '+report_export_gender_filter_short+' GROUP BY crop_type.name, respondent.id_gender1 ORDER BY average_ha_per_hh DESC', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_crop_cultivation.xml');
    Results.Free;         
    
// G - Feed Labor Division

    SQLQuery('SELECT COUNT(*) AS labor_total, feed_labor_type.description AS labor_type, respondent.id, feed_labor_division.id_labor_division_group FROM feed_labor_division LEFT OUTER JOIN respondent ON feed_labor_division.id_respondent = respondent.id LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN feed_labor_type ON feed_labor_type.id = feed_labor_division.id_feed_labor_type WHERE feed_labor_division.id_labor_division_group IS NOT NULL '+report_export_gender_filter_short+' GROUP BY feed_labor_division.id_feed_labor_type, feed_labor_division.id_labor_division_group', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_feed_labor.xml');
    Results.Free;         
    
// G - Decisions (Feed)

    SQLQuery('SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group FROM decision_making_by_household LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision WHERE decision.id_decision_type IN (2,3,4) AND decision_making_by_household.id_gender_group IS NOT NULL '+report_export_gender_filter_short+' GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_decision_feed.xml');
    Results.Free;         

// G - Decisions (Livestock)

    SQLQuery('SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group FROM decision_making_by_household LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision WHERE decision.id_decision_type IN (1) AND decision_making_by_household.id_gender_group IS NOT NULL '+report_export_gender_filter_short+' GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_decision_livestock.xml');
    Results.Free;             
    
// G - Decisions (Sales)

    SQLQuery('SELECT COUNT(*) AS decision_total, decision.description AS decision_type, respondent.id, decision_making_by_household.id_gender_group FROM decision_making_by_household LEFT OUTER JOIN respondent ON decision_making_by_household.id_respondent = respondent.id LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN decision ON decision.id = decision_making_by_household.id_decision WHERE decision.id_decision_type IN (5) AND decision_making_by_household.id_gender_group IS NOT NULL '+report_export_gender_filter_short+' GROUP BY decision_making_by_household.id_decision, decision_making_by_household.id_gender_group', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_decision_sales.xml');
    Results.Free;             
    
// G - Income Sources (Women)

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_gender_filter+' ORDER BY respondent.id) SELECT income_activity_category.description as income_category, TOTAL(COALESCE((womens_income_activity.pct_womens_income * .01), 0)/interview_respondents.number_of) as average_percent FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN womens_income_activity ON womens_income_activity.id_respondent = respondent.id LEFT OUTER JOIN income_activity_type ON income_activity_type.id = womens_income_activity.id_income_activity_type LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category LEFT OUTER JOIN interview_respondents WHERE income_activity_type.description IS NOT NULL '+report_export_gender_filter_short+' GROUP BY income_activity_category.description', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_women_income_by_activity.xml');
    Results.Free;             
    
// G - Decisions (Income)

    SQLQuery('SELECT income_activity_type.id, income_activity_type.description as income_category, income_activity.id_gender_group, count(income_activity.id_gender_group) as gender_total  FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id   LEFT OUTER JOIN site ON site.id = focus_group.id_site LEFT OUTER JOIN project ON project.id = site.id_project LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type WHERE income_activity_type.description IS NOT NULL '+report_export_gender_filter_short+' GROUP BY income_activity.id_income_activity_type, income_activity.id_gender_group', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_decision_income.xml');
    Results.Free;             
    
// G - HH Income Sources vs Women's Income Sources

    SQLQuery('WITH interview_respondents AS (SELECT COUNT (*) AS number_of FROM respondent LEFT OUTER JOIN focus_group ON focus_group.id = respondent.id_focus_group  LEFT OUTER JOIN site ON site.id = focus_group.id_site '+report_export_gender_filter+' ORDER BY respondent.id) SELECT income_category, TOTAL(average_percent_hh) AS avg_percent_hh, TOTAL(average_percent_women) as avg_percent_women FROM (SELECT income_activity_type.description as income_category,  0 as average_percent_hh,  TOTAL(COALESCE((womens_income_activity.pct_womens_income * .01), 0)/interview_respondents.number_of) as average_percent_women  FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id  LEFT OUTER JOIN site ON site.id = focus_group.id_site  LEFT OUTER JOIN project ON project.id = site.id_project  LEFT OUTER JOIN womens_income_activity ON womens_income_activity.id_respondent = respondent.id  LEFT OUTER JOIN income_activity_type ON income_activity_type.id = womens_income_activity.id_income_activity_type  LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category  LEFT OUTER JOIN interview_respondents  WHERE income_activity_type.description IS NOT NULL '+report_export_gender_filter_short+' GROUP BY income_activity_type.description  UNION ALL  SELECT income_activity_type.description as income_category,  TOTAL(COALESCE((income_activity.percent_of_hh_income* .01), 0)/interview_respondents.number_of) as average_percent_hh,  0 as average_percent_women  FROM respondent LEFT OUTER JOIN focus_group ON respondent.id_focus_group = focus_group.id   LEFT OUTER JOIN site ON site.id = focus_group.id_site  LEFT OUTER JOIN project ON project.id = site.id_project  LEFT OUTER JOIN income_activity ON income_activity.id_respondent = respondent.id  LEFT OUTER JOIN income_activity_type ON income_activity_type.id = income_activity.id_income_activity_type  LEFT OUTER JOIN income_activity_category ON income_activity_category.id = income_activity_type.id_income_activity_category  LEFT OUTER JOIN interview_respondents  WHERE income_activity_type.description IS NOT NULL '+report_export_gender_filter_short+' GROUP BY income_activity_type.description) GROUP BY income_category', Results);
    DatasetToXML(Results, report_path+'Report\xml\report_gender_income_sources_comparison.xml');
    Results.Free;             

    reports.label_export_confirmation.Caption := 'Export complete at '+FormatDateTime('yyyy-MM-DD hh:mm:ss', Now);
    reports.label_export_confirmation.Visible := TRUE;

except
    ShowMessage(ExceptionMessage);
end;
end;

 // *** IMPORT EXPORT CONSOLIDATE ***

procedure home_menu_bExport_OnClick (Sender: string; var Cancel: boolean);
var
    export_directory: string;
begin
try
  if not SelectDirectory('Select a folder in which to save the export file', '', export_directory)
  then exit
  else
  begin

    ExportToCSV('core_context_attribute_type', report_path+'export\core_context_attribute_type.csv');
        ExportToCSV('core_context_attribute', report_path+'export\core_context_attribute.csv');
    ExportToCSV('core_context_attribute_score_calc_method', report_path+'export\core_context_attribute_score_calc_method.csv');

    ExportToCSV('scale_zero_ten', report_path+'export\scale_zero_ten.csv');
    ExportToCSV('scale_zero_five', report_path+'export\scale_zero_five.csv');
    ExportToCSV('organization_type', report_path+'export\organization_type.csv');
        ExportToCSV('app_registration', report_path+'export\app_registration.csv');
    ExportToCSV('crop_type', report_path+'export\crop_type.csv');
    ExportToCSV('gender', report_path+'export\gender.csv');
    ExportToCSV('gender_group', report_path+'export\gender_group.csv');
    ExportToCSV('techfit_scale', report_path+'export\techfit_scale.csv');
    ExportToCSV('agriculture_system_type', report_path+'export\agriculture_system_type.csv');
    ExportToCSV('core_commodity', report_path+'export\core_commodity.csv');
    ExportToCSV('month', report_path+'export\month.csv');
    ExportToCSV('scale_zero_five', report_path+'export\scale_zero_five.csv');
    ExportToCSV('unit_type', report_path+'export\unit_type.csv');
        ExportToCSV('unit_area', report_path+'export\unit_area.csv');
        ExportToCSV('unit_mass_weight', report_path+'export\unit_mass_weight.csv');


    ExportToCSV('animal_species', report_path+'export\animal_species.csv');
        ExportToCSV('animal_category', report_path+'export\animal_category.csv');
            ExportToCSV('animal_type', report_path+'export\animal_type.csv');

    ExportToCSV('project_type', report_path+'export\project_type.csv');
        ExportToCSV('project', report_path+'export\project.csv');


    ExportToCSV('world_region', report_path+'export\world_region.csv');
    ExportToCSV('currency', report_path+'export\currency.csv');
        ExportToCSV('country', report_path+'export\country.csv');
        ExportToCSV('community_type', report_path+'export\community_type.csv');

            ExportToCSV('site', report_path+'export\site.csv');
                ExportToCSV('focus_group', report_path+'export\focus_group.csv');
                    ExportToCSV('labour_activity', report_path+'export\labour_activity.csv');
                    ExportToCSV('season', report_path+'export\season.csv');
                    ExportToCSV('focus_group_monthly_statistics', report_path+'export\focus_group_monthly_statistics.csv');
                    ExportToCSV('techfit_assessment', report_path+'export\techfit_assessment.csv');
                        ExportToCSV('core_context_attribute_score', report_path+'export\core_context_attribute_score.csv');

                ExportToCSV('landholding_category', report_path+'export\landholding_category.csv');
                    ExportToCSV('respondent', report_path+'export\respondent.csv');
                        ExportToCSV('livestock_holding', report_path+'export\livestock_holding.csv');
                        ExportToCSV('crop_cultivation', report_path+'export\crop_cultivation.csv');
                        ExportToCSV('respondent_monthly_statistics', report_path+'export\respondent_monthly_statistics.csv');
                        ExportToCSV('coop_membership', report_path+'export\coop_membership.csv');

                ExportToCSV('income_activity_category', report_path+'export\income_activity_category.csv');
                    ExportToCSV('income_activity_type', report_path+'export\income_activity_type.csv');
                        ExportToCSV('income_activity', report_path+'export\income_activity.csv');
                        ExportToCSV('womens_income_activity', report_path+'export\womens_income_activity.csv');

                    ExportToCSV('livestock_sale_category', report_path+'export\livestock_sale_category.csv');
                        ExportToCSV('livestock_sale', report_path+'export\livestock_sale.csv');

                    ExportToCSV('feed_source', report_path+'export\feed_source.csv');
                        ExportToCSV('feed_source_availability', report_path+'export\feed_source_availability.csv');

                    ExportToCSV('fodder_crop_type', report_path+'export\fodder_crop_type.csv');
                        ExportToCSV('fodder_crop_cultivation', report_path+'export\fodder_crop_cultivation.csv');

                    ExportToCSV('purchased_feed_type', report_path+'export\purchased_feed_type.csv');
                        ExportToCSV('purchased_feed', report_path+'export\purchased_feed.csv');
                        
                ExportToCSV('decision_type', report_path+'export\decision_type.csv');
                    ExportToCSV('decision', report_path+'export\decision.csv');
                        ExportToCSV('decision_making_by_household', report_path+'export\decision_making_by_household.csv');
                        
                ExportToCSV('feed_labor_type', report_path+'export\feed_labor_type.csv');
                    ExportToCSV('labor_division_group', report_path+'export\labor_division_group.csv');
                        ExportToCSV('feed_labor_division', report_path+'export\feed_labor_division.csv');

CompressDirectory(''+report_path+'export\', ''+export_directory+'\feast_data_'+FormatDateTime('yyyy_MM_DD_hh_nn_ss', Now)+'_'+registration_concatenated_id+'.zlib');

ShowMessage('Data file successfully exported to '+export_directory)

end;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure home_menu_bImport_OnClick (Sender: string; var Cancel: boolean);
var
    OpenDialog: TOpenDialog;
    isV2: boolean;
begin
try

  // Ask the user to select a file directory, starting with C:

     OpenDialog := TOpenDialog.Create(settings_import_export);
     OpenDialog.InitialDir := 'c:';

     if OpenDialog.Execute then
     begin
          OpenDialog.FileName; // here selected filename

DecompressFiles(OpenDialog.Filename, ExtractFilePath(Application.ExeName)+'import');

import_directory := ExtractFilePath(Application.ExeName)+'import';


// If ANY v2 files exist, all must exist
    if 
        (FileExists(import_directory+'\coop_membership.csv') OR
        FileExists(import_directory+'\gender_group.csv') OR
        FileExists(import_directory+'\womens_income_activity.csv') OR
        FileExists(import_directory+'\decision_type.csv') OR
        FileExists(import_directory+'\decision.csv') OR
        FileExists(import_directory+'\decision_making_by_household.csv') OR
        FileExists(import_directory+'\feed_labor_type.csv') OR
        FileExists(import_directory+'\labor_division_group.csv') OR
        FileExists(import_directory+'\feed_labor_division.csv'))
        AND NOT (
        FileExists(import_directory+'\coop_membership.csv') AND
        FileExists(import_directory+'\gender_group.csv') AND
        FileExists(import_directory+'\womens_income_activity.csv') AND
        FileExists(import_directory+'\decision_type.csv') AND
        FileExists(import_directory+'\decision.csv') AND
        FileExists(import_directory+'\decision_making_by_household.csv') AND
        FileExists(import_directory+'\feed_labor_type.csv') AND
        FileExists(import_directory+'\labor_division_group.csv') AND
        FileExists(import_directory+'\feed_labor_division.csv'))
    then
    begin
        ShowMessage('This import file appears to be a version 2 (Gendered FEAST) import but is missing files. Please re-export from the source application and try again.');
        Exit;
    end else
    begin
      // Since we already excluded the possibility of incomplete V2 data, then if any of the V2 files exist, it's V2.
      if FileExists(import_directory+'\coop_membership.csv') then
      begin
      isV2 := true;
      end;
    end;            

// Backup database and import V1 files
    CopyFile('sqlite.db', 'sqlite.bak',false);

    ImportFromCSV('core_context_attribute_type', import_directory+'\core_context_attribute_type.csv');
    UpdateDatabase('core_context_attribute_type');
        ImportFromCSV('core_context_attribute', import_directory+'\core_context_attribute.csv');
        UpdateDatabase('core_context_attribute');
    ImportFromCSV('core_context_attribute_score_calc_method', import_directory+'\core_context_attribute_score_calc_method.csv');
    UpdateDatabase('core_context_attribute_score_calc_method');

    ImportFromCSV('scale_zero_ten', import_directory+'\scale_zero_ten.csv');
    UpdateDatabase('scale_zero_ten');
    ImportFromCSV('scale_zero_five', import_directory+'\scale_zero_five.csv');
    UpdateDatabase('scale_zero_five');
    ImportFromCSV('organization_type', import_directory+'\organization_type.csv');
    UpdateDatabase('organization_type');
    ImportFromCSV('app_registration', import_directory+'\app_registration.csv');
    UpdateDatabase('app_registration');
    ImportFromCSV('crop_type', import_directory+'\crop_type.csv');
    UpdateDatabase('crop_type');
    ImportFromCSV('gender', import_directory+'\gender.csv');
    UpdateDatabase('gender');
    ImportFromCSV('techfit_scale', import_directory+'\techfit_scale.csv');
    UpdateDatabase('techfit_scale');
    ImportFromCSV('agriculture_system_type', import_directory+'\agriculture_system_type.csv');
    UpdateDatabase('agriculture_system_type');
    ImportFromCSV('core_commodity', import_directory+'\core_commodity.csv');
    UpdateDatabase('core_commodity');
    ImportFromCSV('month', import_directory+'\month.csv');
    UpdateDatabase('month');
    ImportFromCSV('scale_zero_five', import_directory+'\scale_zero_five.csv');
    UpdateDatabase('scale_zero_five');
    ImportFromCSV('unit_type', import_directory+'\unit_type.csv');
    UpdateDatabase('unit_type');
        ImportFromCSV('unit_area', import_directory+'\unit_area.csv');
        UpdateDatabase('unit_area');
        ImportFromCSV('unit_mass_weight', import_directory+'\unit_mass_weight.csv');
        UpdateDatabase('unit_mass_weight');

    ImportFromCSV('animal_species', import_directory+'\animal_species.csv');
    UpdateDatabase('animal_species');
        ImportFromCSV('animal_category', import_directory+'\animal_category.csv');
        UpdateDatabase('animal_category');
            ImportFromCSV('animal_type', import_directory+'\animal_type.csv');
            UpdateDatabase('anmal_type');

    ImportFromCSV('project_type', import_directory+'\project_type.csv');
    UpdateDatabase('project_type');
        ImportFromCSV('project', import_directory+'\project.csv');
        UpdateDatabase('project');

    ImportFromCSV('world_region', import_directory+'\world_region.csv');
    UpdateDatabase('world_region');
    ImportFromCSV('currency', import_directory+'\currency.csv');
    UpdateDatabase('currency');
        ImportFromCSV('country', import_directory+'\country.csv');
        UpdateDatabase('country');
        ImportFromCSV('community_type', import_directory+'\community_type.csv');
        UpdateDatabase('community_type');

            ImportFromCSV('site', import_directory+'\site.csv');
            UpdateDatabase('site');
                ImportFromCSV('focus_group', import_directory+'\focus_group.csv');
                UpdateDatabase('focus_group');
                    ImportFromCSV('labour_activity', import_directory+'\labour_activity.csv');
                    UpdateDatabase('labour_activity');
                    ImportFromCSV('season', import_directory+'\season.csv');
                    UpdateDatabase('season');
                    ImportFromCSV('focus_group_monthly_statistics', import_directory+'\focus_group_monthly_statistics.csv');
                    UpdateDatabase('focus_group_monthly_statistics');
                    ImportFromCSV('techfit_assessment', import_directory+'\techfit_assessment.csv');
                    UpdateDatabase('techfit_assessment');
                        ImportFromCSV('core_context_attribute_score', import_directory+'\core_context_attribute_score.csv');
                        UpdateDatabase('core_context_attribute_score');

                ImportFromCSV('landholding_category', import_directory+'\landholding_category.csv');
                UpdateDatabase('landholding_category');
                    ImportFromCSV('respondent', import_directory+'\respondent.csv');
                    UpdateDatabase('respondent');
                        ImportFromCSV('livestock_holding', import_directory+'\livestock_holding.csv');
                        UpdateDatabase('livestock_holding');
                        ImportFromCSV('crop_cultivation', import_directory+'\crop_cultivation.csv');
                        UpdateDatabase('crop_cultivation');
                        ImportFromCSV('respondent_monthly_statistics', import_directory+'\respondent_monthly_statistics.csv');
                        UpdateDatabase('respondent_monthly_statistics');

                ImportFromCSV('income_activity_category', import_directory+'\income_activity_category.csv');
                UpdateDatabase('income_activity_category');
                    ImportFromCSV('income_activity_type', import_directory+'\income_activity_type.csv');
                    UpdateDatabase('income_activity_type');
                        ImportFromCSV('income_activity', import_directory+'\income_activity.csv');
                        UpdateDatabase('income_activity');

                    ImportFromCSV('livestock_sale_category', import_directory+'\livestock_sale_category.csv');
                    UpdateDatabase('livestock_sale_category');
                        ImportFromCSV('livestock_sale', import_directory+'\livestock_sale.csv');
                        UpdateDatabase('livestock_sale');

                    ImportFromCSV('feed_source', import_directory+'\feed_source.csv');
                    UpdateDatabase('feed_source');
                        ImportFromCSV('feed_source_availability', import_directory+'\feed_source_availability.csv');
                        UpdateDatabase('feed_source_availability');

                    ImportFromCSV('fodder_crop_type', import_directory+'\fodder_crop_type.csv');
                    UpdateDatabase('fodder_crop_type');
                        ImportFromCSV('fodder_crop_cultivation', import_directory+'\fodder_crop_cultivation.csv');
                        UpdateDatabase('fodder_crop_cultivation');
                    ImportFromCSV('purchased_feed_type', import_directory+'\purchased_feed_type.csv');
                    UpdateDatabase('purchased_feed_type');
                        ImportFromCSV('purchased_feed', import_directory+'\purchased_feed.csv');
                        UpdateDatabase('purchased_feed');

// Import G-FEAST v2 tables if relevant

    if isV2 = true then
    begin
    ImportFromCSV('coop_membership', import_directory+'\coop_membership.csv');
    UpdateDatabase('coop_membership');

    ImportFromCSV('gender_group', import_directory+'\gender_group.csv');
    UpdateDatabase('gender_group');    
    
    ImportFromCSV('womens_income_activity', import_directory+'\womens_income_activity.csv');
    UpdateDatabase('womens_income_activity');
                        
                        
    ImportFromCSV('decision_type', import_directory+'\decision_type.csv');
    UpdateDatabase('decision_type');
        ImportFromCSV('decision', import_directory+'\decision.csv');
        UpdateDatabase('decision');
            ImportFromCSV('decision_making_by_household', import_directory+'\decision_making_by_household.csv');
            UpdateDatabase('decision_making_by_household');
            
    ImportFromCSV('feed_labor_type', import_directory+'\feed_labor_type.csv');
    UpdateDatabase('feed_labor_type');
        ImportFromCSV('labor_division_group', import_directory+'\labor_division_group.csv');
        UpdateDatabase('labor_division_group');
            ImportFromCSV('feed_labor_division', import_directory+'\feed_labor_division.csv');
            UpdateDatabase('feed_labor_division');
    end;

// update new techfit fields not present in version 1

     SQLExecute('UPDATE techfit_assessment SET id_site = (SELECT id_site FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) WHERE id_site IS NULL');
     SQLExecute('UPDATE techfit_assessment SET weight_core_feed_issue = (SELECT core_feed_issue FROM techfit_defaults WHERE id = 1), weight_commodity = (SELECT commodity FROM techfit_defaults WHERE id = 1), weight_fs = (SELECT fs FROM techfit_defaults WHERE id = 1), weight_context_attribute = (SELECT context_attribute FROM techfit_defaults WHERE id = 1), weight_impact = (SELECT impact FROM techfit_defaults WHERE id = 1) WHERE weight_impact IS NULL');
     SQLExecute('UPDATE techfit_assessment SET title = (SELECT meeting_date_time FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) || '' '' || (SELECT community FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) || '' '' || (SELECT venue_name FROM focus_group fg WHERE techfit_assessment.id_focus_group = fg.id) WHERE techfit_assessment.title IS NULL');

     ShowMessage('Data import from file complete.')

     end;
     OpenDialog.Free;
except
    ShowMessage(ExceptionMessage);
end;
end;                                                                                                                                                                                                                                                                                                                                                                                                                                

procedure settings_import_export_OnShow (Sender: string; Action: string);
begin
try
    settings_import_export.label_status.Visible := FALSE;
except
    ShowMessage(ExceptionMessage);
end;
end;


procedure ExportToCSV (TableName, FileName: string);
var
    Results: TDataSet;
    Results2: TDataSet;
    sFields: string;
    sFieldName, sTableFK: string;
    slExportCVS: TStringList;
    slTypes: TStringList;

    i,c: integer;
    s, sValue: string;
begin
try
    sFields := '';
    slTypes := TStringList.Create;
    slTypes.Add('TEXT'); // for unique_identifier

    // get field names of table
    SQLQuery('PRAGMA table_info(['+TableName+'])', Results);
    while not Results.Eof do
    begin
        sFieldName := Results.FieldByName('name').AsString;
        if (sFieldName <> 'unique_identifier') and (sFieldName <> 'id') then // ignore fields UNIQ and id
        begin
            if Pos('id_', sFieldName)=1 then // FK
            begin
                // extract table name from foreign key
                sTableFK := sFieldName;
                Delete(sTableFK, 1, 3); // delete 'id_'
                if sTableFK[Length(sTableFK)] in ['0'..'9'] then SetLength(sTableFK, Length(sTableFK)-1); // delete latest char is number

                sFields := sFields + '(SELECT unique_identifier FROM ['+sTableFK+'] WHERE ['+sTableFK+'].id=['+TableName+'].['+sFieldName+']) AS ['+sFieldName+'],';

            end else sFields := sFields + '['+Results.FieldByName('name').AsString + '],';

            slTypes.Add(Results.FieldByName('type').AsString);
        end;
        Results.Next;
    end;
    Results.Free;
    if Length(sFields) > 0 then SetLength(sFields, Length(sFields)-1);


    // export data
    //ShowMessage('SELECT unique_identifier, '+sFields+' FROM ' + '['+TableName+']');
    SQLQuery ('SELECT unique_identifier, '+sFields+' FROM ' + '['+TableName+']', Results2);
    slExportCVS := TStringList.Create;

    c := Results2.FieldCount;
    while not Results2.Eof do
    begin
        s := '';
        for i := 1 to c do
        begin
            sValue := Results2.Fields.FieldByNumber(i).AsString;
            if slTypes[i-1]='REAL' then sValue := ReplaceStr(sValue,',','.');
            s := s + sValue + field_delimiter;
            //s := s + Results2.Fields.FieldByNumber(i).AsString + field_delimiter;
        end;

        if Length(s) > 0 then SetLength( s, Length(s)-Length(field_delimiter) );
        slExportCVS.Add(s);
        Results2.Next;
    end;
    Results2.Free;
    slExportCVS.SaveToFile(FileName);
    slExportCVS.Free;
    slTypes.Free;
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure ImportFromCSV (TableName, FileName: string);
var
    arrStr: array of string;
    i,c: integer;
    slCSV: TStringList;
    sFieldName, sTableFK: string;

    Results: TDataSet;
    slFields: TStringList;
    slTypes: TStringList;
    sFields, sValues, sUpdate, s: string;
    k,q: integer;

    updated_at_DB, updated_at_CSV: TDateTime;
    sDate1, sDate2: string;
    idx: integer;
begin
try
    if not FileExists (FileName) then
    begin
        ShowMessage('Files for import not found.');
        Exit;
    end;

    settings_import_export.label_status.Visible := TRUE;

    slFields := TStringList.Create;
    slTypes  := TStringList.Create;
    slFields.Add( 'unique_identifier' ); // for unique_identifier
    slTypes.Add ( 'TEXT' );

    // get field names and types of table
    SQLQuery('PRAGMA table_info(['+TableName+'])', Results);
    while not Results.Eof do
    begin
        sFieldName := Results.FieldByName('name').AsString;
        if (sFieldName <> 'unique_identifier') and (sFieldName <> 'id') then // ignore fields UNIQ and id
        begin
            if Pos('id_', sFieldName)=1 then // FK
            begin
                // extract table name from foreign key
                sTableFK := sFieldName;
                Delete(sTableFK, 1, 3); // delete 'id_'
                if sTableFK[Length(sTableFK)] in ['0'..'9'] then SetLength(sTableFK, Length(sTableFK)-1); // delete latest char is number

                slFields.Add(sFieldName);
                slTypes.Add ( '(SELECT id FROM ['+sTableFK+'] WHERE ['+sTableFK+'].unique_identifier LIKE ' );
            end else
            begin
                slFields.Add( sFieldName );
                slTypes.Add ( Results.FieldByName('type').AsString );
            end;

        end;
        Results.Next;
    end;
    Results.Free;



    slCSV := TStringList.Create;
    slCSV.LoadFromFile (FileName);

//    ShowMessage( FileName);
//    ShowMessage (slCSV.Count);

    if (slCSV.Count = 0) then
    begin
      slCSV.LoadFromFileAnsi(FileName);
    end;
//    ShowMessage (slCSV.Count);

    if (slCSV.Count > 0) then
    begin
        arrStr := SplitString(slCSV[0], field_delimiter);
        begin
            q := slFields.Count - 1;
            c := slCSV.Count - 1;
            for i := 0 to c do // records
            begin
                arrStr := SplitString(slCSV[i], field_delimiter);
                slFields[0] := arrStr[0]; // unique_identifier
                sFields := 'unique_identifier, ';
                sValues := ''''+slFields[0]+''',';
                sUpdate := 'unique_identifier='''+arrStr[0]+''',';
                for k := 1 to q do // fields
                begin
                    if (k < Length(arrStr)) then
                    begin
                    s := arrStr[k];

                    if Pos('id_', slFields[k])=1 then
                    begin
                        sValues := sValues + slTypes[k] + ''''+s+'''),';
                        sUpdate := sUpdate + '['+slFields[k]+']='+slTypes[k] + ''''+s+'''),';
                    end else
                    if (slTypes[k]='TEXT') and (s<>'') then
                    begin
                        sValues := sValues +  ''''+ ReplaceStr(s, '''', '''''') + ''',';
                        sUpdate := sUpdate  + '['+slFields[k]+']='+ ''''+ ReplaceStr(s, '''', '''''') + ''',';
                    end else
                    if s='' then
                    begin
                        sValues := sValues + 'NULL,';
                        sUpdate := sUpdate + '['+slFields[k]+']=NULL,';
                    end else
                    begin
                        sValues := sValues + arrStr[k]+ ',';
                        sUpdate := sUpdate + '['+slFields[k]+']='+arrStr[k]+',';
                    end;

                    sFields := sFields + '['+slFields[k]+'],';
                    end;
                end;
                if Length(sFields) > 0 then SetLength(sFields, Length(sFields)-1);
                if Length(sValues) > 0 then SetLength(sValues, Length(sValues)-1);
                if Length(sUpdate) > 0 then SetLength(sUpdate, Length(sUpdate)-1);


                // Insert or Update
                // Insert or Update
                if SQLExecute('SELECT Count(*) FROM ['+TableName+'] WHERE unique_identifier LIKE ''' + arrStr[0]+'''')='0' then
                begin
                    SQLExecute ('INSERT INTO ['+TableName+'] ('+sFields+') VALUES ('+ sValues +');');
                end else
                begin
                    if Length(arrStr[0]) > 10 then
                    begin
                        // 1- Keep my local copy
                        // 2- Overwrite my local copy
                        if settings_import_export.combo_import_options.dbItemID = 2 then
                            SQLExecute('UPDATE ['+TableName+'] SET '+sUpdate+' WHERE unique_identifier LIKE '''+arrStr[0]+'''');

                        // 3- Keep the most recently updated record
                        if settings_import_export.combo_import_options.dbItemID = 3 then
                        begin
                            sDate1 := '';
                            sDate2 := '';

                            sDate1 := SQLExecute('SELECT updated_at FROM ['+TableName+'] WHERE unique_identifier LIKE ''' + arrStr[0]+'''');
                            idx := slFields.IndexOf('updated_at');
                            if idx<>-1 then sDate2 := arrStr[idx];
                            if (Length(sDate1)=23) and (Length(sDate2)=23) then
                            begin
                                updated_at_DB := SQLDateTimeToDateTime (sDate1);
                                updated_at_CSV := SQLDateTimeToDateTime (sDate2);
                                if updated_at_CSV > updated_at_DB then
                                    SQLExecute('UPDATE ['+TableName+'] SET '+sUpdate+' WHERE unique_identifier LIKE '''+arrStr[0]+'''');
                            end;
                        end;

                    end;
                end;
                settings_import_export.label_status.Caption := TableName+': '+IntToStr(i) +' of '+ IntToStr(slCSV.Count);
                Application.ProcessMessages;

            end;
        end;
    end;

    slCSV.Free;
    slFields.Free;
    slTypes.Free;

    settings_import_export.label_status.Caption := 'Import Complete';

except
    ShowMessage(ExceptionMessage);
end;
end;

procedure restore_database_backup (Sender: string; var Cancel: boolean);
var
    dialog_response: integer;
begin
try
    dialog_response := MessageDlg('This will restore your database to before the last data import.  ALL imported data and other changes made since then will be lost.  Continue?', mtInformation, mbYes+mbCancel, 0);
          if dialog_response = mrYes then
          begin
          CopyFile('sqlite.bak', 'sqlite.db', false);
          end else
          if dialog_response = mrCancel then
          begin
          Cancel := True;
          end;
except
    ShowMessage(ExceptionMessage);
end;
end;


// *** COPY RESPONDENTS AND RELATED RECORDS TO NEW FOCUS GROUP ***
procedure reassign_b_Copy_respondents_OnClick (Sender: string; var Cancel: boolean);
begin
try
    CopyRespondents(reassign.combo_focusgroup.dbItemID, reassign.cbToFocusGroup.dbItemID);
except
    ShowMessage(ExceptionMessage);
end;
end;

procedure CopyRespondents (idFocusGroupFrom, idFocusGroupTo: integer);
var
    Res_respondent: TDataSet;
    Res_livestock_holding: TDataSet;
    Res_crop_cultivation: TDataSet;
    Res_respondent_monthly_statistics: TDataSet;
    Res_income_activity: TDataSet;
    Res_womens_income_activity: TDataSet;
    Res_livestock_sale: TDataSet;
    Res_feed_source_availability: TDataSet;
    Res_fodder_crop_cultivation: TDataSet;
    Res_purchased_feed: TDataSet;
    Res_feed_labor_division: TDataSet;
    Res_coop_membership: TDataSet;
    Res_decision_making_by_household: TDataSet;

    i_respondent: integer;
    i_livestock_holding: integer;
    i_crop_cultivation: integer;
    i_respondent_monthly_statistics: integer;
    i_income_activity: integer;
    i_womens_income_activity: integer;
    i_livestock_sale: integer;
    i_feed_source_availability: integer;
    i_fodder_crop_cultivation: integer;
    i_purchased_feed: integer;
    i_feed_labor_division: integer;
    i_coop_membership: integer;
    i_decision_making_by_household: integer;

    i_last_insert: integer;

    s_unique_identifier: string;
    id_Old_respondent: string;
    id_New_respondent: string;
begin
try
    i_respondent := 0;
    i_livestock_holding := 0;
    i_crop_cultivation := 0;
    i_respondent_monthly_statistics := 0;
    i_income_activity := 0;
    i_womens_income_activity := 0;
    i_livestock_sale := 0;
    i_feed_source_availability := 0;
    i_fodder_crop_cultivation := 0;
    i_purchased_feed := 0;
    i_feed_labor_division := 0;
    i_coop_membership := 0;
    i_decision_making_by_household := 0;


    // respondents
    SQLQuery('SELECT * FROM respondent WHERE id_focus_group='+IntToStr(idFocusGroupFrom), Res_respondent);
    while not Res_respondent.Eof do
    begin
        id_Old_respondent := Res_respondent.FieldByName('id').AsString;
        s_unique_identifier := 'rpdt_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_respondent)));
        Inc(i_respondent);
        SQLExecute ('INSERT INTO respondent (unique_identifier, id_focus_group,interview_date,name,age,id_gender,head_of_household_is_respondent,head_of_household_name,head_of_household_age,id_gender1,community,id_community_type,sub_region,minor_region,major_region,id_country,gps_latitude,gps_longitude,id_landholding_category,land_under_cultivation,head_of_household_occupation,diet_percent_collected_fodder,diet_percent_grazing,diet_percent_cultivated_fodder,diet_percent_purchased_feed,diet_percent_crop_residue,organization_affiliation,id_unit_area,validate_no_crops,validate_no_livestock_holdings,validate_no_cultivated_fodder,validate_no_purchased_feed,validate_no_livestock_sales,validate_no_market_prices,validate_no_milk_yield,created_at,updated_at,created_by,updated_by, diet_percent_cultivated_fodder, diet_percent_purchased_feed, diet_percent_crop_residue, validate_no_coop, female_managed, land_ownership_female, land_ownership_male, land_ownership_joint, land_under_control) '+
                    'SELECT '''+s_unique_identifier+''', '+IntToStr(idFocusGroupTo)+',interview_date,name,age,id_gender,head_of_household_is_respondent,head_of_household_name,head_of_household_age,id_gender1,community,id_community_type,sub_region,minor_region,major_region,id_country,gps_latitude,gps_longitude,id_landholding_category,land_under_cultivation,head_of_household_occupation,diet_percent_collected_fodder,diet_percent_grazing,diet_percent_cultivated_fodder,diet_percent_purchased_feed,diet_percent_crop_residue,organization_affiliation,id_unit_area,validate_no_crops,validate_no_livestock_holdings,validate_no_cultivated_fodder,validate_no_purchased_feed,validate_no_livestock_sales,validate_no_market_prices,validate_no_milk_yield,created_at,updated_at,created_by,updated_by, diet_percent_cultivated_fodder, diet_percent_purchased_feed, diet_percent_crop_residue FROM respondent, validate_no_coop, female_managed, land_ownership_female, land_ownership_male, land_ownership_joint, land_under_control WHERE id='+id_Old_respondent );
        i_last_insert := Last_Insert_id;
        id_New_respondent := IntToStr(i_last_insert);


        // livestock_holding
        SQLQuery('SELECT * FROM livestock_holding WHERE id_respondent='+id_Old_respondent, Res_livestock_holding);
        while not Res_livestock_holding.Eof do
        begin
            s_unique_identifier := 'lshd_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_livestock_holding)));
            Inc(i_livestock_holding);
            SQLExecute ('INSERT INTO livestock_holding (unique_identifier, id_respondent,id_animal_type,average_weight,headcount,dominant_breed,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_animal_type,average_weight,headcount,dominant_breed,created_at,updated_at,created_by,updated_by FROM livestock_holding WHERE id='+Res_livestock_holding.FieldByName('id').AsString );
            Res_livestock_holding.Next;
        end;



       // crop_cultivation
        SQLQuery('SELECT * FROM crop_cultivation WHERE id_respondent='+id_Old_respondent, Res_crop_cultivation);
        while not Res_crop_cultivation.Eof do
        begin
            s_unique_identifier := 'crop_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_crop_cultivation)));
            Inc(i_crop_cultivation);
            SQLExecute ('INSERT INTO crop_cultivation (unique_identifier, id_respondent,id_crop_type,cultivated_land,id_unit_area,annual_yield,id_unit_mass_weight,percent_fed,percent_burned,percent_mulched,percent_sold,percent_other,created_by,updated_by,created_at,updated_at) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_crop_type,cultivated_land,id_unit_area,annual_yield,id_unit_mass_weight,percent_fed,percent_burned,percent_mulched,percent_sold,percent_other,created_by,updated_by,created_at,updated_at FROM crop_cultivation WHERE id='+Res_crop_cultivation.FieldByName('id').AsString );
            Res_crop_cultivation.Next;
        end;



        // income_activity
        SQLQuery('SELECT * FROM income_activity WHERE id_respondent='+id_Old_respondent, Res_income_activity);
        while not Res_income_activity.Eof do
        begin
            s_unique_identifier := 'icsr_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_income_activity)));
            Inc(i_income_activity);
            SQLExecute ('INSERT INTO income_activity (unique_identifier, id_respondent,id_income_activity_type,percent_of_hh_income,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_income_activity_type,percent_of_hh_income,created_at,updated_at,created_by,updated_by FROM income_activity WHERE id='+Res_income_activity.FieldByName('id').AsString );
            Res_income_activity.Next;
        end;
        
        // women's income_activity
        SQLQuery('SELECT * FROM womens_income_activity WHERE id_respondent='+id_Old_respondent, Res_womens_income_activity);
        while not Res_income_activity.Eof do
        begin
            s_unique_identifier := 'wicsr_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_womens_income_activity)));
            Inc(i_womens_income_activity);
            SQLExecute ('INSERT INTO womens_income_activity (unique_identifier, id_respondent,id_income_activity_type,pct_womens_income,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_income_activity_type,pct_womens_income,created_at,updated_at,created_by,updated_by FROM womens_income_activity WHERE id='+Res_womens_income_activity.FieldByName('id').AsString );
            Res_income_activity.Next;
        end;



        // fodder_crop_cultivation
        SQLQuery('SELECT * FROM fodder_crop_cultivation WHERE id_respondent='+id_Old_respondent, Res_fodder_crop_cultivation);
        while not Res_fodder_crop_cultivation.Eof do
        begin
            s_unique_identifier := 'fdcp_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_fodder_crop_cultivation)));
            Inc(i_fodder_crop_cultivation);
            SQLExecute ('INSERT INTO fodder_crop_cultivation (unique_identifier, id_respondent,id_fodder_crop_type,cultivated_land,id_unit_area,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_fodder_crop_type,cultivated_land,id_unit_area,created_at,updated_at,created_by,updated_by FROM fodder_crop_cultivation WHERE id='+Res_fodder_crop_cultivation.FieldByName('id').AsString );
            Res_fodder_crop_cultivation.Next;
        end;



        // purchased_feed
        SQLQuery('SELECT * FROM purchased_feed WHERE id_respondent='+id_Old_respondent, Res_purchased_feed);
        while not Res_purchased_feed.Eof do
        begin
            s_unique_identifier := 'prch_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_purchased_feed)));
            Inc(i_purchased_feed);
            SQLExecute ('INSERT INTO purchased_feed (unique_identifier, id_respondent,id_purchased_feed_type,quantity_purchased,id_unit_mass_weight,unit_price,purchases_per_year,id_currency,created_by,updated_by,created_at,updated_at) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_purchased_feed_type,quantity_purchased,id_unit_mass_weight,unit_price,purchases_per_year,id_currency,created_by,updated_by,created_at,updated_at FROM purchased_feed WHERE id='+Res_purchased_feed.FieldByName('id').AsString );
            Res_purchased_feed.Next;
        end;




        // respondent_monthly_statistics
        SQLQuery('SELECT * FROM respondent_monthly_statistics WHERE id_respondent='+id_Old_respondent, Res_respondent_monthly_statistics);
        while not Res_respondent_monthly_statistics.Eof do
        begin
            s_unique_identifier := 'rems_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_respondent_monthly_statistics)));
            Inc(i_respondent_monthly_statistics);
            SQLExecute ('INSERT INTO respondent_monthly_statistics (unique_identifier, id_respondent,id_month,milk_average_yield,milk_average_price_litre,milk_retained_for_household,market_price_cattle,market_price_sheep,market_price_goat,id_scale_zero_ten,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_month,milk_average_yield,milk_average_price_litre,milk_retained_for_household,market_price_cattle,market_price_sheep,market_price_goat,id_scale_zero_ten,created_at,updated_at,created_by,updated_by FROM respondent_monthly_statistics WHERE id='+Res_respondent_monthly_statistics.FieldByName('id').AsString );
            Res_respondent_monthly_statistics.Next;
        end;





        // livestock_sale
        SQLQuery('SELECT * FROM livestock_sale WHERE id_respondent='+id_Old_respondent, Res_livestock_sale);
        while not Res_livestock_sale.Eof do
        begin
            s_unique_identifier := 'lssa_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_livestock_sale)));
            Inc(i_livestock_sale);
            SQLExecute ('INSERT INTO livestock_sale (unique_identifier, id_respondent,id_livestock_sale_category,number_sold,approximate_weight,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_livestock_sale_category,number_sold,approximate_weight,created_at,updated_at,created_by,updated_by FROM livestock_sale WHERE id='+Res_livestock_sale.FieldByName('id').AsString );
            Res_livestock_sale.Next;
        end;




        // feed_source_availability
        SQLQuery('SELECT * FROM feed_source_availability WHERE id_respondent='+id_Old_respondent, Res_feed_source_availability);
        while not Res_feed_source_availability.Eof do
        begin
            s_unique_identifier := 'fsav_'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_feed_source_availability)));
            Inc(i_feed_source_availability);
            SQLExecute ('INSERT INTO feed_source_availability (unique_identifier, id_respondent,id_feed_source,id_month,percentage,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_feed_source,id_month,percentage,created_at,updated_at,created_by,updated_by FROM feed_source_availability WHERE id='+Res_feed_source_availability.FieldByName('id').AsString );
            Res_feed_source_availability.Next;
        end;
        
// Copy gendered fields (if any)        
        // Labor division
        SQLQuery('SELECT * FROM feed_labor_division WHERE id_respondent='+id_Old_respondent, Res_feed_labor_division);
        while not Res_feed_labor_division.Eof do
        begin
            s_unique_identifier := 'fld'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_feed_labor_division)));
            Inc(i_feed_labor_division);
            SQLExecute ('INSERT INTO feed_labor_division (unique_identifier,id_respondent,id_feed_labor_type,id_labor_division_group,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_feed_labor_type,id_labor_division_group,created_at,updated_at,created_by,updated_by FROM feed_labor_division WHERE id='+Res_feed_labor_division.FieldByName('id').AsString );
            Res_feed_labor_division.Next;
        end;
        
        // Coop membership
        SQLQuery('SELECT * FROM coop_membership WHERE id_respondent='+id_Old_respondent, Res_coop_membership);
        while not Res_coop_membership.Eof do
        begin
            s_unique_identifier := 'fld'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_coop_membership)));
            Inc(i_coop_membership);
            SQLExecute ('INSERT INTO coop_membership (unique_identifier,id_respondent,name_free_entry,membership_count_male,membership_count_female,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',name_free_entry,membership_count_male,membership_count_female,created_at,updated_at,created_by,updated_by FROM coop_membership WHERE id='+Res_coop_membership.FieldByName('id').AsString );
            Res_coop_membership.Next;
        end;
        
        // Decision making
        SQLQuery('SELECT * FROM decision_making_by_household WHERE id_respondent='+id_Old_respondent, Res_decision_making_by_household);
        while not Res_decision_making_by_household.Eof do
        begin
            s_unique_identifier := 'fld'+registration_concatenated_id+'_'+FloatToStr(Now)+'_'+FormatFloat('0##', StrToFloat(IntToStr(i_decision_making_by_household)));
            Inc(i_decision_making_by_household);
            SQLExecute ('INSERT INTO decision_making_by_household (unique_identifier,id_respondent,id_decision,id_gender_group,created_at,updated_at,created_by,updated_by) '+
                        'SELECT '''+s_unique_identifier+''', '+id_New_respondent+',id_decision,id_gender_group,created_at,updated_at,created_by,updated_by FROM decision_making_by_household WHERE id='+Res_decision_making_by_household.FieldByName('id').AsString );
            Res_decision_making_by_household.Next;
        end;

        Res_respondent.Next;
    end;

    Res_livestock_holding.Free;
    Res_crop_cultivation.Free;
    Res_income_activity.Free;
    Res_womens_income_activity.Free;
    Res_fodder_crop_cultivation.Free;
    Res_purchased_feed.Free;
    Res_respondent_monthly_statistics.Free;
    Res_livestock_sale.Free;
    Res_feed_source_availability.Free;
    
    Res_feed_labor_division.Free;
    Res_coop_membership.Free;
    Res_decision_making_by_household.Free;

    Res_respondent.Free;

    ShowMessage('Copy operation complete');
    reassign.Close;

except
    ShowMessage(ExceptionMessage);
end;
end;


procedure advanced_button (Sender: string; var Cancel: boolean);
begin
try
    If InputBox('Caption', 'Enter password', '')<>'reassign' then Cancel := True;
except
    ShowMessage(ExceptionMessage);
end;
end;

begin
end.
